﻿----------------------------------------------------------------------------------------------------
-- ChatBox Slash Commands
----------------------------------------------------------------------------------------------------
function ChatBox_Split(text, separator)
	local value;
	local mstart, mend = 1;
	local oldn, numMatches = 0, 0;
	local regexKey = "([^"..separator.."]+)";
	local sfind = strfind;	-- string.find if not in WoW (n calls)
	local t = {};
	
	-- Using string.find instead of string.gfind to avoid garbage generation
	mstart, mend, value = sfind(text, regexKey, mstart);
	
	while (value) do
		numMatches = numMatches + 1;
		t[numMatches] = value
		mstart = mend + 1;	
		mstart, mend, value = sfind(text, regexKey, mstart);
   	end
	
--	table.setn(t, numMatches);
	
	return t;
end

function ChatBox_AddText(n, text)
	if ( n == ChatBox.Channel ) then
		list_name = "생략 채널명";
	elseif ( n == ChatBox.WhoSayList ) then
		list_name = "누가말하나~";
	elseif ( n == ChatBox.WhatWantsList ) then
		list_name = "무엇을찾으세요?";
	else
		list_name = "나를불러주세요"
	end
	local exist = false;
	if not text then return; end
	if text=="" then return; end
	if not n then n = {}; end
	for i=1,getn(n),1 do
		if( n[i] == text )then
			exist = true;
		end
	end
	if( exist == false )then
		table.insert(n,text);
		cb_display(text.. "을 "..list_name.." 목록에 추가합니다.");
	end
end

function ChatBox_RemoveText(n, t)
	if ( n == ChatBox.Channel ) then
		list_name = "생략 채널명";
	elseif ( n == ChatBox.WhatWantsList ) then
		list_name = "무엇을찾으세요?";
	elseif ( n == ChatBox.WhoSayList ) then
		list_name = "누가말하나~";
	else
		list_name = "나를불러주세요"
	end

	local _type = "string";
	local rn = 0;
	if( type(t) == "number" )then
		_type = "number";
		rn = t;
	end
	if( _type == "string" )then
		for i=1,table.getn(n),1 do
			if( n[i] == t )then
				rn = i;
			end
		end
	end
	table.remove(n,rn);
	if ( _type == "string") then
		cb_display(t.. " 을 "..list_name.." 목록에서 삭제합니다.");
	else
		cb_display(list_name.." 목록의 "..t.. "번 항목을 목록에서 삭제합니다.");
	end
end


function ChatBox_Commands(msg)
	if msg == nil then msg = "" end

--	msg = string.lower(msg)

	cmd = ChatBox_Split(msg, "%s");
	table.insert(cmd, "");

	-- No parameter or not one listed from above
	if msg == "" or msg == "?" or msg == string.lower(CB_OPTIONS) or msg == string.lower(CB_HELP) then

		cb_display("\n");
		cb_display(YEL..CB_HELPTITLE.."   /ts나 /plm을 입력하면 다른 설정을 할 수 있습니다.".."\n")
		cb_display(YEL .. CB_SHORTCUTS);
		cb_display(WHT .. CB_STICKY .. " : " .. RED .. ChatBox_check(ChatBox.setSticky) ..GRN.. CB_STICKY_HELP_TEXT)
		cb_display(WHT .. CB_HIDEBOTTOMBUTTON .. " : " .. RED .. ChatBox_check(ChatBox.hideBottomButton) ..GRN..CB_HIDEBOTTOMBUTTON_HELP_TEXT)
		cb_display(WHT .. CB_EDITATTOP .. " : " .. RED .. ChatBox_check(ChatBox.editAtTop) ..GRN..CB_EDITATTOP_HELP_TEXT)
		cb_display(WHT .. CB_HIDEEMOTEBUTTON .. " : " .. RED .. ChatBox_check(ChatBox.hideEmoteButton) ..GRN..CB_HIDEEMOTEBUTTON_HELP_TEXT)
		cb_display(WHT .. CB_MENUSIDE .. " : " .. RED .. ChatBox_check(ChatBox.menuOnLeft) ..GRN..CB_MENUSIDE_HELP_TEXT)
		cb_display(WHT .. CB_COLORNAMES .. " : " .. RED .. ChatBox_check(ChatBox.colorNames) ..GRN..CB_COLORNAMES_HELP_TEXT)
		cb_display(WHT .. CB_LONGSTRINGS .. " : " .. RED .. ChatBox_check(ChatBox.longStrings) ..GRN..CB_LONGSTRINGS_HELP_TEXT)
		cb_display(WHT .. CB_CLINK .. " : " .. RED .. ChatBox_check(ChatBox.CLINK) ..GRN..CB_CLINK_HELP_TEXT)
		cb_display(WHT .. CB_RAID .. " : " .. RED .. ChatBox_check(ChatBox.Raid) ..GRN..CB_RAID_HELP_TEXT)
		cb_display(WHT .. CB_DRUNK .. " : " .. RED .. ChatBox_check(ChatBox.DrunkSpam) ..GRN..CB_DRUNK_HELP_TEXT)
		cb_display(WHT .. CB_DUEL .. " : " .. RED .. ChatBox_check(ChatBox.DuelSpam) ..GRN..CB_DUEL_HELP_TEXT)
		cb_display(WHT .. CB_CHANUMBER .. " : " .. RED .. ChatBox_check(ChatBox.ChaNumber) ..GRN..CB_CHANUMBER_HELP_TEXT)
		cb_display(WHT .. CB_CALLME .. " : " .. RED .. ChatBox_check(ChatBox.Call) ..GRN..CB_CALLME_HELP_TEXT)
		cb_display(WHT .. CB_WHOSAY .. " : " .. RED .. ChatBox_check(ChatBox.WhoSay) ..GRN..CB_WHOSAY_HELP_TEXT)
		cb_display(WHT .. CB_WHATWANTS .. " : " .. RED .. ChatBox_check(ChatBox.WhatWants) ..GRN..CB_WHATWANTS_HELP_TEXT)
		cb_display(WHT .. CB_CHATHEAD .. " : " .. RED .. ChatBox_check(ChatBox.ChatHead) ..GRN..CB_CHATHEAD_HELP_TEXT)
		cb_display(WHT .. CB_CHATTAIL .. " : " .. RED .. ChatBox_check(ChatBox.ChatTail) ..GRN..CB_CHATTAIL_HELP_TEXT)
		cb_display(WHT .. CB_AUTOSELECT .. " : " .. GRN..CB_AUTOSELECT_HELP_TEXT)
		cb_display(WHT .. CB_RWARNING .. " : " .. GRN..CB_RWARNING_HELP_TEXT)
		cb_display(WHT .. CB_LOGHIGHLIGHT .. " : " .. GRN..CB_LOGHIGHLIGHT_HELP_TEXT)

	--to change the sticky
	elseif ( string.find(msg, string.lower(CB_STICKY_SHORT))) then
		if ChatBox.setSticky then
   			cb_display(WHT..CB_STICKY_TEXT..RED..CB_OFF);
			ChatBox.setSticky = false;
		else
			cb_display(WHT..CB_STICKY_TEXT..RED..CB_ON);
			ChatBox.setSticky = true;
		end
		ChatBox_SetSticky();


	--to change the scroll to bottom button display
	elseif ( string.find(msg, string.lower(CB_HIDEBOTTOMBUTTON_SHORT))) then
		if ChatBox.hideBottomButton then
   			cb_display(WHT..CB_HIDEBOTTOMBUTTON_TEXT..RED..CB_ON);
			ChatBox.hideBottomButton = false;
		else
			cb_display(WHT..CB_HIDEBOTTOMBUTTON_TEXT..RED..CB_OFF);
			ChatBox.hideBottomButton = true;
		end


	--to change the emote/language button display
	elseif ( string.find(msg, string.lower(CB_HIDEEMOTEBUTTON_SHORT))) then
		if ChatBox.hideEmoteButton then
   			cb_display(WHT..CB_HIDEEMOTEBUTTON_TEXT..RED..CB_ON);
			ChatFrameMenuButton:Show();
			ChatBox.hideEmoteButton = false;
		else
   			cb_display(WHT..CB_HIDEEMOTEBUTTON_TEXT..RED..CB_OFF);
			ChatFrameMenuButton:Hide();
			ChatBox.hideEmoteButton = true;
		end

	--to change the useArrows behavior
	elseif ( string.find(msg, string.lower(CB_USEARROWS_SHORT))) then
		if ChatBox.useArrows then
			cb_display(WHT..CB_USEARROWS_TEXT.. RED .. CB_OFF);
			ChatFrameEditBox:SetAltArrowKeyMode(true);
			ChatBox.useArrows = false;
		else
			cb_display(WHT..CB_USEARROWS_TEXT .. RED .. CB_ON);
			ChatFrameEditBox:SetAltArrowKeyMode(false);
			ChatBox.useArrows = true;
		end

	--to change the editAtTop display
	elseif ( string.find(msg, string.lower(CB_EDITATTOP_SHORT)) ) then
		if (cmd[2] == "damjau" ) then
			ChatFrameEditBox:ClearAllPoints();
			ChatFrameEditBox:SetPoint("BOTTOMLEFT", "UIParent", "BOTTOM", -246, 330);
			ChatFrameEditBox:SetPoint("BOTTOMRIGHT", "UIParent", "BOTTOM", 246, 330);
			ChatBox.editAtTop = 1;

		elseif ChatBox.editAtTop then
   			cb_display(WHT..CB_EDITATTOP_TEXTA..RED..CB_BOTTOM..WHT..CB_EDITATTOP_TEXTB);
			ChatFrameEditBox:ClearAllPoints();
			ChatFrameEditBox:SetPoint("TOPLEFT", "ChatFrame1", "BOTTOMLEFT", 0, 2);
			ChatFrameEditBox:SetPoint("TOPRIGHT", "ChatFrame1", "BOTTOMRIGHT", 0, 2);
			ChatBox.editAtTop = false;
		else
   			cb_display(WHT..CB_EDITATTOP_TEXTA..RED..CB_TOP..WHT..CB_EDITATTOP_TEXTB);
			ChatFrameEditBox:ClearAllPoints();
			ChatFrameEditBox:SetPoint("BOTTOMLEFT", "ChatFrame1", "TOPLEFT", 0, 2);
			ChatFrameEditBox:SetPoint("BOTTOMRIGHT", "ChatFrame1", "TOPRIGHT", 0, 2);
			ChatBox.editAtTop = true;
		end



	--to change which side the buttons are on.
	elseif ( string.find(msg, string.lower(CB_MENUSIDE_SHORT)) ) then
		if ChatBox.menuOnLeft then
   			cb_display(WHT..CB_MENUSIDE_TEXT.. RED .. CB_OFF);
			ChatBox.menuOnLeft = false;
		else
   			cb_display(WHT..CB_MENUSIDE_TEXT .. RED .. CB_ON);
			ChatBox.menuOnLeft = true;
		end
		ChatBox_Relocate_Buttons()

	--to change the color of names in chat behavior
	elseif ( string.find(cmd[1], string.lower(CB_COLORNAMES_SHORT))) then
		if (cmd[2] == "유지" ) then
			ChatBox.colorNames_continue = true;
		elseif (cmd[2] == "갱신") then
			ChatBox.colorNames_continue = false;
		else
			if ChatBox.colorNames then
				cb_display(WHT..CB_COLORNAMES_TEXT.. RED .. CB_OFF);
				ChatBox.colorNames = false;
			else
				cb_display(WHT..CB_COLORNAMES_TEXT .. RED .. CB_ON);
				ChatBox.colorNames = true;
			end
			ChatBox_SetStrings();
		end

	--to change showing [Party] [Guild] [Raid] in chat.
	elseif ( string.find(cmd[1], string.lower(CB_LONGSTRINGS_SHORT))) then
		if ( cmd[2] == "일반" or cmd[2] == "일반형" or tonumber(cmd[2]) == 1) then
			ChatBox.longStrings = 1;
			cb_display(WHT..CB_LONGSTRINGS_TEXT.. RED .. "일반형");      
		elseif ( cmd[2] == "짧게" or cmd[2] == "축약형" or tonumber(cmd[2]) == 2 ) then
			ChatBox.longStrings = 2;
			cb_display(WHT..CB_LONGSTRINGS_TEXT.. RED .. "축약형");      
		elseif ( cmd[2] == "아주짧게" or cmd[2] == "생략형" or tonumber(cmd[2]) == 3) then
			ChatBox.longStrings = 3;
			cb_display(WHT..CB_LONGSTRINGS_TEXT.. RED .. "생략형");      
		elseif ( tonumber(cmd[2]) == 4) then
			ChatBox.longStrings = 4;
			cb_display(WHT..CB_LONGSTRINGS_TEXT.. RED .. "한글축약형");      
		end
		ChatBox_SetStrings();

	--to change if you want to use the CLINK tag
	elseif ( string.find(msg, string.lower(CB_CLINK_SHORT))) then
		if ChatBox.CLINK then
   			cb_display(WHT..CB_CLINK_TEXT..RED..CB_OFF);
			ChatBox.CLINK = false;
		else
   			cb_display(WHT..CB_CLINK_TEXT..RED..CB_ON);
			ChatBox.CLINK = true;
		end

	-- 채널명 생략 기능
	elseif ( string.find(cmd[1], string.lower(CB_CHANUMBER_SHORT))) then

--[[		if( cmd[2] == "추가" )then
			if(cmd[3])then
				ChatBox_AddText(ChatBox.Channel, cmd[3]);
			end
		elseif( cmd[2] == "제거" or cmd[2] == "삭제")then
			if ( tonumber(cmd[3]) ) then
					ChatBox_RemoveText(ChatBox.Channel, tonumber(cmd[3]));
			else
				ChatBox_RemoveText(ChatBox.Channel, cmd[3]);
			end

		elseif( cmd[2] == "보기" or cmd[2] == "목록" )then
			cb_display("-----------------");
			if( table.getn(ChatBox.Channel) > 0 )then
				for i=1,table.getn(ChatBox.Channel) do
					cb_display(i..". "..ChatBox.Channel[i]);
				end
			else
				cb_display("    없습니다^^");
			end
			cb_display("-----------------");
			return;
		elseif (cmd[2] == "기본값") then
			for i=1,table.getn(ChatBox.Channel),1 do
				table.remove(ChatBox.Channel,1);
			end
			cb_display("생략할 채널명 목록을 기본값으로 되돌립니다.");
			ChatBox_AddText(ChatBox.Channel, "공개");
			ChatBox_AddText(ChatBox.Channel, "거래");
			ChatBox_AddText(ChatBox.Channel, "파티찾기");
			ChatBox_AddText(ChatBox.Channel, "수비");
		else]]
			if ChatBox.ChaNumber then
				cb_display(WHT..CB_CHANUMBER_TEXT..RED..CB_OFF);
				ChatBox.ChaNumber = nil;
			else
				cb_display(WHT..CB_CHANUMBER_TEXT..RED..CB_ON);
				ChatBox.ChaNumber = true;
			end
			return;
--		end

	-- CallMe
	elseif ( string.find(cmd[1], string.lower(CB_CALLME_SHORT))) then

		if( cmd[2] == "추가" )then
			if(cmd[3])then
				text = string.gsub(msg, cmd[1].." "..cmd[2].." ", "")
				ChatBox_AddText(ChatBox.CallMe, text);
			end
		elseif( cmd[2] == "제거" or cmd[2] == "삭제" )then
			if(cmd[3])then
				if ( tonumber(cmd[3]) ) then
					ChatBox_RemoveText(ChatBox.CallMe, tonumber(cmd[3]));
				else
					text = string.gsub(msg, cmd[1].." "..cmd[2].." ", "")
					ChatBox_RemoveText(ChatBox.CallMe, text);
				end
			end

		elseif (cmd[2] == "색상" ) then
			ChatBox_CallMe_ColorPicker();
		elseif( cmd[2] == "보기" or cmd[2] == "목록" )then
			cb_display("-----------------");
			if( table.getn(ChatBox.CallMe) > 0 )then
				for i=1,table.getn(ChatBox.CallMe) do
					cb_display(i..". "..ChatBox.CallMe[i]);
				end
			else
				cb_display("    없습니다^^");
			end
			cb_display("-----------------");
			return;
		else
			if ChatBox.Call then
				cb_display(WHT..CB_CALLME_TEXT..RED..CB_OFF);
				ChatBox.Call = nil;
			else
				cb_display(WHT..CB_CALLME_TEXT..RED..CB_ON);
				ChatBox.Call = true;
				if ( ChatBox.CallMe == nil ) then
					ChatBox.CallMe[1] = UnitName("player")
				end
				if ( not ChatBox.CallMe_Color ) then
					ChatBox.CallMe_Color = false
				end
			end
			return;
		end

	-- WhoSay
	elseif ( string.find(cmd[1], string.lower(CB_WHOSAY_SHORT))) then

		if( cmd[2] == "추가" )then
			if(cmd[3])then
				text = string.gsub(msg, cmd[1].." "..cmd[2].." ", "")
				ChatBox_AddText(ChatBox.WhoSayList, text);
			end
		elseif( cmd[2] == "제거" or cmd[2] == "삭제" )then
			if(cmd[3])then
				if ( tonumber(cmd[3]) ) then
					ChatBox_RemoveText(ChatBox.WhoSayList, tonumber(cmd[3]));
				else
					text = string.gsub(msg, cmd[1].." "..cmd[2].." ", "")
					ChatBox_RemoveText(ChatBox.WhoSayList, text);
				end
			end

		elseif( cmd[2] == "보기" or cmd[2] == "목록" )then
			cb_display("-----------------");
			if( table.getn(ChatBox.WhoSayList) > 0 )then
				for i=1,table.getn(ChatBox.WhoSayList) do
					cb_display(i..". "..ChatBox.WhoSayList[i]);
				end
			else
				cb_display("    없습니다^^");
			end
			cb_display("-----------------");
			return;
		elseif( cmd[2] == "초기화" )then
			for i=1,table.getn(ChatBox.WhoSayList),1 do
				table.remove(ChatBox.WhoSayList,1);
			end
		else
			if ChatBox.WhoSay then
				cb_display(WHT..CB_WHOSAY_TEXT..RED..CB_OFF);
				ChatBox.WhoSay = nil;
			else
				cb_display(WHT..CB_WHOSAY_TEXT..RED..CB_ON);
				ChatBox.WhoSay = true;
				if ( ChatBox.WhoSayList == nil ) then
					ChatBox.WhoSayList[1] = ""
				end
			end
			return;
		end

	-- WhatWants
	elseif ( string.find(cmd[1], string.lower(CB_WHATWANTS_SHORT))) then

		if( cmd[2] == "추가" )then
			if(cmd[3])then
				text = string.gsub(msg, cmd[1].." "..cmd[2].." ", "")
				ChatBox_AddText(ChatBox.WhatWantsList, text);
			end
		elseif( cmd[2] == "제거" or cmd[2] == "삭제" )then
			if(cmd[3])then
				if ( tonumber(cmd[3]) ) then
					ChatBox_RemoveText(ChatBox.WhatWantsList, tonumber(cmd[3]));
				else
					text = string.gsub(msg, cmd[1].." "..cmd[2].." ", "")
					ChatBox_RemoveText(ChatBox.WhatWantsList, text);
				end
			end

		elseif( cmd[2] == "보기" or cmd[2] == "목록" )then
			cb_display("-----------------");
			if( table.getn(ChatBox.WhatWantsList) > 0 )then
				for i=1,table.getn(ChatBox.WhatWantsList) do
					cb_display(i..". "..ChatBox.WhatWantsList[i]);
				end
			else
				cb_display("    없습니다^^");
			end
			cb_display("-----------------");
			return;
		elseif (cmd[2] == "색상" ) then
			ChatBox_WhatWants_ColorPicker();
		elseif( cmd[2] == "초기화" )then
			for i=1,table.getn(ChatBox.WhatWantsList),1 do
				table.remove(ChatBox.WhatWantsList,1);
			end
		else
			if ChatBox.WhatWants then
				cb_display(WHT..CB_WHATWANTS_TEXT..RED..CB_OFF);
				ChatBox.WhatWants = nil;
			else
				cb_display(WHT..CB_WHATWANTS_TEXT..RED..CB_ON);
				ChatBox.WhatWants = true;
				if ( ChatBox.WhatWantsList == nil ) then
					ChatBox.WhatWantsList[1] = ""
				end
			end
			return;
		end

	-- 말머리 기능
	elseif ( string.find(msg, string.lower(CB_CHATHEAD_SHORT))) then
		local text = string.gsub(msg, cmd[1].." "..cmd[2].." ", "")
		if ( ChatBox.ChatHeadList == nil ) then
			ChatBox.ChatHeadList = { }
		end
		if ( text == msg ) then
			text = nil
		end
		if (cmd[2] == "파티") then
			if ( text ) then
				ChatBox.ChatHeadList["PARTY"] = text;
			else
				ChatBox.ChatHeadList["PARTY"] = nil;
			end
		elseif (cmd[2] == "공격대") then
			if ( text ) then
				ChatBox.ChatHeadList["RAID"] = text;
			else
				ChatBox.ChatHeadList["RAID"] = nil;
			end
		elseif (cmd[2] == "길드") then
			if ( text ) then
				ChatBox.ChatHeadList["GUILD"] = text;
			else
				ChatBox.ChatHeadList["GUILD"] = nil;
			end
		elseif ( cmd[2] == "일반대화" or cmd[2] == "대화" ) then
			if ( text ) then
				ChatBox.ChatHeadList["SAY"] = text;
			else
				ChatBox.ChatHeadList["SAY"] = nil;
			end
		elseif ( cmd[2] == "귓속말" or cmd[2] == "귓말" ) then
			if ( text ) then
				ChatBox.ChatHeadList["WHISPER"] = text;
			else
				ChatBox.ChatHeadList["WHISPER"] = nil;
			end
		elseif (cmd[2] == "모두" ) then
			if ( text ) then
				ChatBox.ChatHeadList["ALL"] = text;
			else
				ChatBox.ChatHeadList["ALL"] = nil;
			end
		elseif ( cmd[2] == "초기화" ) then
			ChatBox.ChatHeadList = {}
		elseif (cmd[2] and text and text ~= "") then
			if ( text ) then
				ChatBox.ChatHeadList[cmd[2]] = text;
			else
				ChatBox.ChatHeadList[cmd[2]] = nil;
			end
		else
			if ChatBox.ChatHead then
				cb_display(WHT..CB_CHATHEAD_TEXT..RED..CB_OFF);
				ChatBox.ChatHead = false;
			else
				cb_display(WHT..CB_CHATHEAD_TEXT..RED..CB_ON);
				ChatBox.ChatHead = true;
			end
		end

	-- 말꼬리 기능
	elseif ( string.find(msg, string.lower(CB_CHATTAIL_SHORT))) then
		local text = string.gsub(msg, cmd[1].." "..cmd[2].." ", "")
		if ( ChatBox.ChatTailList == nil ) then
			ChatBox.ChatTailList = { }
		end
		if ( text == msg ) then
			text = nil
		end
		if (cmd[2] == "파티" ) then
			if ( text ) then
				ChatBox.ChatTailList["PARTY"] = text;
			else
				ChatBox.ChatTailList["PARTY"] = nil;
			end
		elseif (cmd[2] == "공격대" ) then
			if ( text ) then
				ChatBox.ChatTailList["RAID"] = text;
			else
				ChatBox.ChatTailList["RAID"] = nil;
			end
		elseif (cmd[2] == "길드" ) then
			if ( text ) then
				ChatBox.ChatTailList["GUILD"] = text;
			else
				ChatBox.ChatTailList["GUILD"] = nil;
			end
		elseif ( cmd[2] == "일반대화" or cmd[2] == "대화" ) then
			if ( text ) then
				ChatBox.ChatTailList["SAY"] = text;
			else
				ChatBox.ChatTailList["SAY"] = nil;
			end
		elseif ( cmd[2] == "귓속말" or cmd[2] == "귓말" ) then
			if ( text ) then
				ChatBox.ChatTailList["WHISPER"] = text;
			else
				ChatBox.ChatTailList["WHISPER"] = nil;
			end
		elseif ( cmd[2] == "모두" ) then
			if ( text ) then
				ChatBox.ChatTailList["ALL"] = text;
			else
				ChatBox.ChatTailList["ALL"] = nil;
			end
		elseif ( cmd[2] == "초기화" ) then
			ChatBox.ChatTailList = {}
		elseif ( cmd[2] ) then
			if ( text ) then
				ChatBox.ChatTailList[cmd[2]] = text;
			else
				ChatBox.ChatTailList[cmd[2]] = nil;
			end
		else
			if ChatBox.ChatTail then
				cb_display(WHT..CB_CHATTAIL_TEXT..RED..CB_OFF);
				ChatBox.ChatTail = false;
			else
				cb_display(WHT..CB_CHATTAIL_TEXT..RED..CB_ON);
				ChatBox.ChatTail = true;
			end
		end

	-- 공격대 대화에 공격대 정보 표시
	elseif ( string.find(msg, string.lower(CB_RAID_SHORT))) then
		if ChatBox.Raid then
			cb_display(WHT..CB_RAID_TEXT..RED..CB_OFF);
			ChatBox.Raid = false;
		else
			cb_display(WHT..CB_RAID_TEXT..RED..CB_ON);
			ChatBox.Raid = true;
		end

	-- 만취 스팸 거르기
	elseif ( string.find(msg, string.lower(CB_DRUNK_SHORT))) then
		if ChatBox.DrunkSpam then
			cb_display(WHT..CB_DRUNK_TEXT..RED..CB_OFF);
			ChatBox.DrunkSpam = false;
		else
			cb_display(WHT..CB_DRUNK_TEXT..RED..CB_ON);
			ChatBox.DrunkSpam = true;
		end

	-- 결투 스팸 거르기
	elseif ( string.find(msg, string.lower(CB_DUEL_SHORT))) then
		if ChatBox.DuelSpam then
			cb_display(WHT..CB_DUEL_TEXT..RED..CB_OFF);
			ChatBox.DuelSpam = false;
		else
			cb_display(WHT..CB_DUEL_TEXT..RED..CB_ON);
			ChatBox.DuelSpam = true;
		end
	-- 접속 메세지 강조
	elseif ( string.find(msg, string.lower(CB_LOGHIGHLIGHT_SHORT))) then
		if ChatBox.LogHighlight then
			cb_display(WHT..CB_LOGHIGHLIGHT_TEXT..RED..CB_OFF);
			ChatBox.LogHighlight = false;
		else
			cb_display(WHT..CB_LOGHIGHLIGHT_TEXT..RED..CB_ON);
			ChatBox.LogHighlight = true;
		end

	-- 공격대 경보
	elseif ( string.find(msg, string.lower(CB_RWARNING_SHORT))) then
		if ( cmd[2] == "위치" ) then
			if (cmd[3] == "가로" or strlower(cmd[3]) == "x" ) then
				ChatBox.RaidWarning.x = tonumber(cmd[4])		
			elseif (cmd[3] == "세로" or strlower(cmd[3]) == "y" ) then
				ChatBox.RaidWarning.y = tonumber(cmd[4])		
			end
			if (ChatBox.RaidWarning.y or ChatBox.RaidWarning.x) then
				RaidWarningFrame:SetPoint("TOP", "UIErrorsFrame", "BOTTOM", ChatBox.RaidWarning.x, ChatBox.RaidWarning.x)
				cb_display(WHT.."공격대 경보의 위치를 가로 "..RED..ChatBox.RaidWarning.x..WHT.." 세로 "..RED..ChatBox.RaidWarning.y.."로 변경합니다.")
			end
		elseif (cmd[2] == "크기" and tonumber(cmd[3])) then
			if ( tonumber(cmd[3]) > 1 and tonumber(cmd[3]) < 3 ) then
				ChatBox.RaidWarning.scale = tonumber(cmd[3])
				RaidWarningFrame:SetScale(tonumber(cmd[3]))
				cb_display(WHT.."공격대 경보의 크기를 "..RED..ChatBox.RaidWarning.scale..WHT.."|1으로;로; 변경합니다.")
			else
			end
		end

	-- 자동선택 기능
	elseif ( string.find(cmd[1], string.lower(CB_AUTOSELECT_SHORT))) then

		local QNumber = tonumber(cmd[2])
		if ( QNumber ) then

			local NName = UnitName('npc')
			local MaxQ = getn({GetGossipOptions()})/2

			if ( QNumber < 0 ) then

				if QuestFrame:IsVisible() then
					ChatBox.Custom[NName] = QNumber
					cb_display(format(CB_AS_COMPLETE,NName))
				else 
					cb_display(WHT..CB_AS_NOQUEST) 
				end

			elseif ( QNumber == 0 ) then

				if (ChatBox.Custom[NName]) then
					ChatBox.Custom[NName] = nil
					cb_display(format(CB_AS_DELETE,NName))
				else 
					cb_display(format(CB_AS_NONE,NName)); 
				end

			elseif ( not NName or MaxQ==0) then 

				cb_display(CB_GOSSIP)

			elseif ( QNumber <= MaxQ) then
			
				ChatBox.Custom[NName] = QNumber
				cb_display(format(CB_AS_SELECT,NName,QNumber))

			else 

				cb_display(format(CB_AS_INVALID,MaxQ)); 

			end

		elseif ( cmd[2] == "목록" ) then
		
			if ( next(ChatBox.Custom) ) then
			
				cb_display(CB_AS_LIST);
				for NName,QNumber in pairs(ChatBox.Custom) do
					cb_display(NName..' = '..QNumber)
				end
			else 

				cb_display(CB_AS_EMPTY); 

			end

		elseif ( cmd[2] == "퀘스트" ) then
			ChatBox.AS.QLevel = not ChatBox.AS.QLevel;
			cb_display(CB_AS_QUEST..(ChatBox.AS.QLevel and CB_ON or CB_OFF))

		elseif ( cmd[2] == "상급자" ) then
			ChatBox.AS.Trainer = not ChatBox.AS.Trainer;
			cb_display(CB_AS_TRAIN..(ChatBox.AS.Trainer and CB_ON or CB_OFF))

		elseif ( cmd[2] == "여관" ) then
			ChatBox.AS.Inn = not ChatBox.AS.Inn;
			cb_display(CB_AS_INN..(ChatBox.AS.Inn and CB_ON or CB_OFF))

		elseif ( cmd[2] == "대화" ) then
			ChatBox.AS.Token = not ChatBox.AS.Token;
			cb_display(CB_AS_TOKEN..(ChatBox.AS.Token and CB_ON or CB_OFF))

		else  
		
			cb_display(RED .. CB_AS_ERRORMSG)

		end

	--no idea what they typed!!!
	else
		cb_display(RED .. CB_ERRORMSG)
	end
end

----------------------------------------------------------------------------------------------------
-- TimeStamp Commands
----------------------------------------------------------------------------------------------------

-- Handles a slash command
function ChatBox_TimeStamp_Commands(msg)

	if msg == nil then msg = "" end

	if not (string.find(msg, CB_TS_FORMAT)) then
		msg = string.lower(msg)
	end

	-- No parameter or not one listed from above
	if msg == "" or msg == "?" or msg == string.lower(CB_OPTIONS) or msg == string.lower(CB_HELP) then

		cb_display("\n");
		cb_display(YEL..CB_TS_HELPTITLE.."   /cb나 /plm를 입력하면 다른 설정을 할 수 있습니다.".."\n")
   		-- List all chat frames and their status
		for i = 1, 7 do
			local name = "ChatFrame"..i;
			local status = ChatBox.TimeStamp_Settings.frames[i]
			local tabtext  =  getglobal(name .. "TabText"):GetText();
			if (tabtext) then
				name = name .. " (" .. tabtext .. ")";
			end
			if (status and status == CB_ON) then
				cb_display(string.format("    " .. CB_TS_FRAMESTATUS_TEXT, WHT .. name .. END, GRN .. CB_ON));
			else
				cb_display(string.format("    " .. CB_TS_FRAMESTATUS_TEXT, WHT .. name .. END, RED .. CB_OFF));
			end
		end
		cb_display(YEL .. "        " .. CB_TIMESTAMP_FRAME_HELP1);
		cb_display(YEL .. "        " .. CB_TIMESTAMP_FRAME_HELP2);
		cb_display("\n");

		cb_display(WHT .. CB_TS_COLOR .. " : " .. ChatBox_check_color() ..GRN.. CB_TS_COLOR_HELP_TEXT)
		cb_display(WHT .. CB_TS_FORMAT .. " : " .. RED .. ChatBox_check(ChatBox.TimeStamp_Settings.format).. GRN.. CB_TS_FORMAT_HELP_TEXTA)
		cb_display(WHT .. CB_TS_FORMAT_HELP_TEXTB);
		cb_display(WHT .. CB_TS_RESET .. GRN.. CB_TS_RESET_HELP_TEXT)



	elseif (msg == CB_TS_COLOR) then
		-- Change the color of the timestamps using a color picker
		ChatBox_TimeStamp_ColorPicker();

	elseif (msg == CB_TS_COLOR .. " " .. string.lower(CB_OFF)) then
		-- Disable the coloring of the timestamps
		ChatBox.TimeStamp_Settings.color = false;
		--ChatBox_TimeStamp_Set(CB_TS_COLOR, CB_OFF);
		cb_display(WHT..CB_TS_COLOR_TEXT .. " " .. ChatBox_check_color());

	elseif (string.find(msg, CB_TS_FORMAT)) then
		local index = string.find(msg, " ");
		if (index) then
			local test = string.sub(msg, index+1)
			if ( test ) then
				ChatBox.TimeStamp_Settings.format = test;
			else
				ChatBox.TimeStamp_Settings.format = "[%H:%M:%S]";
			end
		else
  			ChatBox.TimeStamp_Settings.format = "[%H:%M:%S]";
  		end

		-- Show a message notifying the user what happened
		cb_display(WHT..CB_TS_FORMAT_TEXT .. " " .. RED .. ChatBox.TimeStamp_Settings.format);

	elseif (string.find(msg, string.lower(CB_ON))) then
		local index = string.find(msg, " ");
		if (index) then
			local test = string.sub(msg, index+1)
			if ( test ) then
				test = "ChatFrame"..tostring(test)
				ChatBox.TimeStamp_Settings.frames[test] = CB_ON;
				cb_display(string.format(CB_TIMESTAMP_FRAMEENABLED, GRN .. test .. END));
			else
      				cb_display(RED .. CB_ERRORMSG)
   			end
		else
   			cb_display(RED .. CB_ERRORMSG)
		end

	elseif (string.find(msg, string.lower(CB_OFF))) then
		local index = string.find(msg, " ");
		if (index) then
			local test = string.sub(msg, index+1)
			if ( test ) then
				test = "ChatFrame"..tostring(test)
   				ChatBox.TimeStamp_Settings.frames[test] = CB_OFF;
	      			cb_display(string.format(CB_TIMESTAMP_FRAMEDISABLED, GRN .. test .. END));
			else
      				cb_display(RED .. CB_ERRORMSG)
   			end
		else
   			cb_display(RED .. CB_ERRORMSG)
		end

	elseif (msg == CB_TS_RESET) then
		-- Reset the settings of the current character back to defaults
		ChatBox.TimeStamp_Settings = {
   		color = false,
   		format = "[%H:%M:%S]",
   		frames = {
   			ChatFrame1 = CB_OFF,
   			ChatFrame2 = CB_OFF,
   			ChatFrame3 = CB_OFF,
   			ChatFrame4 = CB_OFF,
   			ChatFrame5 = CB_OFF,
   			ChatFrame6 = CB_OFF,
   			ChatFrame7 = CB_OFF,
   		   },
   		};

		-- Show a message notifying the user what happened
		cb_display(RED .. CB_TS_RESET_TEXT);

	--no idea what they typed!!!
	else
		cb_display(RED .. CB_ERRORMSG)
	end
end

----------------------------------------------------------------------------------------------------
-- PLM Slash Commands
----------------------------------------------------------------------------------------------------
function ChatBox_PLM_Commands(msg)
	if msg == nil then msg = "" end

	msg = string.lower(msg)

	-- No parameter or not one listed from above
	if msg == "" or msg == "?" or msg == string.lower(CB_OPTIONS) or msg == string.lower(CB_HELP) then
		cb_display("\n");
		cb_display(YEL..CB_HELPTITLE.."   /cb나 /ts를 입력하면 다른 설정을 할 수 있습니다.".."\n");
		cb_display(WHT .. CB_PLM_TEXT .. RED .. ChatBox_check(ChatBox.plm))
		cb_display("             " .. GRN .. CB_PLM_HELP_TEXT);
		cb_display(GRY .. CB_PLM_HELPA);
		cb_display(GRY .. CB_PLM_HELPB .. WHT .. CB_PLM_HELPC);
		cb_display(ORN .. CB_PLM_HELPD);
		cb_display("\n");
		cb_display(WHT .. CB_PLM_DEF_TEXT_HELP .. RED .. ChatBox_check(ChatBox.plm_def_name));
		cb_display(WHT .. CB_PLM_ALT_TEXT_HELP .. RED .. ChatBox_check(ChatBox.plm_alt_name));
		cb_display(WHT .. CB_PLM_SHIFT_TEXT_HELP .. RED .. ChatBox_check(ChatBox.plm_shift_name));
		cb_display(WHT .. CB_PLM_CTRL_TEXT_HELP .. RED .. ChatBox_check(ChatBox.plm_ctrl_name));


	--to toggle the Player Link Menu.
	elseif ( msg == string.lower(CB_ON) or msg == string.lower(CB_OFF) ) then
		if ChatBox.plm then
   			cb_display(WHT..CB_PLM_TEXT..RED..CB_OFF);
			ChatBox.plm = false;
		else
   			cb_display(WHT..CB_PLM_TEXT..RED..CB_ON);
			ChatBox.plm = true;
		end
		SetupPLM();


	--to change the default key functionality
	elseif (string.find(msg, string.lower(CB_PLM_DEF))) then
		local index = string.find(msg, " ");
		if (index) then
			local test = string.sub(msg, index+1)
			if ( test ) then
				if test == string.lower(WHO) then
	      				ChatBox.plm_def = ChatBox_specialSendWho;
	      				ChatBox.plm_def_name = WHO;
--[[				elseif test == string.lower(CB_TARGET) then
      					ChatBox.plm_def = TargetByName;
      					ChatBox.plm_def_name = CB_TARGET;]]
				elseif test == string.lower(WHISPER) then
      					ChatBox.plm_def = ChatFrame_SendTell;
		      			ChatBox.plm_def_name = WHISPER;
				elseif test == string.lower(PARTY_INVITE) then
      					ChatBox.plm_def = InviteByName;
		      			ChatBox.plm_def_name = PARTY_INVITE;
				elseif test == string.lower(IGNORE) then
      					ChatBox.plm_def = AddIgnore;
		      			ChatBox.plm_def_name = IGNORE;
				end
				cb_display(WHT .. CB_PLM_DEF_TEXT_HELP .. RED .. ChatBox.plm_def_name);
			end
		else
   			ChatBox.plm_def = false;
   			ChatBox.plm_def_name = CB_OFF;
			cb_display(WHT .. CB_PLM_DEF_TEXT_HELP .. RED .. CB_OFF);
		end

	--to change the alt key functionality
	elseif (string.find(msg, string.lower(CB_PLM_ALT))) then
		local index = string.find(msg, " ");
		if (index) then
			local test = string.sub(msg, index+1)
			if ( test ) then
				if test == string.lower(WHO) then
	      				ChatBox.plm_alt = ChatBox_specialSendWho;
	      				ChatBox.plm_alt_name = WHO;
--[[				elseif test == string.lower(CB_TARGET) then
      					ChatBox.plm_alt = TargetByName;
      					ChatBox.plm_alt_name = CB_TARGET;]]
				elseif test == string.lower(WHISPER) then
      					ChatBox.plm_alt = ChatFrame_SendTell;
		      			ChatBox.plm_alt_name = WHISPER;
				elseif test == string.lower(PARTY_INVITE) then
      					ChatBox.plm_alt = InviteByName;
		      			ChatBox.plm_alt_name = PARTY_INVITE;
				elseif test == string.lower(IGNORE) then
      					ChatBox.plm_alt = AddIgnore;
		      			ChatBox.plm_alt_name = IGNORE;
				end
				cb_display(WHT .. CB_PLM_ALT_TEXT_HELP .. RED .. ChatBox.plm_alt_name);
			end
		else
   			ChatBox.plm_alt = false;
   			ChatBox.plm_alt_name = CB_OFF;
			cb_display(WHT .. CB_PLM_ALT_TEXT_HELP .. RED .. CB_OFF);
		end

	--to change the shift key functionality
	elseif (string.find(msg, string.lower(CB_PLM_SHIFT))) then
		local index = string.find(msg, " ");
		if (index) then
			local test = string.sub(msg, index+1)
			if ( test ) then
				if test == string.lower(WHO) then
		      			ChatBox.plm_shift = ChatBox_specialSendWho;
      					ChatBox.plm_shift_name = WHO;
--[[				elseif test == string.lower(CB_TARGET) then
		      			ChatBox.plm_shift = TargetByName;
      					ChatBox.plm_shift_name = CB_TARGET;]]
				elseif test == string.lower(WHISPER) then
		      			ChatBox.plm_shift = ChatFrame_SendTell;
      					ChatBox.plm_shift_name = WHISPER;
				elseif test == string.lower(PARTY_INVITE) then
		      			ChatBox.plm_shift = InviteByName;
      					ChatBox.plm_shift_name = PARTY_INVITE;
				elseif test == string.lower(IGNORE) then
		      			ChatBox.plm_shift = AddIgnore;
      					ChatBox.plm_shift_name = IGNORE;
      				end
	   			cb_display(WHT .. CB_PLM_SHIFT_TEXT_HELP .. RED .. ChatBox.plm_shift_name);
   			end
			else
	   			ChatBox.plm_shift = false;
   				ChatBox.plm_shift_name = CB_OFF;
				cb_display(WHT .. CB_PLM_SHIFT_TEXT_HELP .. RED .. CB_OFF);
			end

	--to change the control key functionality
	elseif (string.find(msg, string.lower(CB_PLM_CTRL))) then
		local index = string.find(msg, " ");
		if (index) then
			local test = string.sub(msg, index+1)
			if ( test ) then
				if test == string.lower(WHO) then
      					ChatBox.plm_ctrl = ChatBox_specialSendWho;
		      			ChatBox.plm_ctrl_name = WHO;
--[[				elseif test == string.lower(CB_TARGET) then
      					ChatBox.plm_ctrl = TargetByName;
			      		ChatBox.plm_ctrl_name = CB_TARGET;]]
				elseif test == string.lower(WHISPER) then
      					ChatBox.plm_ctrl = ChatFrame_SendTell;
			      		ChatBox.plm_ctrl_name = WHISPER;
				elseif test == string.lower(PARTY_INVITE) then
      					ChatBox.plm_ctrl = InviteByName;
			      		ChatBox.plm_ctrl_name = PARTY_INVITE;
				elseif test == string.lower(IGNORE) then
	      				ChatBox.plm_ctrl = AddIgnore;
			      		ChatBox.plm_ctrl_name = IGNORE;
      				end
	   			cb_display(WHT .. CB_PLM_CTRL_TEXT_HELP .. RED .. ChatBox.plm_ctrl_name );
	   		end
		else
   			ChatBox.plm_ctrl = false;
   			ChatBox.plm_ctrl_name = CB_OFF;
			cb_display(WHT .. CB_PLM_CTRL_TEXT_HELP .. RED .. CB_OFF);
		end

	--no idea what they typed!!!
	else
		cb_display(RED .. CB_ERRORMSG)
	end
end
