local MOUNT_BUFF = {
	"Spell_Nature_Swiftness" ,
	"QirajiCrystal" ,
	"Ability_Mount" ,
	"INV_Misc_Foot_Kodo" ,
};


local ADDON_NAME = "BabUnmount";
local ADDON_VER = "1.00";
local ADDON_USAGE = "/babunmount";

------------- Commom functions --------------------------------------------------------------------------
local function Print(msg, r, g, b, frame)
	if (not r) then r = 1.0; end
	if (not g) then g = 1.0; end
	if (not b) then b = 1.0; end
	if ( frame ) then
		if frame=="UIErrorsFrame" then
			UIErrorsFrame:AddMessage(msg,1,0.7,0.7,1,5);
		else
			frame:AddMessage(msg,r,g,b);
		end
	else
		if ( DEFAULT_CHAT_FRAME ) then
			DEFAULT_CHAT_FRAME:AddMessage(msg, r, g, b);
		end
	end
end

local function Notice(msg)
	Print(msg, 1,0.7,0.2);
end

local function Error(msg)
	Print(msg, nil, nil, nil, "UIErrorsFrame");
end

local function DB(msg)
	if not msg then
		msg = "Check!"
	end
	Print(msg, 0.5, 0.5, 0.5);
end

local function Tooltip_ClearLines(tooltip)
	for i=1,(tooltip:NumLines()) do
		getglobal(tooltip:GetName().."TextRight"..i):SetText();
	end
	tooltip:ClearLines();
end

--------------------------------------------------------------------------------------------------------
local function BabUnmount_UnMount()
	local mount;
	local wtf;
	for i = 1, 20 do
		local buffIndex, untilCancelled = GetPlayerBuff(i);
		if buffIndex ~= 0 then
			if untilCancelled == 1 then
				Tooltip_ClearLines(BabUnmountTooltip);
				BabUnmountTooltip:SetPlayerBuff(i);
				local temp = BabUnmountTooltipTextLeft2:GetText();
				if temp then
					temp = gsub(temp,"이동 속도 (.+)%%만큼 증가","%1");
					if (temp == "60") or (temp == "100") then
						mount = i;
						break;
					end
				else
					wtf = true;
					break;
				end
			end
		else
			break;
		end
	end

	if wtf then
		for i = 1, 20 do
			local texture = GetPlayerBuffTexture(i);
			if (texture) then
				for j , v in pairs(MOUNT_BUFF) do
					if string.find(texture, v) then
						CancelPlayerBuff(i);
						return;
					end
				end
			else
				return;
			end
		end
	end

	CancelPlayerBuff(mount);
end
------------- onFoo functions --------------------------------------------------------------------------
function BabUnmount_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("UI_ERROR_MESSAGE");

	SlashCmdList["BABUNMOUNT"] = function()
		Notice("** BabUnmount (readme.txt를 참조하세요.) **");
		for i=1,20 do
			local texture = GetPlayerBuffTexture(i);
			if (texture) then
				local _ , temp = strfind(texture , 'Interface\\Icons\\');
				if temp then
					texture = strsub(texture , temp+1)
				end
				Notice(i .. ":  " ..texture);
			else
				break
			end
		end
	end
	SLASH_BABUNMOUNT1 = "/BABUNMOUNT";
	SLASH_BABUNMOUNT2 = "/babunmount";
end

function BabUnmount_OnEvent(event)
	if event == "VARIABLES_LOADED" then
		Notice(ADDON_NAME.." ver."..ADDON_VER.." Loaded. ( Usage: ".. ADDON_USAGE .." )");
	elseif event == "UI_ERROR_MESSAGE" then
		if (arg1==ERR_ATTACK_MOUNTED or arg1==SPELL_FAILED_NOT_MOUNTED or arg1==ERR_TAXIPLAYERALREADYMOUNTED) then
			BabUnmount_UnMount();
		end
	end
end
