BLUEMAPNOTE_MAJOR_VERSION = "Blue Map Note";
BLUEMAPNOTE_MINOR_VER = 16;
BLUEMAPNOTE_MINOR_VERSION = " Revision:"..BLUEMAPNOTE_MINOR_VER;
BLUEMAPNOTE_MAX_MINIMAP_NOTES = 12;
BLUEMAPNOTE_MAX_WORLDMAP_NOTES = 350;
BLUEMAPNOTE_TEXTURE_SIZE = 12;
BLUEMAPNOTE_TEXTURE_ALPHA = 1.0;
BLUEMAPNOTE_TEXTURE_ALPHA2 = 0.6;
BLUEMAPNOTE_ICON_PATH = "Interface\\AddOns\\BlueMapNote\\Icons\\";
BLUEMAPNOTE_MINMAP_UPDATE_INTERVAL = 0.25;
BLUEMAPNOTE_SAME_RANGE = 0.2;
BINDING_HEADER_BLUEMAPNOTE = BLUEMAPNOTE_MAJOR_VERSION;
BINDING_NAME_BLUEMAPNOTE_UI = "UI 창 열기";
BINDING_NAME_BLUEMAPNOTE_MEMO = "현 위치에 메모 작성";

BMN = {
	tooltipName = "",
	tooltipTime = 0,
	worldMapNotes = 0,
	miniMapNotes = 0,
	updateTime = 0,
	prevX = -1,
	prevY = -1,
	prevZoom = -1,
	isInSide = 0,
	checkInSide = 0,
};
	
function BlueMapNote_OnLoad()
	-- 이벤트 등록
	BlueMapNote:RegisterEvent("VARIABLES_LOADED");
	BlueMapNote:RegisterEvent("PLAYER_ENTERING_WORLD");
	BlueMapNote:RegisterEvent("WORLD_MAP_UPDATE");
	BlueMapNote:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	BlueMapNote:RegisterEvent("MINIMAP_UPDATE_ZOOM");	
	BlueMapNote:RegisterEvent("UI_ERROR_MESSAGE");
	BlueMapNote:RegisterEvent("UNIT_SPELLCAST_START");
	-- 슬래쉬 커맨드
	SlashCmdList["BLUEMAPNOTE"] = function(msg)
		BlueMapNote_SlashCommand(msg);
	end
	SLASH_BLUEMAPNOTE1 = "/bluemapnote";
	SLASH_BLUEMAPNOTE2 = "/블루맵노트";
	SLASH_BLUEMAPNOTE3 = "/bmn";
	-- 자원 및 지역 정보
	BlueMapNote_DataBase();
end

function BlueMapNote_OnEvent()
	if (event == "VARIABLES_LOADED") then
		if (BlueMapNoteOpt ~= nil) then
			BlueMapNoteOpt = nil;
		end
		if (BlueMapNoteOption == nil) then
			BlueMapNoteOption = {
				memo = { minimap = 1, worldmap = 1 },
				herb = { minimap = 1, worldmap = 1 },
				ore = { minimap = 1, worldmap = 1 },
				ect = { minimap = 1, worldmap = 1 },
				skip = {},
			};
		end
		if (BlueMapNoteDB == nil) then
			BlueMapNoteDB = {};
		end
		if (BlueMapNoteData ~= nil) then				
			BlueMapNote_LoadPlugIn();
			local loaded = LoadAddOn("BlueMapNote_Conv");
			if (BlueMapNote_ConvertOldData) then
				BlueMapNote_ConvertOldData();
			end		
		end
		BMN.minimapFrame = Minimap;
		BlueMapNoteMiniMapFrame:SetWidth(BMN.minimapFrame:GetWidth());
		BlueMapNoteMiniMapFrame:SetHeight(BMN.minimapFrame:GetHeight());
		BlueMapNoteMiniMapFrame:ClearAllPoints();
		BlueMapNoteMiniMapFrame:SetPoint("CENTER", BMN.minimapFrame, "CENTER", 0, 0);
		CreateFrame("Frame", "BlueMapNote_WorldMapObserver", WorldMapFrame);
		BlueMapNote_WorldMapObserver:SetScript("OnHide", function() SetMapToCurrentZone() BlueMapNote_ZoneInfo() BlueMapNote_MiniMap() end);
		if (AoAWorldMapFrame) then
			AoAWorldMapButton:SetScript("OnMouseUp", function() BlueMapNote_WorldMapButton_OnClick(arg1, this) end);
			CreateFrame("Frame", "BlueMapNote_AoAObserver", AoAWorldMapFrame);
			BlueMapNote_AoAObserver:SetScript("OnHide", function() SetMapToCurrentZone() BlueMapNote_ZoneInfo() BlueMapNote_MiniMap() end);
		end
		if (BlueInstanceMap) then
			BlueInstanceMap:SetScript("OnClick", function() BlueMapNote_WorldMapButton_OnClick(arg1, this) end);
		end
		WorldMapButton:SetScript("OnMouseUp", function() BlueMapNote_WorldMapButton_OnClick(arg1, this) end);
	elseif (event == "PLAYER_ENTERING_WORLD") then
		BlueMapNoteMiniMapFrame:SetFrameStrata(BMN.minimapFrame:GetFrameStrata());
		BlueMapNoteMiniMapFrame:SetFrameLevel(BMN.minimapFrame:GetFrameLevel() + 1);
		BMN.zone = GetRealZoneText();
		BlueMapNote_IsInSide();
		BlueMapNote_ZoneInfo();
	elseif (event == "WORLD_MAP_UPDATE") then
		BlueMapNote_WorldMapUpdate();
	elseif (event == "ZONE_CHANGED_NEW_AREA") then
		BMN.zone = GetRealZoneText();
		BlueMapNote_ZoneInfo();	
		BlueMapNote_UpdateNotes();
	elseif (event == "MINIMAP_UPDATE_ZOOM") then
		BMN.checkInSide = GetTime() + 1.0;
	elseif (event == "UNIT_SPELLCAST_START" and arg1 == "player") then
		local _, _, text = UnitCastingInfo("player");
		if (text and (text == "약초채집" or text == "채광" or text == "열기" or text == "")) then
			BlueMapNote_AddResource();
		end
	elseif (event == "UI_ERROR_MESSAGE" and arg1 and (strfind(arg1, "채광") or strfind(arg1, "약초"))) then
		BlueMapNote_AddResource();
	end
end

function BlueMapNote_OnUpdate()
	if (GameTooltip:IsVisible() and GetMouseFocus() == WorldFrame and not(UnitExists("mouseover"))) then
		BMN.tooltipName = GameTooltipTextLeft1:GetText();
		if (BMN.tooltipName) then
			BMN.tooltipTime = GetTime();
		else
			BMN.tooltipName = "";
		end
	elseif ((GetTime() - BMN.tooltipTime) > 1.5) then
		BMN.tooltipName = "";
	end
	if (BMN.checkInSide > 0 and BMN.checkInSide <= GetTime()) then
		BMN.prevZoom = Minimap:GetZoom();
		BMN.prevX, BMN.prevY = GetPlayerMapPosition("player");
		BlueMapNote_IsInSide();
		BlueMapNote_ZoneInfo();
		BlueMapNote_MiniMap();
		BMN.checkInSide = 0;
	elseif (BMN.checkInSide == 0) then
		local x, y = GetPlayerMapPosition("player");
		local zoom = Minimap:GetZoom();
		if (zoom ~= BMN.prevZoom) then
			BMN.prevZoom = zoom;
			BlueMapNote_ZoneInfo();
			BlueMapNote_MiniMap();
		elseif (x ~= BMN.prevX or y ~= BMN.prevY) then
			if (BMN.prevX == 0 and BMN.prevY == 0 and not(IsInInstance())) then
				BlueMapNote_ZoneInfo();
			end
			BMN.prevX = x;
			BMN.prevY = y;
			BlueMapNote_MiniMap();
		end
	end
end

function BlueMapNote_WorldMapUpdate()
	if (WorldMapFrame:IsVisible()) then
		WorldMapMagnifyingGlassButton:SetText(ZOOM_OUT_BUTTON_TEXT.."\n메모 작성 : Ctrl + 마우스 클릭\n메모 편집 : Alt + 마우스 클릭\n메모 삭제 : Shift + 마우스 클릭");
		if (BlueInstanceMap and BlueInstanceMap:IsVisible()) then
			BlueMapNote_WorldMap(BlueInstanceMap);
		else			
			BlueMapNote_WorldMap(WorldMapFrame);
		end
	elseif (AoAWorldMapFrame and AoAWorldMapFrame:IsVisible()) then
		BlueMapNote_WorldMap(AoAWorldMapFrame);
	end
end

function BlueMapNote_IsInSide()	
	local insideZoom = tonumber(GetCVar("minimapInsideZoom"));
	local outsideZoom = tonumber(GetCVar("minimapZoom"));
	local zoom = Minimap:GetZoom();
	if (insideZoom == outsideZoom) then
		if (insideZoom == 0) then
			Minimap:SetZoom(zoom + 1);
		else
			Minimap:SetZoom(zoom - 1);
		end
	end
	local nInsideZoom = tonumber(GetCVar("minimapInsideZoom"));
	local nZoom = Minimap:GetZoom();
	if (nInsideZoom == nZoom) then
		Minimap:SetZoom(insideZoom);
		BMN.isInSide = 1;
	else
		Minimap:SetZoom(outsideZoom);
		BMN.isInSide = 0;
	end
end

function BlueMapNote_ZoneInfo()
	BMN.zoneInfo = nil;
	local zone, x, y = BlueMapNote_GetPosition();	
	if (zone == nil) then
		return;
	end
	local continent = BMN.regionMap[zone];
	local regionData = BMN.regionData[zone];
	local zoom = Minimap:GetZoom() + 1;
	if not(continent and regionData and regionData.scale and regionData.xOffset and regionData.yOffset) then		
		return;
	end
	BMN.zoneInfo = {};	
	BMN.zoneInfo.mapScaleX = BMN.regionValue[continent][zoom][1];
	BMN.zoneInfo.mapScaleY = BMN.regionValue[continent][zoom][2];
	if (BMN.isInSide == 1) then
		BMN.zoneInfo.mapScaleX = BMN.zoneInfo.mapScaleX * BMN.regionInsideZoom[zoom];
		BMN.zoneInfo.mapScaleY = BMN.zoneInfo.mapScaleY * BMN.regionInsideZoom[zoom];
	end
	BMN.zoneInfo.cScale = regionData.scale;
	BMN.zoneInfo.cXOffset = regionData.xOffset;
	BMN.zoneInfo.cYOffset = regionData.yOffset;
	BMN.zoneInfo.worldScale = UIParent:GetEffectiveScale();
end

function BlueMapNote_UpdateNotes()
	BlueMapNote_WorldMapUpdate();
	BlueMapNote_MiniMap();
end

function BlueMapNote_LoadPlugIn()
	local loaded = LoadAddOn("BlueMapNote_UI");
end

function BlueMapNote_GetPosition()
	local x, y = GetPlayerMapPosition("player");
	local zone = GetRealZoneText() or "";
	if ((x == 0 and y == 0) or (x == nil or y == nil) or IsInInstance() or BMN.regionData[zone] == nil) then
		return nil, 0, 0;
	end
	return zone, tonumber(format("%.2f", x * 100.0)), tonumber(format("%.2f", y * 100.0));
end

function BlueMapNote_AddResource()
	if (WorldMapFrame:IsVisible() or (AoAWorldMapFrame and AoAWorldMapFrame:IsVisible()) or IsInInstance()) then
		return;
	end
	local zone, x, y = BlueMapNote_GetPosition();
	if (zone == nil or BMN.tooltipName == nil) then
		return;
	elseif (zone and BMN.tooltipName) then
		local text = BlueMapNote_GetResOName(BMN.tooltipName);
		local res = BMN.Resource[text];
		if (res and BMN.ResourceTexture[res] and BlueMapNote_IsSameRes(zone, x, y, res) == 0) then
			local n = BlueMapNote_NextDBN(zone);
			BlueMapNoteDB[zone][n] = { x = x, y = y, res = res };
			BlueMapNote_UpdateNotes();
		end
	end
end

function BlueMapNote_IsSameRes(zone, x, y, res)
	local r = BLUEMAPNOTE_SAME_RANGE;
	local dbn = BlueMapNote_NextDBN(zone) - 1;
	local i;
	for i = 1, dbn do
		if (BlueMapNoteDB[zone][i].title == nil) then
			local oX, oY, oRes = BlueMapNoteDB[zone][i].x, BlueMapNoteDB[zone][i].y, BlueMapNoteDB[zone][i].res;
			if (res == oRes and (oX - r) <= x and (oX + r) >= x and (oY - r) <= y and (oY + r) >= y) then
				return 1;
			end
		end
	end
	return 0;
end

function BlueMapNote_NextDBN(zone)
	if (zone == nil) then
		return 0;
	end
	if (BlueMapNoteDB[zone] == nil) then
		BlueMapNoteDB[zone] = {};
	end
	return #(BlueMapNoteDB[zone]) + 1;
end

function BlueMapNote_DeleteNote(zone, id)
	if (BlueMapNoteDB[zone] == nil or BlueMapNoteDB[zone][id] == nil) then
		return;
	end
	local i;
	local n = BlueMapNote_NextDBN(zone) - 1;
	for i = id, n - 1 do
		BlueMapNoteDB[zone][i] = BlueMapNoteDB[zone][i + 1];
	end
	BlueMapNoteDB[zone][n] = nil;
	BlueMapNote_UpdateNotes();
end

function BlueMapNote_ShowTooltip(frameName, tooltip)
	local id = getglobal(frameName).id;
	local zone = getglobal(frameName).zone;
	local content;
	if (BlueMapNoteDB[zone] and BlueMapNoteDB[zone][id]) then
		local x, y = this:GetCenter();
		local parentX, parentY = this:GetParent():GetCenter();
		if ( x > parentX ) then
			tooltip:SetOwner(this, "ANCHOR_LEFT");
		else
			tooltip:SetOwner(this, "ANCHOR_RIGHT");
		end
		local resName = BlueMapNote_GetResourceName(BlueMapNoteDB[zone][id].res);
		if (BlueMapNoteDB[zone][id].title) then
			if (BlueMapNoteDB[zone][id].content == "") then
				tooltip:SetText(BlueMapNoteDB[zone][id].title);
			else
				content = gsub(BlueMapNoteDB[zone][id].content, "%_", "\n");
				tooltip:SetText(BlueMapNoteDB[zone][id].title.."\n|cffffffff"..content.."|r");
			end
		else
			tooltip:SetText(resName);
		end
		tooltip:Show();
	end
end

function BlueMapNote_MiniMap()
	BlueMapNoteMiniMapFrame:Hide();
	if (BMN.zoneInfo == nil or BMN.zoneInfo.cScale == nil or BMN.zoneInfo.cXOffset == nil) then
		for i = 1, BLUEMAPNOTE_MAX_MINIMAP_NOTES do
			if (getglobal("Blue_MiniMapNote"..i)) then
				getglobal("Blue_MiniMapNote"..i):Hide();
				getglobal("Blue_MiniMapNote"..i).id = nil;
				getglobal("Blue_MiniMapNote"..i).zone = nil;
			else
				break;
			end
		end
		BMN.miniMapNotes = 0;
		return;	
	end
	local n = 0;
	local dn = BlueMapNote_NextDBN(BMN.zone) - 1;
	local i, posX, posY, resX, resY, dX, dY, dis, degree, resType;
	local x, y = GetPlayerMapPosition("player");
	x = x * BMN.zoneInfo.cScale + BMN.zoneInfo.cXOffset;
	y = y * BMN.zoneInfo.cScale + BMN.zoneInfo.cYOffset;
	for i = 1, dn do
		local db = BlueMapNoteDB[BMN.zone][i];
		local resType = BlueMapNote_GetResourceTypeText(db.res);
		if (resType and BlueMapNoteOption[resType].minimap == 1 and BlueMapNoteOption.skip[db.res] == nil) then			
			resX = db.x / 100 * BMN.zoneInfo.cScale + BMN.zoneInfo.cXOffset;
			resY = db.y / 100 * BMN.zoneInfo.cScale + BMN.zoneInfo.cYOffset;
			dX = (resX - x) * BMN.zoneInfo.mapScaleX;
			dY = (resY - y) * BMN.zoneInfo.mapScaleY;
			dis = sqrt(dX * dX + dY * dY) * BMN.zoneInfo.worldScale;
			if (dis < 58) then
				n = n + 1;
				if (n > BLUEMAPNOTE_MAX_MINIMAP_NOTES) then
					n = BLUEMAPNOTE_MAX_MINIMAP_NOTES;
					break;
				end
				if (dX == 0) then
					dX = 0.000001;
				end
				degree = atan(dY / dX);
				if (dX < 0) then
					posX = -cos(degree) * dis;
					posY = sin(degree) * dis;
				else
					posX = cos(degree) * dis;
					posY = -sin(degree) * dis;
				end
				if (getglobal("Blue_MiniMapNote"..n) == nil) then
					CreateFrame("Button", "Blue_MiniMapNote"..n, BlueMapNoteMiniMapFrame, "BlueMapNoteResource2");
				end
				getglobal("Blue_MiniMapNote"..n):SetID(n);
				getglobal("Blue_MiniMapNote"..n).id = i;
				getglobal("Blue_MiniMapNote"..n).zone = BMN.zone;
				getglobal("Blue_MiniMapNote"..n):SetWidth(BLUEMAPNOTE_TEXTURE_SIZE);
				getglobal("Blue_MiniMapNote"..n):SetHeight(BLUEMAPNOTE_TEXTURE_SIZE);
				getglobal("Blue_MiniMapNote"..n):ClearAllPoints();
				getglobal("Blue_MiniMapNote"..n):SetPoint("CENTER", "BlueMapNoteMiniMapFrame", "CENTER", posX, posY);
				if (resType == BlueMapNote_GetTracker() and dis < 26) then
					getglobal("Blue_MiniMapNote"..n.."_texture"):SetTexture(BLUEMAPNOTE_ICON_PATH.."Detail");
				else
					getglobal("Blue_MiniMapNote"..n.."_texture"):SetTexture(BLUEMAPNOTE_ICON_PATH..BMN.ResourceTexture[db.res]);
				end
				getglobal("Blue_MiniMapNote"..n):Show();
			end
		end
	end
	for i = n + 1, BLUEMAPNOTE_MAX_MINIMAP_NOTES do
		if (getglobal("Blue_MiniMapNote"..i)) then
			getglobal("Blue_MiniMapNote"..i):Hide();
			getglobal("Blue_MiniMapNote"..i).id = nil;
			getglobal("Blue_MiniMapNote"..i).zone = nil;
		else
			break;
		end
	end
	BMN.miniMapNotes = n;
	BlueMapNoteMiniMapFrame:Show();
end

function BlueMapNote_WorldMap(frame)
	BlueMapNoteWorldMapFrame:Hide();
	local frameDetail, frameButton, frameScale;
	local mapZones = { GetMapZones(GetCurrentMapContinent()) };
	local zone = mapZones[GetCurrentMapZone()];
	if (AoAWorldMapFrame and frame == AoAWorldMapFrame) then
		frameDetail = AoAWorldMapButton;
		frameButton = AoAWorldMapButton;
		frameScale = AoAWorldMapButton:GetEffectiveScale();
	elseif (BlueInstanceMap and frame == BlueInstanceMap and BlueInstanceMap:IsVisible()) then
		frameDetail = BlueInstanceMap;
		frameButton = BlueInstanceMap;
		frameScale = 1;
		zone = BlueInstanceMapText:GetText();
	else
		frame = WorldMapFrame;
		frameDetail = WorldMapDetailFrame;
		frameButton = WorldMapButton;
		frameScale = 1;
	end
	if (zone == nil) then
		return;
	end
	BlueMapNoteWorldMapFrame:SetParent(frameDetail);
	BlueMapNoteWorldMapFrame:ClearAllPoints();
	BlueMapNoteWorldMapFrame:SetPoint("TOPLEFT", frameDetail, "TOPLEFT", 0, 0);
	BlueMapNoteWorldMapFrame:SetWidth(frameDetail:GetWidth() / frameScale);
	BlueMapNoteWorldMapFrame:SetHeight(frameDetail:GetHeight() / frameScale);
	BlueMapNoteWorldMapFrame:SetFrameStrata(frameButton:GetFrameStrata());
	BlueMapNoteWorldMapFrame:SetFrameLevel(frameButton:GetFrameLevel() + 1);
	local worldMapWidth, worldMapHeight = BlueMapNoteWorldMapFrame:GetWidth(), BlueMapNoteWorldMapFrame:GetHeight();
	local i, n = 0, 0;
	local db;
	local dn = BlueMapNote_NextDBN(zone) - 1;
	for i = 1, dn do
		db = BlueMapNoteDB[zone][i];
		resType = BlueMapNote_GetResourceTypeText(db.res);
		if (resType and BlueMapNoteOption[resType].worldmap == 1 and BlueMapNoteOption.skip[db.res] == nil) then
			n = n + 1;
			if (n > BLUEMAPNOTE_MAX_WORLDMAP_NOTES) then
				n = BLUEMAPNOTE_MAX_WORLDMAP_NOTES; 
				break;
			end
			local posX = (worldMapWidth / 100.0 * db.x - BLUEMAPNOTE_TEXTURE_SIZE / 2);
			local posY = -(worldMapHeight / 100.0 * db.y - BLUEMAPNOTE_TEXTURE_SIZE / 2);
			if (getglobal("Blue_WorldMapNote"..n) == nil) then
				CreateFrame("Button", "Blue_WorldMapNote"..n, BlueMapNoteWorldMapFrame, "BlueMapNoteResource1");
			end
			getglobal("Blue_WorldMapNote"..n):SetID(n);
			getglobal("Blue_WorldMapNote"..n).id = i;
			getglobal("Blue_WorldMapNote"..n).zone = zone;
			getglobal("Blue_WorldMapNote"..n):SetWidth(BLUEMAPNOTE_TEXTURE_SIZE);
			getglobal("Blue_WorldMapNote"..n):SetHeight(BLUEMAPNOTE_TEXTURE_SIZE);
			getglobal("Blue_WorldMapNote"..n):SetAlpha(BLUEMAPNOTE_TEXTURE_ALPHA);
			getglobal("Blue_WorldMapNote"..n):ClearAllPoints();
			getglobal("Blue_WorldMapNote"..n):SetPoint("TOPLEFT", "BlueMapNoteWorldMapFrame", "TOPLEFT", posX, posY);
			getglobal("Blue_WorldMapNote"..n.."_texture"):SetTexture(BLUEMAPNOTE_ICON_PATH..BMN.ResourceTexture[db.res]);
			getglobal("Blue_WorldMapNote"..n):Show();
		end
	end
	for i = n + 1, BMN.worldMapNotes do
		if (getglobal("Blue_WorldMapNote"..i)) then
			getglobal("Blue_WorldMapNote"..i):Hide();
			getglobal("Blue_WorldMapNote"..i).id = nil;
			getglobal("Blue_WorldMapNote"..i).zone = nil;
		end
	end
	BMN.worldMapNotes = n;
	BlueMapNoteWorldMapFrame:Show();
end

function BlueMapNote_GetResourceTypeText(res)
	local resType = floor((res or 0) / 100);
	if (resType == 1) then
		return "memo";
	elseif (resType == 2) then
		return "herb";
	elseif (resType == 3) then
		return "ore";
	elseif (resType == 4) then
		return "ect";
	else
		return nil;
	end
end

function BlueMapNote_GetResourceName(res)
	if (res == 404) then
		return "궤짝";
	end
	if (res == 405) then
		return "마력의 수정";
	end
	local name, value;
	for name, value in pairs(BMN.Resource) do
		if (value == res) then
			return name;
		end
	end
	return "";
end

function BlueMapNote_WorldMapButton_OnClick(mouseButton, button)
	if (mouseButton == "LeftButton" and IsControlKeyDown()) then
		local mapZones = { GetMapZones(GetCurrentMapContinent()) };		
		local mapZone = mapZones[GetCurrentMapZone()];	
		local scale = 1;
		if (BlueInstanceMap and button == BlueInstanceMap and BlueInstanceMap:IsVisible()) then
			mapZone = BlueInstanceMapText:GetText();
		end
		if (mapZone == nil) then
			BlueMapNote_WorldMapButton_OnClickDef(mouseButton, button);
			return;
		end
		if (WorldMapFrame:IsVisible()) then
			scale = 1;
		elseif (AoAWorldMapFrame and AoAWorldMapFrame:IsVisible()) then
			scale = AoAWorldMapFrame:GetEffectiveScale();
		end
		local centerX, centerY = button:GetCenter();
	        local width = button:GetWidth() / scale;
	        local height = button:GetHeight() / scale;
	        local x, y = GetCursorPosition();
		x = x / button:GetEffectiveScale();
		y = y / button:GetEffectiveScale();
		local posX = (x - (centerX - width / 2)) / width;
		local posY = (centerY + height / 2 - y) / height;
		posX = tonumber(format("%.2f", posX * 100.0));
		posY = tonumber(format("%.2f", posY * 100.0));
		BlueMapNote_LoadPlugIn();
		BlueMapNote_AddMemo_UI(mapZone, posX, posY);
	else
		BlueMapNote_WorldMapButton_OnClickDef(mouseButton, button);
	end
end

function BlueMapNote_WorldMapButton_OnClickDef(mouseButton, button)
	if (button == WorldMapButton) then
		WorldMapButton_OnClick(mouseButton, button);
	elseif (BlueInstanceMap and button == BlueInstanceMap) then
		BlueInstanceMap_OnClick(mouseButton, button);
	elseif (AoAWorldMapButton and button == AoAWorldMapButton) then
		AoAWMapButton_OnClick(mouseButton, button);
	end
end

function BlueMapNote_SlashCommand(msg)
	msg = strlower(msg);
	if (msg == "convert" or msg == "converter" or msg == "변환") then
		BlueMapNote_LoadPlugIn();
		local loaded = LoadAddOn("BlueMapNote_Conv");
		if (BlueMapNote_ConvertData) then
			BlueMapNote_ConvertData();
		end
	elseif (msg == "config" or msg == "option" or msg == "설정") then
		BlueMapNote_LoadPlugIn();
		if (BlueMapNote_Toggle_UI) then
			BlueMapNote_Toggle_UI();
		end
	elseif (msg == "memo" or msg == "메모" or msg == "note" or msg == "노트") then
		local zone, x, y = BlueMapNote_GetPosition();
		BlueMapNote_LoadPlugIn();
		if (BlueMapNote_AddMemo_UI and zone and not(x == 0 and y == 0)) then			
			BlueMapNote_AddMemo_UI(zone, x, y);
		end
	else
		DEFAULT_CHAT_FRAME:AddMessage("\n[|cFF669900B|cFFFFFFFFlue |cFF669900M|cFFFFFFFFap |cFF669900N|cFFFFFFFFote|cffcccccc"..BLUEMAPNOTE_MINOR_VERSION.."]|r");
		DEFAULT_CHAT_FRAME:AddMessage("|cffffea00멍령어:|r /블루맵노트 /bluemapnote /bmn");
		DEFAULT_CHAT_FRAME:AddMessage("|cffffea00옵션:|r /블루맵노트 /bluemapnote /bmn");
		DEFAULT_CHAT_FRAME:AddMessage(" o |cff00ff00convert | 변환|r　기존 다른 노트 애드온의 자료 변환");
		DEFAULT_CHAT_FRAME:AddMessage(" o |cff00ff00config | 설정|r　 설정창 열기");
		DEFAULT_CHAT_FRAME:AddMessage(" o |cff00ff00memo | note | 메모 | 노트|r　 현재 위치에 새 매모를 작성.");
	end
end

function BlueMapNote_ChangeResName(name)
	if (name == nil) then
		return "";
	end
	name = gsub(name, "진흙으로 덮인 ", "");
	name = gsub(name, " ", "");
	if (strfind(name, "마력의수정")) then
		name = gsub(name, "붉은", "");
		name = gsub(name, "푸른", "");
		name = gsub(name, "노란", "");
		name = gsub(name, "녹색", "");
	end
	return name;
end

function BlueMapNote_GetResOName(rName)
	if (rName == nil) then
		return nil;
	end
	for name, _ in pairs(BMN.Resource) do
		if (BlueMapNote_ChangeResName(name) == BlueMapNote_ChangeResName(rName)) then
			return name;
		end
	end
	return nil;
end

function BlueMapNote_GetTracker()
	local trackingTexture = GetTrackingTexture();
	if (trackingTexture) then
		if (trackingTexture == "Interface\\Icons\\INV_Misc_Flower_02") then
			return "herb";
		elseif (trackingTexture == "Interface\\Icons\\Spell_Nature_Earthquake") then
			return "ore";
		end
	end
	return "";
end