local tabName = { "설  정", "자  원", "도움말" };
local currTab = 1;
local helpText = {
	["title"] = "Blue Map Note ?!",
	["contents"] =  " 약초와 광물의 채집 정보, 사용자가 작성한 노트를"..
			" 미니맵과 월드맵에 표시해주는 애드온입니다.\n"..
			"약초나 광맥을 클릭하기만해도(배우지 않아도 상관"..
			"없습니다) 월드맵과 미니맵에 정보를 기록합니다. 단축키"..
			"를 설정해 현위치에 메모를 작성하는것이 가능합니다."..
			" 월드맵에서 컨트롤+클릭으로 새 메모를 작성할 수 도 있습니다."..
			" 필요하지 않는 자원이나 메모는 시프트+클릭으로 삭제할 수 있습니다. "..
			"자원 정보는 차후에 지원할 예정입니다 ^^..\n\n      "..
			"|cffaaaaff알렉스트라자 서버 언데드 흑마법사 지독한독감|r",
 };

function BlueMapNote_OnLoad_UI()
	BlueMapNote_LoadSetting();
	BlueMapNote_ShowOptions();
end

function BlueMapNote_Toggle_UI()
	if (BlueMapNoteOptions:IsVisible()) then
		HideUIPanel(BlueMapNoteOptions);
	else
		ShowUIPanel(BlueMapNoteOptions);
		if (WorldMapFrame:IsVisible()) then
			BlueMapNoteOptions:SetFrameStrata("FULLSCREEN_DIALOG");
		else
			BlueMapNoteOptions:SetFrameStrata("MEDIUM");
		end
	end
end

function BlueMapNote_AddMemo_UI(zone, posX, posY)
	BlueMapNote_EditMemo_TitleText:SetText("새 메모 작성");
	BlueMapNote_EditMemo_Title:SetBackdropColor(0, 0, 1, 0.8);
	BlueMapNote_EditMemo_OKButtonText:SetText("확  인");
	BlueMapNote_EditMemo_CancelButtonText:SetText("취  소");
	if (WorldMapFrame:IsVisible()) then
		BlueMapNote_EditMemo:SetFrameStrata("FULLSCREEN_DIALOG");
		BlueMapNote_EditMemo:SetParent("WorldMapFrame");
	else
		BlueMapNote_EditMemo:SetFrameStrata("MEDIUM");
		BlueMapNote_EditMemo:SetParent("UIParent");
	end
	BlueMapNote_EditMemo_Position:SetText(format("%s (%1.2f, %1.2f)", zone, posX, posY));
	BlueMapNote_EditMemo_Memo1Text:SetText("제   목");
	BlueMapNote_EditMemo_Memo2Text:SetText("내   용");
	BlueMapNote_EditMemo_Memo1EditBox:SetText("");
	BlueMapNote_EditMemo_Memo2EditBox:SetText("");
	BlueMapNote_EditMemo_OKButton.zone = zone;
	BlueMapNote_EditMemo_OKButton.posX = posX;
	BlueMapNote_EditMemo_OKButton.posY = posY;
	BlueMapNote_EditMemo_OKButton.edit = 0;
	ShowUIPanel(BlueMapNote_EditMemo);
end

function BlueMapNote_AddMemo(title, content, zone, x, y, memoIcon)
	if (zone == nil or x == nil or y == nil) then
		zone, x, y = BlueMapNote_GetPosition();
	end
	if (x == 0 and y == 0) then
		return;
	end
	if (memoIcon == nil) then
		memoIcon = 101;
	else
		memoIcon = memoIcon + 100;
	end
	if (zone and title) then
		local i;
		local n = BlueMapNote_NextDBN(zone);
		for i = 1, n - 1 do
			if (BlueMapNoteDB[zone][i] ~= nil and BlueMapNoteDB[zone][i].x == x and BlueMapNoteDB[zone][i].y == y) then
				return;
			end
		end
		BlueMapNoteDB[zone][n] = { x = x, y = y, res = memoIcon, title = title, content = content };
	end
end

function BlueMapNote_EditMemo_UI(zone, id)
	local x = BlueMapNoteDB[zone][id].x;
	local y = BlueMapNoteDB[zone][id].y;
	local title = BlueMapNoteDB[zone][id].title;
	local content = BlueMapNoteDB[zone][id].content;
	local icon = BlueMapNoteDB[zone][id].res - 100;
	BlueMapNote_EditMemo_TitleText:SetText("메모 편집");
	BlueMapNote_EditMemo_Title:SetBackdropColor(0, 0, 1, 0.8);
	BlueMapNote_EditMemo_OKButtonText:SetText("확  인");
	BlueMapNote_EditMemo_CancelButtonText:SetText("취  소");
	if (WorldMapFrame:IsVisible()) then
		BlueMapNote_EditMemo:SetFrameStrata("FULLSCREEN_DIALOG");
		BlueMapNote_EditMemo:SetParent("WorldMapFrame");
	else
		BlueMapNote_EditMemo:SetFrameStrata("MEDIUM");
		BlueMapNote_EditMemo:SetParent("UIParent");
	end
	BlueMapNote_EditMemo_Position:SetText(format("%s (%1.2f, %1.2f)", zone, x, y));
	BlueMapNote_EditMemo_Memo1Text:SetText("제   목");
	BlueMapNote_EditMemo_Memo2Text:SetText("내   용");
	BlueMapNote_EditMemo_Memo1EditBox:SetText(title);
	BlueMapNote_EditMemo_Memo2EditBox:SetText(content);
	BlueMapNote_EditMemo_OKButton.zone = zone;
	BlueMapNote_EditMemo_OKButton.posX = x;
	BlueMapNote_EditMemo_OKButton.posY = y;
	BlueMapNote_EditMemo_OKButton.edit = id;
	ShowUIPanel(BlueMapNote_EditMemo);
	local i;
	for i = 1, 6 do
		if (i == icon) then
			getglobal("BlueMapNote_SelectIcon"..i).checked = 1;
			getglobal("BlueMapNote_SelectIcon"..i.."_B"):Show();
		else
			getglobal("BlueMapNote_SelectIcon"..i).checked = 0;
			getglobal("BlueMapNote_SelectIcon"..i.."_B"):Hide();
		end
	end
end

function BlueMapNote_ShowOptions()
	local i;
	BlueMapNoteOptions_Title:SetBackdropColor(0, 0, 1, 0.8);
	for i = 1, getn(tabName) do
		getglobal("BlueMapNoteOptions_Tab"..i.."ButtonText"):SetText(tabName[i]);
	end
	BlueMapNoteOptions_OKButtonText:SetText("확      인");
	BlueMapNoteOptions_CancelButtonText:SetText("취      소");
	BlueMapNoteOptions_TitleText:SetText(BLUEMAPNOTE_MAJOR_VERSION.."|cffffffff"..BLUEMAPNOTE_MINOR_VERSION.."|r");
	BlueMapNoteOptons_Tab3Content:SetSpacing(8);
	BlueMapNote_SelectTab(currTab);
	BlueMapNoteOptons_Tab3Title:SetText(helpText.title);
	BlueMapNoteOptons_Tab3Content:SetText(helpText.contents);
	BlueMapNoteOptons_Tab1Title1:SetText("메       모");
	BlueMapNoteOptons_Tab1Title1:SetTextColor(1, 1, 1);
	BlueMapNoteOptons_Tab1Title2:SetText("약       초");
	BlueMapNoteOptons_Tab1Title2:SetTextColor(1, 1, 1);
	BlueMapNoteOptons_Tab1Title3:SetText("광       맥");
	BlueMapNoteOptons_Tab1Title3:SetTextColor(1, 1, 1);
	BlueMapNoteOptons_Tab1Title4:SetText("기       타");
	BlueMapNoteOptons_Tab1Title4:SetTextColor(1, 1, 1);
	BlueMapNoteOptions_Tab1Button1Text:SetText("미니맵 보이기");
	BlueMapNoteOptions_Tab1Button1.tooltipText = "미니맵에 메모 아이콘을 보이고 숨깁니다.";
	BlueMapNoteOptions_Tab1Button2Text:SetText("월드맵 보이기");
	BlueMapNoteOptions_Tab1Button2.tooltipText = "월드맵에 메모 아이콘을 보이고 숨깁니다.";
	BlueMapNoteOptions_Tab1Button3Text:SetText("미니맵 보이기");
	BlueMapNoteOptions_Tab1Button3.tooltipText = "미니맵에 약초 아이콘을 보이고 숨깁니다.";
	BlueMapNoteOptions_Tab1Button4Text:SetText("월드맵 보이기");
	BlueMapNoteOptions_Tab1Button4.tooltipText = "월드맵에 약초 아이콘을 보이고 숨깁니다.";
	BlueMapNoteOptions_Tab1Button5Text:SetText("미니맵 보이기");
	BlueMapNoteOptions_Tab1Button5.tooltipText = "미니맵에 광맥 아이콘을 보이고 숨깁니다.";
	BlueMapNoteOptions_Tab1Button6Text:SetText("월드맵 보이기");
	BlueMapNoteOptions_Tab1Button6.tooltipText = "월드맵에 광맥 아이콘을 보이고 숨깁니다.";
	BlueMapNoteOptions_Tab1Button7Text:SetText("미니맵 보이기");
	BlueMapNoteOptions_Tab1Button7.tooltipText = "미니맵에 궤짝, 영웅의 피, 운고로 수집물 등의 아이콘을 보이고 숨깁니다.";
	BlueMapNoteOptions_Tab1Button8Text:SetText("월드맵 보이기");
	BlueMapNoteOptions_Tab1Button8.tooltipText = "월드맵에 궤짝, 영웅의 피, 운고로 수집물 등의 아이콘을 보이고 숨깁니다.";
	BlueMapNoteOptions_Tab1Filter1Text:SetText("필  터");	
	BlueMapNoteOptions_Tab1Filter1Text:SetTextColor(1, 0.82, 0);
	BlueMapNoteOptions_Tab1Filter2Text:SetText("필  터");
	BlueMapNoteOptions_Tab1Filter2Text:SetTextColor(1, 0.82, 0);
	BlueMapNoteOptions_Tab1Filter3Text:SetText("필  터");
	BlueMapNoteOptions_Tab1Filter3Text:SetTextColor(1, 0.82, 0);
	BlueMapNoteOptions_Tab1Filter4Text:SetText("필  터");
	BlueMapNoteOptions_Tab1Filter4Text:SetTextColor(1, 0.82, 0);
	BlueMapNoteOptions_Tab1Filter5Text:SetText("필  터");
	BlueMapNoteOptions_Tab1Filter5Text:SetTextColor(1, 0.82, 0);
end

function BlueMapNote_InitializeMemo()
	BlueMapNote_InitializeItem(101, 106);
end

function BlueMapNote_InitializeHerb1()
	BlueMapNote_InitializeItem(201, 218);
end

function BlueMapNote_InitializeHerb2()
	BlueMapNote_InitializeItem(219, 299);
end

function BlueMapNote_InitializeOre()
	BlueMapNote_InitializeItem(301, 399);
end

function BlueMapNote_InitializeEct()
	BlueMapNote_InitializeItem(401, 499);
end

function BlueMapNote_InitializeItem(t1, t2)
	local info = {};
	local i;
	for i = t1, t2 do
		if (BMN.ResourceTexture[i]) then
			info.text = BlueMapNote_GetResourceName(i);
			info.func = BlueMapNote_CheckMenu;
			info.icon = BLUEMAPNOTE_ICON_PATH..BMN.ResourceTexture[i];
			info.keepShownOnClick = 1;
			info.arg1 = i;
			info.justifyH = "LEFT";
			if (BlueMapNoteOption.skip[i] == 1) then
				info.checked = nil;
			else
				info.checked = 1;
			end		
			UIDropDownMenu_AddButton(info);
		else
			return;
		end
	end
end

function BlueMapNote_CheckMenu(id)
	if (BlueMapNoteOption.skip[id]) then
		BlueMapNoteOption.skip[id] = nil;
	else
		BlueMapNoteOption.skip[id] = 1;
	end
	BlueMapNote_UpdateNotes();
end



function BlueMapNote_SelectTab(tab)
	for i = 1, getn(tabName) do
		getglobal("BlueMapNoteOptions_Tab"..i.."ButtonText"):SetTextColor(1, 1, 1);
		getglobal("BlueMapNoteOptions_Tab"..i.."Button"):SetBackdropBorderColor(1, 1, 1);
		getglobal("BlueMapNoteOptions_Tab"..i):Hide();
	end
	getglobal("BlueMapNoteOptions_Tab"..tab.."ButtonText"):SetTextColor(1, 0.82, 0);
	getglobal("BlueMapNoteOptions_Tab"..tab.."Button"):SetBackdropBorderColor(0.6, 0.6, 1);
	getglobal("BlueMapNoteOptions_Tab"..tab):Show();
	currTab = tab;
end

function BlueMapNote_LoadSetting()
	isLoaded = true;
	BlueMapNote_SetChecked(BlueMapNoteOption.memo.minimap, BlueMapNoteOptions_Tab1Button1);
	BlueMapNote_SetChecked(BlueMapNoteOption.memo.worldmap, BlueMapNoteOptions_Tab1Button2);
	BlueMapNote_SetChecked(BlueMapNoteOption.herb.minimap, BlueMapNoteOptions_Tab1Button3);
	BlueMapNote_SetChecked(BlueMapNoteOption.herb.worldmap, BlueMapNoteOptions_Tab1Button4);
	BlueMapNote_SetChecked(BlueMapNoteOption.ore.minimap, BlueMapNoteOptions_Tab1Button5);
	BlueMapNote_SetChecked(BlueMapNoteOption.ore.worldmap, BlueMapNoteOptions_Tab1Button6);
	BlueMapNote_SetChecked(BlueMapNoteOption.ect.minimap, BlueMapNoteOptions_Tab1Button7);
	BlueMapNote_SetChecked(BlueMapNoteOption.ect.worldmap, BlueMapNoteOptions_Tab1Button8);
end

function BlueMapNote_SetChecked(value, frame)
	if (value == 1) then
		frame:SetChecked(true);
	elseif (value == 0) then
		frame:SetChecked(false);
	end
end

function BlueMapNote_GetChecked(frame)
	if (frame:GetChecked()) then
		return 1;
	else
		return 0;
	end
end

function BlueMapNote_SaveSetting()
	BlueMapNoteOption.memo.minimap = BlueMapNote_GetChecked(BlueMapNoteOptions_Tab1Button1);
	BlueMapNoteOption.memo.worldmap = BlueMapNote_GetChecked(BlueMapNoteOptions_Tab1Button2);
	BlueMapNoteOption.herb.minimap = BlueMapNote_GetChecked(BlueMapNoteOptions_Tab1Button3);
	BlueMapNoteOption.herb.worldmap = BlueMapNote_GetChecked(BlueMapNoteOptions_Tab1Button4);
	BlueMapNoteOption.ore.minimap = BlueMapNote_GetChecked(BlueMapNoteOptions_Tab1Button5);
	BlueMapNoteOption.ore.worldmap = BlueMapNote_GetChecked(BlueMapNoteOptions_Tab1Button6);
	BlueMapNoteOption.ect.minimap = BlueMapNote_GetChecked(BlueMapNoteOptions_Tab1Button7);
	BlueMapNoteOption.ect.worldmap = BlueMapNote_GetChecked(BlueMapNoteOptions_Tab1Button8);
end