local convAddons = { "Gatherer", "MapNotes", "CT_MapMod" };
local mapZones = {};

function BlueMapNote_ConvertOldData()
	if (BlueMapNoteData == nil) then
		return;
	end
	local i;	
	for i = 1, 3000 do
		if (BlueMapNoteData[i]) then
			BlueMapNote_AddNewNote(BlueMapNoteData[i].zone, BlueMapNoteData[i].x, BlueMapNoteData[i].y, BlueMapNoteData[i].res, BlueMapNoteData[i].title, BlueMapNoteData[i].content);
		end
	end
	BlueMapNoteData = nil;
end

function BlueMapNote_ConvertData()
	local i, name, value;
	local n = { GetMapContinents() };
	mapZones = {};
	for i = 1, getn(n) do
		mapZones[i] = { GetMapZones(i) };
	end
	for i = 1, getn(convAddons) do
		if (IsAddOnLoaded(convAddons[i])) then
			BlueMapNote_ConvertFrame:Show();
			BlueMapNote_ConvSetText(convAddons[i]);
			if (getglobal("BlueMapNote_Conv"..convAddons[i])) then
				getglobal("BlueMapNote_Conv"..convAddons[i])();
			end
			BlueMapNote_ConvertFrame:Hide();
			DisableAddOn(convAddons[i]);
		end
	end
	BlueMapNote_UpdateNotes();
	if (BlueMapNote_ConvertFrame_TitleText:GetText() == BLUEMAPNOTE_MAJOR_VERSION) then
		BlueMapNote_ConvertFrame:Show();
		BlueMapNote_ConvertFrame_ContentsText:SetText("|cffffffff모든 자료를 성공적으로 변환했습니다.\nUI를 재시작해주세요!|r");
		BlueMapNote_ConvertFrame.closeTime = GetTime();
	end
end

function BlueMapNote_ConvSetText(addonName)
	BlueMapNote_ConvertFrame_TitleText:SetText(BLUEMAPNOTE_MAJOR_VERSION);
	BlueMapNote_ConvertFrame_Title:SetBackdropColor(0, 0, 1, 0.8);
	BlueMapNote_ConvertFrame_ContentsText:SetSpacing(8);
	BlueMapNote_ConvertFrame_ContentsText:SetText("|cffffff33"..addonName.."\n|cffffffff자료를 변환중입니다!\n잠시 기다려주세요.|r");
end

function BlueMapNote_ConvGatherer()
	local text = BlueMapNote_ConvertFrame_ContentsText:GetText().."\n|cff00ff00";
	local i, j, k, n, v, x, y, res, zone, name;
	for i = 1, getn(mapZones) do
		for j = 1, getn(mapZones[i]) do
			if (GatherItems and GatherItems[i] and GatherItems[i][j]) then
				zone = mapZones[i][j];
				for n, v in pairs(GatherItems[i][j]) do
					if (n and BMN.Resource[BlueMapNote_GetResOName(n)]) then
						name = BlueMapNote_GetResOName(n);
						res = BMN.Resource[name];
						for k = 1, getn(v) do
							if (v[k]) then
								x = v[k].x;
								y = v[k].y;
								BlueMapNote_ConvertFrame_ContentsText:SetText(text..name.."\n"..zone.." ("..x..", "..y..")");
								BlueMapNote_AddNewNote(zone, x, y, res);
							end
						end
					end
				end
			end
		end
	end
end

function BlueMapNote_ConvMapNotes()
	local icon = { 101, 102, 103, 101, 102, 104, 105, 106, 104, 105 };
	local text = BlueMapNote_ConvertFrame_ContentsText:GetText().."\n|cff00ff00";
	local i, j, k, x, y, res, zone, title, content;
	for i = 1, getn(mapZones) do
		for j = 1, getn(mapZones[i]) do
			if (MapNotes_Data and MapNotes_Data[i] and MapNotes_Data[i][j]) then
				zone = mapZones[i][j];
				for k = 1, getn(MapNotes_Data[i][j]) do
					if (MapNotes_Data[i][j][k]) then
						x, y = BlueMapNote_ConvPosition(MapNotes_Data[i][j][k].xPos, MapNotes_Data[i][j][k].yPos);
						title = MapNotes_Data[i][j][k].name;
						res = icon[MapNotes_Data[i][j][k].icon + 1];
						content = "";
						if (MapNotes_Data[i][j][k].inf1 ~= "") then
							content = content..MapNotes_Data[i][j][k].inf1;
						end
						if (MapNotes_Data[i][j][k].inf2 ~= "") then
							content = content.."^"..MapNotes_Data[i][j][k].inf2;
						end
						BlueMapNote_ConvertFrame_ContentsText:SetText(text..title.."\n"..zone.." ("..x.." "..y..")");
						BlueMapNote_AddNewNote(zone, x, y, res, title, content);
					end
				end
			end
		end
	end
end

function BlueMapNote_ConvCT_MapMod()
	local text = BlueMapNote_ConvertFrame_ContentsText:GetText().."\n|cff00ff00";
	local i, j, k, zone, res, x, y, name;
	for i = 1, getn(mapZones) do
		for j = 1, getn(mapZones[i]) do
			zone = mapZones[i][j];
			if (CT_UserMap_Notes and CT_UserMap_Notes[zone]) then
				for k = 1, getn(CT_UserMap_Notes[zone]) do
					if (CT_UserMap_Notes[zone][k]) then
						name = BMN.Resource[BlueMapNote_GetResOName(CT_UserMap_Notes[zone][k].name)];
						if (name) then
							x, y = BlueMapNote_ConvPosition(CT_UserMap_Notes[zone][k].x, CT_UserMap_Notes[zone][k].y);							
							res = BMN.Resource[name];						
							BlueMapNote_ConvertFrame_ContentsText:SetText(text..name.."\n"..zone.." ("..x..", "..y..")");
							BlueMapNote_AddNewNote(zone, x, y, res);							
						end
					end
				end
			end
		end
	end
end

function BlueMapNote_ConvPosition(x, y)
	return tonumber(format("%.2f", x * 100.0)), tonumber(format("%.2f", y * 100.0));
end

function BlueMapNote_AddNewNote(zone, x, y, res, title, content)
	local i;
	local n = BlueMapNote_NextDBN(zone);
	if (title == nil) then
		for i = 1, n - 1 do
			if (BlueMapNoteDB[zone][i].x == x and BlueMapNoteDB[zone][i].y == y and BlueMapNote_GetResourceTypeText(BlueMapNoteDB[zone][i].res) == "memo") then
				return;
			end
		end
		BlueMapNoteDB[zone][n] = { x = x, y = y, res = res };
	elseif (BlueMapNote_IsSameRes(zone, x, y, res) == 0) then
		BlueMapNoteDB[zone][n] = { x = x, y = y, res = res, title = title, content = content };
	end
end