﻿BINDING_HEADER_NUGUDROP = "누구드랍";
BINDING_NAME_NUGUDROPTOGGLE = "누구드랍 리스트 열기/닫기";
ND_Version = "2.4"

if (not NuguDropOption) then
	NuguDropOption = {};
end

if (not NuguDropOption["NuguDropButtonPos"]) then
	NuguDropOption["NuguDropButtonPos"] = -70;
end

-- 사전(1)/캐시(0) 어느것을 참조할 것인가 선택하는 변수
if (not NuguDropOption["ND_whatref"]) then
	NuguDropOption["ND_whatref"] = 0;
end

if (not NuguDropOption["SelectedTab"]) then
	NuguDropOption["SelectedTab"] = 1;
end

local NuguDropColor = { r=0, g=0.7, b=1 };

function NuguDrop_OnLoad()
	SlashCmdList["NuguDropCOMMAND"] = NuguDrop_SlashCmd
	SLASH_NuguDropCOMMAND1 = "/nd"
	SLASH_NuguDropCOMMAND2 = "/누구드랍"

	DEFAULT_CHAT_FRAME:AddMessage("|cffff9C00누구드랍? v.2.4 (시링크스흑마/아크투르스주술 of 렉사르)|r");
end

function NuguDrop_SlashCmd(msg)
	local cmd = gsub(msg, "%s*([^%s]+).*", "%1");

	if ( strlen(cmd) <= 0 ) then
		NuguDropListFrame_OnShow();
		NuguDrop_HelpMsg();
		return;
	end

	if ( cmd == "사전" ) then
		ND_CheckDic();
		if (dic_chk ~= 5 ) then
			NuguDropOption.ND_whatref = 1;
			NuguDrop_Print("이제부터 보유하고 있는 사전의 정보를 참조합니다.");
			ND_SpamCheck = 2;
			return;
		else
			NuguDropOption.ND_whatref = 0;
			NuguDrop_Print("현재 아이템사전이 없거나 보유하고 있는 정보가 없습니다.");
			NuguDrop_Print("계속해서 캐시의 정보를 참조하게 합니다.");
			ND_SpamCheck = 2;
			return;
		end			
	elseif  ( cmd == "캐시" ) then
		NuguDropOption.ND_whatref = 0;
		NuguDrop_Print("이제부터 캐시의 정보를 참조합니다.");
		ND_SpamCheck = 2;
		return;
	elseif  ( cmd == "미니맵" ) then
		NuguDropButton_Toggle();
	else
		NuguDrop_HelpMsg();
	end
end

function NuguDrop_HelpMsg()
	NuguDrop_Print("|cffff0000━━━━━━━━━━━━━━|r");
	NuguDrop_Print("/누구드랍 사전 : 보유한 사전정보를 참조합니다.");
	NuguDrop_Print("/누구드랍 캐시 : 캐시정보를 참조합니다.");
	NuguDrop_Print("/누구드랍 미니맵 : 미니맵 아이콘 보기/감추기");
	NuguDrop_Print("|cffff0000━━━━━━━━━━━━━━|r");
end

function NuguDrop_GetComment(info, i)
        local comment = nil
	if (info[i])then
	        comment = "|cffffffa4"..info[i].."|r";
	        if (info[i+1]) then
	                comment = comment.."|cffffffff-|r|cff00ffff"..info[i+1].."|r".." |cffffBC00<";
	                if (info[i+2]) then
				if (jul_check == 1) then
		                        comment = comment.."학카르"..">|r";
				elseif (jul_check == 0) then
		                        comment = comment.."혈군주 만도키르"..">|r";
				elseif (jul_check == nil) then
		                        comment = comment..info[i+2]..">|r";
				end
	                end
	        end
	end
        return comment;
end

function NuguDrop_AddLine(tooltip, comment)
        if (comment) then
		tooltip:AddLine(comment, NuguDropColor.r, NuguDropColor.g, NuguDropColor.b);
		return true;
	else
	        return false;
	end
end

function NuguDrop_OnShow(tooltipString)
        local tooltip = getglobal(tooltipString);
        local textLeft1 = getglobal(tooltipString.."TextLeft1");
	jul_check = nil;

	if (not tooltip) or (not textLeft1) then
                return;
        end
	local firstLine = textLeft1:GetText();
	-- 스킬명/몹이름/버프명 이 동일한 경우 체크구문
	if ((firstLine == "의지의 힘") or (firstLine == "무력의 손길") or (firstLine == "영혼의 약탈자") or (firstLine == "폭풍의 눈")
		or (firstLine == "수정거미 송곳니") or (firstLine == "자연의 은총") or (firstLine == "퀴라지 학살자")) then
	        local textLeft2 = getglobal(tooltipString.."TextLeft2");
	        if textLeft2 then
			local secondLine = getglobal(tooltipString.."TextLeft2"):GetText();
			if secondLine then
				-- 아이템의 경우 2번째 줄을 항상 착용시 귀속/획득시 귀속/귀속 아이템 으로 나오므로
				-- 공통인자인 "귀속"이란 단어로 체크
				if (string.find(secondLine, "귀속") == nil) then return;
				end
			else
			-- 툴팁 2번째 줄이 없는경우
				return;
			end
		else return;
		end
	end
	-- 줄구룹 학카르/만도키르 드랍인 "학카리 전투검" 아이템명 동일하므로 처리루틴 추가
	if (firstLine == "학카리 전투검") then
	        local fourthLine = getglobal(tooltipString.."TextLeft4"):GetText();
		if fourthLine == "주장비" then
			jul_check = 1;
		else
			jul_check = 0;
		end
	end
	local change = false;
	if firstLine and NuguDrop and NuguDropCustom then
		-- 울다만 / 나락 드랍템의 아이템명이 같으므로 따로 처리
		if (string.find(firstLine, "(.+)의 바위주먹")) then firstLine = "의 바위주먹" end
	        if NuguDrop[firstLine] then
	                if NuguDrop_AddLine(tooltip, NuguDrop_GetComment(NuguDrop[firstLine], 1)) == true then
        	                change = true;
        	        end
	        elseif NuguDropCustom[firstLine] then
	                if NuguDrop_AddLine(tooltip, NuguDrop_GetComment(NuguDropCustom[firstLine], 1)) == true then
        	                change = true;
        	        end
	        end
	        if NuguDropCustom[firstLine] then
	                if NuguDrop_AddLine(tooltip, NuguDrop_GetComment(NuguDropCustom[firstLine], 4)) == true then
        	                change = true;
        	        end
	        end
		if (not change) then
			local _, _, CheckOther, CheckRandomPreOption = string.find(firstLine, "(.[^%s]+)의 (.+)")
			-- 한어절로 된 혈장 드랍템 "어깨갑옷" 아이템과 일반 아이템 비교 체크
			if ((CheckOther == "약탈자") or (CheckOther == "집행자") or (CheckOther == "학살자") or (CheckOther == "암흑문지기")
				or (CheckOther == "논쟁") or (CheckOther == "영웅") or (CheckOther == "정") or (CheckOther == "냉혹")
				or (CheckOther == "지휘관") or (CheckOther == "인내") or (CheckOther == "고행") 
				or (CheckOther == "무용") or (CheckOther == "성령") or (CheckOther == "우레") or (CheckOther == "검은장막")		-- 업글셋
				or (CheckOther == "관통") or (CheckOther == "응징") or (CheckOther == "정복자") or (CheckOther == "폭풍소환사")	-- 안퀴셋
				-- 낙스 드랍몹이 정해질 경우 아래라인은 삭제
				or (CheckOther == "복원") or (CheckOther == "격노") or (CheckOther == "신념") or (CheckOther == "무쌍") or (CheckOther == "해골사신") or (CheckOther == "지축이동"))	-- 낙스셋
				and CheckRandomPreOption == "어깨갑옷" then
				change = false;
			-- 뼈고리 투구 체크 : 왜 이것만 ? -_-
			elseif ((CheckOther == "곰") or (CheckOther == "매") or (CheckOther == "늑대") or (CheckOther == "고래")
				or (CheckOther == "원숭이") or (CheckOther == "독수리") or (CheckOther == "맷돼지"))
				and CheckRandomPreOption == "뼈고리 투구" then
				change = false;
			-- ~의 아이템 처리
			elseif CheckRandomPreOption and NuguDrop[CheckRandomPreOption] then
				if NuguDrop_AddLine(tooltip, NuguDrop_GetComment(NuguDrop[CheckRandomPreOption], 1)) == true then
			                change = true;
        		        end
			end
			-- [랜덤속성] 저항'의' 열'의' 투구 체크 : "의"자가 2개 들어가서 생기는 -_-ㅋ
			local _, _, RRegist, YHead = string.find(firstLine, "(.+) 저항의 (.+)")
			if (YHead == "열의 투구") and (not change) then
				if NuguDrop_AddLine(tooltip, NuguDrop_GetComment(NuguDrop[YHead], 1)) == true then
			                change = true;
        		        end
			end
		end

	end
	if change then
		tooltip:Show();
	end
end

