﻿SelectedZone = nil;
SelectedMob = nil;
ND_SpamCheck = 2;

ITEM_QUALITY_HEXCOLORS = {};
for i = -1, 6 do
	_, _, _, ITEM_QUALITY_HEXCOLORS[i] = GetItemQualityColor(i);
end

-----------------------------
-- 기본 화면 출력 함수
-----------------------------
function NuguDrop_Print(text)
	if (text) then DEFAULT_CHAT_FRAME:AddMessage("|cffff8000<누구드랍>"..FONT_COLOR_CODE_CLOSE..": "..text); end
end

-----------------------------
function ND_CheckTab()
	NuguDropZoneList = {};
	NuguDropMobList = {};
	if (NuguDropOption["SelectedTab"] == 1) then
		NuguDropZoneList = NuguDropZoneList_Orig;
		NuguDropMobList = NuguDropMobList_Orig;
	else
		NuguDropZoneList = NuguDropZoneList_Exp;
		NuguDropMobList = NuguDropMobList_Exp;
	end
end

function ND_FlushZoneList()
	local listsize1 = table.getn(NuguDropZoneList);
	for n=1,listsize1 do
		getglobal("NuguDropZone"..n):Hide();
	end
	if (SelectedZone) then
		local listsize2 = table.getn(NuguDropMobList[NuguDropZoneList[SelectedZone]]);
		for n=1,listsize2 do
			getglobal("NuguDropMob"..n):UnlockHighlight();
			getglobal("NuguDropMob"..n.."_Text"):SetText("");
			getglobal("NuguDropMob"..n):Disable();
			getglobal("NuguDropMob"..n):Hide();
		end
	end
	if (SelectedMob) then
		if (ND_Temp_Itemname) then
			local listsize3 = table.getn(ND_Temp_Itemname);
			for n=1,listsize3 do
				getglobal("NuguDropItem"..n):Hide();
			end
		end
	end
	SelectedZone = nil;
	SelectedMob = nil;
end


--------------------------------------------------
--[[ 사전 종류 체크 ]]
--------------------------------------------------
function ND_CheckDic()
	-- 0. 최신버전 아이템싱크(ItemSync v12 이상)
	if (ISYNC_VERSION) and (ISyncDB) then
		if (ISYNC_VERSION >= 12) then
			dic_chk = 0;
	-- 1. 구버전 아이템싱크(v12 이전)
		else
			dic_chk = 1;
		end
	-- 2. LootLink enhanced
	elseif (LOOTLINK_VERSION) and (ItemLinks) then
		-- LootLink enhanced 버전일 경우 미니맵 아이콘이 있으므로.. 그중 X 좌표값이 존재하는지 체크
		if (LootLinkState.x) then
			dic_chk = 2;
	-- 3. NOT Enhanced LootLink (하늘아리)
		else
			dic_chk = 3;
		end
	-- 4. KC_Items와 LinkView모듈이 활성화 된경우 챗창에 표시 (by Creep7)
	elseif (KC_ITEMS_LOCALS) and (KC_ITEMS_LOCALS.modules.linkview) then
		dic_chk = 4;                
	-- 5. 아이템사전이 없는경우
	else dic_chk = 5;
	end
end

function NuguDropListFrame_OnShow()
	PlaySound("igMainMenuOpen");
	if NuguDrop then
		NuguDropListFrame:Show();
		NuguDropListFrameZoneList:Show();
		if NuguDropListFrameMobList:IsVisible() then
			NuguDropListFrameMobList:Hide();
			if NuguDropListFrameItemList:IsVisible() then
				NuguDropListFrameItemList:Hide();
			end
		end
		ND_CheckDic();
		NuguDropListFrame_ZoneList();
	else
		NuguDropListFrame:Hide();
		NuguDropListFrameMobList:Hide();
	end
	-- Escape Key 로 NuguDrop의 닫을 수 있도록 해 줍니다. (By icecre4m)
	tinsert(UISpecialFrames,"NuguDropListFrame"); 
end

function NuguDropListFrame_OnHide()
	PlaySound("igMainMenuClose");
	NuguDropListFrameCloseButton_OnClick();
end

function NuguDropListFrame_OnLoad()
--[[	if (not NuguDropOption["ND_whatref"]) then
		NuguDropOption["ND_whatref"] = 0; -- 사전(1)/캐시(0) 어느것을 참조할 것인가 선택하는 변수
	end
]]
end

function NuguDropListFrame_OnMouseDown(arg1) if arg1=="LeftButton" then NuguDropListFrame:StartMoving(); end end
function NuguDropListFrame_OnMouseUp(arg1) if arg1=="LeftButton" then NuguDropListFrame:StopMovingOrSizing(); end end

function NuguDropListFrameCloseButton_OnClick()
	NuguDropListFrame_Close();
--	NuguDropListFrameMobList:Hide();
--	NuguDropListFrameItemList:Hide();
end

function NuguDropListFrame_Close()
	NuguDropListFrame:StopMovingOrSizing();
	HideUIPanel(NuguDropListFrame);
end


function NuguDropListFrame_Toggle()
	if(NuguDropListFrame:IsVisible()) then
		HideUIPanel(NuguDropListFrame);
	else
		ShowUIPanel(NuguDropListFrame);
	end
end

-----------------------------------
-- Zone을 출력하는 부분
-----------------------------------
function NuguDropListFrame_ZoneList()
	ND_CheckTab()
	local i = table.getn(NuguDropZoneList);
	for n=1,i do
		getglobal("NuguDropZone"..n):UnlockHighlight();
		NuguDropListFrame_ZoneInsert(n, NuguDropZoneList[n]);
	end
	NuguDropListFrameZoneList:SetHeight(18 + (18*i));
end

function NuguDropListFrame_ZoneInsert(n, zonename)
	local ZoneButton = getglobal("NuguDropZone"..n);
	local ZoneText = getglobal("NuguDropZone"..n.."_Text");
	ZoneText:SetText(zonename);
	-- 색 구분
	if (string.find(zonename, "<공>")) or (string.find(zonename, "필드")) or (string.find(zonename, "실리더스")) or (string.find(zonename, "퀘스트")) or (string.find(zonename, "기타")) or (string.find(zonename, "명예"))then
		ZoneText:SetTextColor(1, 0.7, 0, 1);
	else
		ZoneText:SetTextColor(1, 1, 0.7, 1);
	end
	ZoneButton:Enable();
	ZoneButton:Show();
end

-- 특정 Zone 을 선택했을때
function NuguDropZoneButton_OnClick(zone)
	if (not NuguDropZoneList) then return; end
	if (SelectedZone) then
		getglobal("NuguDropZone"..SelectedZone):UnlockHighlight();
		local i = table.getn(NuguDropMobList[NuguDropZoneList[SelectedZone]]);
		for n=1,i do
			getglobal("NuguDropMob"..n):UnlockHighlight();
			getglobal("NuguDropMob"..n.."_Text"):SetText("");
			getglobal("NuguDropMob"..n):Disable();
			getglobal("NuguDropMob"..n):Hide();
		end
	end
	SelectedZone = zone;
	getglobal("NuguDropZone"..zone):LockHighlight();
	-- 몹 리스트 출력
	if (not NuguDropListFrameMobList:IsVisible()) then
		NuguDropListFrameMobList:Show();
		NuguDropListFrame_MobList(SelectedZone);
	else
		NuguDropListFrame_MobList(SelectedZone);
	end
	-- 아이템 리스트가 있으면 숨긴다
--	if NuguDropListFrameItemList:IsVisible() then
		NuguDropListFrameItemList:Hide();
--	end
end

-----------------------------------
-- Mob을 출력하는 부분
-----------------------------------
function NuguDropListFrame_MobList(SelectedZone)
	local i2 = table.getn(NuguDropMobList[NuguDropZoneList[SelectedZone]]);
	for n=1,i2 do
		NuguDropListFrame_MobInsert(n, NuguDropMobList[NuguDropZoneList[SelectedZone]][n]);
	end
	NuguDropListFrameMobList:SetHeight(18 + (18*i2));
end

function NuguDropListFrame_MobInsert(n, Mobname)
	local MobButton = getglobal("NuguDropMob"..n);
	local MobText = getglobal("NuguDropMob"..n.."_Text");
	MobText:SetText(Mobname);
	-- 희귀몹/일반몹/퀘소환몹/기타 색깔변경
	if (string.find(Mobname, "희귀")) or (string.find(Mobname, "퀘")) or (string.find(Mobname, "광란의경계")) or (string.find(Mobname, "중급")) or (string.find(Mobname, "장군의 정원")) or (string.find(Mobname, "중간보스")) or (string.find(Mobname, "only")) then
		MobText:SetTextColor(0.8, 0.8, 1, 1);
	elseif (string.find(Mobname, "일반")) or (string.find(Mobname, "상자")) or (string.find(Mobname, "공물함")) or (string.find(Mobname, "공통")) or (string.find(Mobname, "상급")) then
		MobText:SetTextColor(0.4, 0.9, 0.7, 1);
	elseif (string.find(Mobname, "세트")) then
		MobText:SetTextColor(0.8, 0.8, 1, 1);
	-- 낙스 지역 구분 
	elseif (string.find(Mobname, "골렘 전당")) then
		MobText:SetTextColor(0.5, 0.8, 0.5, 1);	
	elseif (string.find(Mobname, "거미 전당")) then
		MobText:SetTextColor(0.8, 0.8, 1, 1);	
	elseif (string.find(Mobname, "기사단 전당")) then
		MobText:SetTextColor(0.8, 0.5, 0.5, 1);	
	elseif (string.find(Mobname, "역병 전당")) then
		MobText:SetTextColor(0.8, 0.5, 0.8, 1);
	else
		MobText:SetTextColor(1, 0.7, 0.7, 1);
	end
	MobButton:Enable();
	MobButton:Show();
end

-- 특정 Mob 을 선택했을 때
function NuguDropMobButton_OnClick(Mob)
	if (not NuguDropMobList) then return; end
	if (SelectedMob) then
		getglobal("NuguDropMob"..SelectedMob):UnlockHighlight();
		if (ND_Temp_Itemname) then
			i3 = table.getn(ND_Temp_Itemname);
			for n=1,i3 do
				getglobal("NuguDropItem"..n):Hide();
			end
		end
	end
	SelectedMob = Mob;
	getglobal("NuguDropMob"..Mob):LockHighlight();
	if NuguDropListFrameItemList:IsVisible() then
		NuguDropListFrame_ItemList(SelectedMob);
	else
		NuguDropListFrameItemList:Show();
		NuguDropListFrame_ItemList(SelectedMob);
	end
end

-----------------------------------
-- Item을 출력하는 부분
-----------------------------------
function NuguDropListFrame_ItemList(SelectedMob)
	local ZoneText = getglobal("NuguDropZone"..SelectedZone.."_Text"):GetText();
	local MobText = getglobal("NuguDropMob"..SelectedMob.."_Text"):GetText();
	local cnt=0;				-- 선택한 몹이 드랍하는 아이템수
	local NuguDropTcont=0;		-- 전체 아이템수
	ND_Temp_Itemname = {};		-- 선택한 몹의 드랍템 임시저장(다른몹 선택시 프레임에 뿌려져 있는걸 지우기 위해서 필요)
	ND_Cache_ItemNums = {};	-- 선택한 몹의 아이템ID 임시저장

--	NuguDrop_Print("|cffff0000━━━━━━━━━━━━━━|r");
--	NuguDrop_Print("|cffffd600선택한 존 : "..ZoneText.."|r");
--	NuguDrop_Print("|cff00ffff선택한 몹 : "..MobText.."|r");
--	NuguDrop_Print("ND_whatref 사전(1)/캐시(0): "..NuguDropOption.ND_whatref);

	for ND_Itemname, ND_Iteminfo in pairs(NuguDrop) do
		NuguDropTcont = NuguDropTcont + 1;
		-- "학카리 전투검" 동일한 아이템명 체크 ( 실패 -_-X)
--[[		if (ND_Itemname == "학카리 전투검") then
			if ( (MobText == "혈군주 만도키르") and (ND_Iteminfo[3] == "학카르") ) then
				ND_Iteminfo[3] = "혈군주 만도키르"
			else
				ND_Iteminfo[3] = "학카르"
			end
		end
]]
		-- NuguDrop 에서 해당존의 해당몹 체크하여.. [3] 부분만 추출
		if ( (ND_Iteminfo[2] == ZoneText) and (ND_Iteminfo[3] == MobText) )
			-- 도면정보를 보여주기 위한 조건문
			or -- (SelectedZone == 31) and
			(string.find( ND_Itemname, MobText..": " )) then
			-- 갯수파악
			cnt = cnt + 1;
			----------------------------------------------------------------------
			--[[ 사전이 없거나 캐시정보를 참조하고자 할 경우 ]]
			if (NuguDropOption.ND_whatref == 0) or (dic_chk == 5) then
				-- 캐시로부터 생성한 데이터가 없을경우 생성
				if (not ND_Cache_ItemsAll) then
					NuguDrop_ItemDB_BuildItemsAll();
				end
				-- 캐시로부터 데이터를 갱신한지 5분이 지난경우 다시 아이템데이터 생성
				if (time() - NuguDrop_ItemDB_last_rebuild > 300) then
					NuguDrop_ItemDB_BuildItemsAll();
				end

				local i4 = table.getn(ND_Cache_ItemsAll);
				for n=1,i4 do
					local itemName, itemLink, itemRarity = GetItemInfo(ND_Cache_ItemsAll[n]);
					if ( itemName ) then
						if (itemName == ND_Itemname) then
							-- 해당 아이템의 ID 저장
							table.insert(ND_Cache_ItemNums, ND_Cache_ItemsAll[n]);
							NuguDropCache_SWITCH = 1;
							break;
						else
							NuguDropCache_SWITCH = 2;
						end
					end
				end
				if NuguDropCache_SWITCH == 2 then
					--아무 아이템의 ID 저장 : 빈자리 채우기 >_< 
					table.insert(ND_Cache_ItemNums, ND_Cache_ItemsAll[1]);
				end
			end
			----------------------------------------------------------------------
			-- 현재 선택한 몹의 드랍템리스트를 임시로 저장
			ND_Temp_Itemname[cnt] = ND_Itemname;

			-- 매칭된 갯수만큼 아이템버튼 보이기
			local ItemButton = getglobal("NuguDropItem"..cnt);
			local ItemText = getglobal("NuguDropItem"..cnt.."_Text");
			----------------------------------------------------------------------
			--[[ NuguDropListFrameItemList 에 표시하는 부분 ]]--
			----------------------------------------------------------------------
			if (NuguDropOption.ND_whatref == 1) then
				-- 1. 최신버전 아이템싱크(ItemSync v12 이상)
				if (dic_chk == 0) then
					ItemText:SetText(ISync:FetchLink_ParseChatMSG("["..ND_Itemname.."]"));

				-- 1. 구버전 아이템싱크(ItemSync)
				elseif (dic_chk == 1) then
					ItemText:SetText(ISyncCore_ParseChatMSG("["..ND_Itemname.."]"));

				-- 2. LootLink enhanced
				elseif (dic_chk == 2) then
					ItemText:SetText(LootLink_TypeLinks_ParseChatMessage("["..ND_Itemname.."]"));

				-- 3. NOT Enhanced LootLink (하늘아리)
				elseif (dic_chk == 3) then
					ItemText:SetText(ND_LootLink_TypeLinks_ParseChatMessage("["..ND_Itemname.."]"));

				-- 4. KC_Items와 LinkView모듈이 활성화 된경우
				elseif (dic_chk == 4) then
					ItemText:SetText(NuguDropGetKC_ItemsLink(ND_Itemname));
				end
			end
			-- 5. 아이템사전이 없거나 캐시를 사용하고자 할 경우
			if (NuguDropOption.ND_whatref == 0) or (dic_chk == 5) then
				local i5 = table.getn(ND_Cache_ItemNums);
				for n=1,i5 do
					local itemName, itemLink, itemRarity = GetItemInfo(ND_Cache_ItemNums[n]);
					if ( itemName ) then
						if (itemName == ND_Itemname) then
						--	ItemText:SetText(ITEM_QUALITY_HEXCOLORS[itemRarity].."|H"..itemLink.."|h["..itemName.."]|h|r");
							ItemText:SetText(itemLink);
							NuguDropCache_SWITCH = 1;
							break;
						else
							NuguDropCache_SWITCH = 2;
						end
					end
				end
				if NuguDropCache_SWITCH == 2 then
					ItemText:SetText(ND_Itemname);
				end
			end

		ItemButton:Enable();
		ItemButton:Show();
		end
	end	-- for 문 끝

	if (ND_Temp_Itemname) then
		if (NuguDropOption.ND_whatref == 1) then
			if (ND_SpamCheck > 0) then
			if dic_chk == 0 then
				NuguDrop_Print("|cffffdfab참고한 아이템사전 : |r".."ItemSync v"..ISYNC_VERSION);
			elseif dic_chk == 1 then
				NuguDrop_Print("|cffffdfab참고한 아이템사전 : |r".."ItemSync v"..ISYNC_VERSION);
			elseif dic_chk == 2 then
				NuguDrop_Print("|cffffdfab참고한 아이템사전 : |r".."Enhanced LootLink");
			elseif dic_chk == 3 then
				NuguDrop_Print("|cffffdfab참고한 아이템사전 : |r".."NOT Enhanced LootLink (하늘아리)");
			elseif dic_chk == 4 then
				NuguDrop_Print("|cffffdfab참고한 아이템사전 : |r".."KC_Items");
			end
			end
			ND_SpamCheck = ND_SpamCheck  - 1;
		end
		if (NuguDropOption.ND_whatref == 0) or (dic_chk == 5) then
			if (ND_SpamCheck > 0) then
				NuguDrop_Print("|cffffdfab참고한 아이템사전 : |r".."와우캐시로부터 생성");
				ND_SpamCheck = ND_SpamCheck - 1;
			end
		end
--		NuguDrop_Print("|cffffffab선택한 몹이 드랍하는 아이템수: |r"..table.getn(ND_Temp_Itemname));
	end
	NuguDropListFrameItemList:SetHeight(18 + (18*cnt));
--	NuguDrop_Print("|cff1eff00전체 등록된 아이템수 : |r"..NuguDropTcont);
--	NuguDrop_Print("|cffff0000━━━━━━━━━━━━━━|r");
end


-----------------------------------------
-- KC_Items 사용의 경우, 해당 Item에 대한 Link 반환함수 (By Creep7)
-----------------------------------------
function NuguDropGetKC_ItemsLink(ItemName)
	local KC_FIX_NAME, KC_FIX_LINK, KC_FIX_ID, KC_FIX_SWITCH = nil;
	for KC_FIX_ID in pairs(KC_ItemsDB) do
		KC_FIX_NAME = GetItemInfo(KC_FIX_ID)
		if ItemName == KC_FIX_NAME then
			KC_FIX_NAME, KC_FIX_LINK, KC_FIX_QUALITY = GetItemInfo(KC_FIX_ID);
			_,_,_,KC_FIX_COLOR = GetItemQualityColor(KC_FIX_QUALITY);
			KC_FIX_ITEMLINK = string.format("%s|H%s|h[%s]|h|r",KC_FIX_COLOR, KC_FIX_LINK, KC_FIX_NAME);
			KC_FIX_SWITCH = 1;
			break;
		else
			KC_FIX_ITEMLINK = ItemName;
			KC_FIX_SWITCH = 2;
		end
	end
	return KC_FIX_ITEMLINK;
end

-----------------------------------------
-- Item을 Shift + Click 했을 때 채팅창으로 링크
-----------------------------------------
function NuguDropItemButton_OnClick(SelectedItemIdx)
	ND_Itemname = ND_Temp_Itemname[SelectedItemIdx];
	-- 쉬프트+클릭이고, 채팅입력상태로 되어있을 때.
	if ( IsShiftKeyDown() and ChatFrameEditBox:IsVisible() ) then
		-- 아이템 정보 링크를 입력창에 넣어준다.
		if (NuguDropOption.ND_whatref == 1) then
			if (dic_chk == 0) then
				ChatFrameEditBox:Insert(ISync:FetchLink_ParseChatMSG("["..ND_Itemname.."]"));
			elseif (dic_chk == 1) then
				ChatFrameEditBox:Insert(ISyncCore_ParseChatMSG("["..ND_Itemname.."]"));
			elseif (dic_chk == 2) then
				ChatFrameEditBox:Insert(LootLink_TypeLinks_ParseChatMessage("["..ND_Itemname.."]"));
			elseif (dic_chk == 3) then
				ChatFrameEditBox:Insert(ND_LootLink_TypeLinks_ParseChatMessage("["..ND_Itemname.."]"));
			elseif (dic_chk == 4) then
				ChatFrameEditBox:Insert(NuguDropGetKC_ItemsLink(ND_Itemname));
			end
		end
		if (NuguDropOption.ND_whatref == 0) or (dic_chk == 5) then
			local itemName, itemLink, itemRarity = GetItemInfo(ND_Cache_ItemNums[SelectedItemIdx]);
			if ( itemName ) then
				if (itemName == ND_Itemname) then
--					ChatFrameEditBox:Insert(ITEM_QUALITY_HEXCOLORS[itemRarity].."|H"..itemLink.."|h["..itemName.."]|h|r", "|c%x+|H(item:%d+:%d+:%d+:%d+)|h%[.-%]|h|r")
-- 확팩 변경
					ChatFrameEditBox:Insert(itemLink)
				end
			end
		end
	-- 컨트롤+클릭시 미리입어보기 (by djxcrash)
	elseif ( IsControlKeyDown()) then
		if (dic_chk == 0) then
			DressUpItemLink(ISync:FetchLink_ParseChatMSG("["..ND_Itemname.."]"));
		elseif (dic_chk == 1) then
			DressUpItemLink(ISyncCore_ParseChatMSG("["..ND_Itemname.."]"));
		elseif (dic_chk == 2) then
			DressUpItemLink(LootLink_TypeLinks_ParseChatMessage("["..ND_Itemname.."]"));
		elseif (dic_chk == 3) then
			DressUpItemLink(ND_LootLink_TypeLinks_ParseChatMessage("["..ND_Itemname.."]"));
		elseif (dic_chk == 4) then
			DressUpItemLink(NuguDropGetKC_ItemsLink(ND_Itemname));
		elseif (dic_chk == 5) then
			local itemName, itemLink, itemRarity = GetItemInfo(ND_Cache_ItemNums[SelectedItemIdx]);
			if ( itemName ) then
				if (itemName == ND_Itemname) then
--					DressUpItemLink(ITEM_QUALITY_HEXCOLORS[itemRarity].."|H"..itemLink.."|h["..itemName.."]|h|r", "|c%x+|H(item:%d+:%d+:%d+:%d+)|h%[.-%]|h|r")
-- 확팩 변경
					DressUpItemLink(itemLink)
				end
			end
		end
	end
end

-----------------------------------------
-- Item을 MouseOver 했을 때 ToolTip 표시
-----------------------------------------
function NuguDropItemButton_OnEnter(SelectedItemIdx)
	ND_Itemname = ND_Temp_Itemname[SelectedItemIdx];
	if (NuguDropOption.ND_whatref == 1) then
		-- 0. 최신버전 아이템싱크(ItemSync v12 이상)
		if (dic_chk == 0) then
			local link = ISync:FetchLink_ParseChatMSG("["..ND_Itemname.."]");
			NuguDrop_ShowToolTip(link, SelectedItemIdx);

		-- 1. 구버전 아이템싱크(ItemSync)
		elseif (dic_chk == 1) then
			local link = ISyncCore_ParseChatMSG("["..ND_Itemname.."]");
			NuguDrop_ShowToolTip(link, SelectedItemIdx);

		-- 2. LootLink enhanced
		elseif (dic_chk == 2) then
			local link = LootLink_TypeLinks_ParseChatMessage("["..ND_Itemname.."]");
			NuguDrop_ShowToolTip(link, SelectedItemIdx);

		-- 3. NOT Enhanced LootLink (하늘아리)
		elseif (dic_chk == 3) then
			local link = ND_LootLink_TypeLinks_ParseChatMessage("["..ND_Itemname.."]");
			NuguDrop_ShowToolTip(link, SelectedItemIdx);

		-- 4. KC_Items
		elseif (dic_chk == 4) then
			NuguDrop_ShowToolTip(NuguDropGetKC_ItemsLink(ND_Itemname), SelectedItemIdx);
		end
	end
	-- 5. 아이템사전이 없거나 캐시정보를 참조하고자 할 경우
	if (NuguDropOption.ND_whatref == 0) or (dic_chk == 5) then
		local itemName, itemLink, itemRarity = GetItemInfo(ND_Cache_ItemNums[SelectedItemIdx]);
		if ( itemName ) then
			if (itemName == ND_Itemname) then
--				local link = ITEM_QUALITY_HEXCOLORS[itemRarity].."|H"..itemLink.."|h["..itemName.."]|h|r";
-- 확팩 변경
				NuguDrop_ShowToolTip(itemLink, SelectedItemIdx);
			end
		end
	end
end

-----------------------------
-- Item 위에서 마우스 치웠을 때 
-----------------------------
function NuguDropItemButton_OnLeave()
	GameTooltip:Hide();
	NuguDropTooltipIcon:Hide();
end

-----------------------------------------
-- ToolTip 표시함수
-----------------------------------------
function NuguDrop_ShowToolTip(link, SelectedItemIdx)
-- 확팩 변경
--	for itemID in string.gmatch(link, "|c%x+|Hitem:%d+:%d+:%d+:%d+|h%[.-%]|h|r") do
--	_,_, itemId = string.find(link, "item:(%d+):");
--		if (itemID) then
--			NuguDrop_Print(itemID)
--			NuguDrop_AddTooltipTexture(SelectedItemIdx, itemID);
-- 확팩 변경
			NuguDrop_AddTooltipTexture(SelectedItemIdx, link);
			GameTooltip:SetOwner(NuguDropTooltipIcon, "ANCHOR_NONE");
			GameTooltip:SetPoint("TOPLEFT", NuguDropTooltipIcon, "BOTTOMLEFT", -2, 3);
--			GameTooltip:SetHyperlink(itemID);
-- 확팩 변경
			GameTooltip:SetHyperlink(link);
			GameTooltip:Show();
--		end
--	end
end

-----------------------------
-- Item Icon 표시
-----------------------------
--function NuguDrop_AddTooltipTexture(SelectedItemIdx, itemID)
-- 확팩 변경
function NuguDrop_AddTooltipTexture(SelectedItemIdx, link)
--	if ( itemID ) then
	if ( link ) then
--		local _, _, _, _, _, _, _, _, itemTexture = GetItemInfo(itemID);
-- 확팩 변경
		local _, _, _, _, _, _, _, _, _, itemTexture = GetItemInfo(link);
		if ( itemTexture ) then
			NuguDropTooltipIconTexture:SetTexture( itemTexture );
			NuguDropTooltipIcon:ClearAllPoints();
			NuguDropTooltipIcon:SetPoint("BOTTOMLEFT", getglobal("NuguDropItem"..SelectedItemIdx), "TOPRIGHT", 0, 6);
			NuguDropTooltipIcon:Show();
			return;
		end
	end
end			

-----------------------------
-- 아이템사전이 없을경우 캐시데이터로 아이템리스트 생성하는 함수
-----------------------------
function NuguDrop_ItemDB_BuildItemsAll()
	NuguDrop_ItemDB_last_rebuild = time();
	ND_Cache_ItemsAll = {};

	for i = 1, 25000 do
		local itemName, itemLink, itemRarity = GetItemInfo(i);
		-- 유효아이템인가 체크
		if ( itemName ) then
			table.insert(ND_Cache_ItemsAll, i);
		end
	end
	if ( DEFAULT_CHAT_FRAME ) then
		NuguDrop_Print("아이템리스트 생성중 - 캐시로부터 "..table.getn(ND_Cache_ItemsAll).." 개의 아이템 발견");
	end
end

-----------------------------
-- NOT Enhanced LootLink용 함수 (하늘아리)
-----------------------------
function ND_LootLink_GetValue( elem, index, link )
	local name;
	if ( type(elem) == "table" ) then
		index = elem[2];
		elem = elem[1];
	end
	if ( link and ItemLinks[elem] and ItemLinks[elem].i ~= link ) then
		if ( ItemLinks[elem].m ) then
			for k, v in pairs(ItemLinks[elem].m) do
				if v.i == link then
					index = k;
					break;
				end
			end
			if ( not index ) then
				return nil;
			end
		end
	end
	if ( index and ItemLinks[elem] and ItemLinks[elem].m ) then
		return ItemLinks[elem].m[index], index;
	elseif ( ItemLinks[elem] ) then
		return ItemLinks[elem];
	else
		return nil;
	end
end

function ND_LootLink_GetHyperlink(name, index)
	local itemLink = ND_LootLink_GetValue( name, index );
	if( itemLink and itemLink.i) then
		local item = string.gsub(itemLink.i, "(%d+):(%d+):(%d+):(%d+)", "%1:%2:%3:0");
		return "item:"..item;
	end
	return nil;
end

function ND_LootLink_GetLink(name, index)
	local itemLink = ND_LootLink_GetValue(name, index);
	if( itemLink and itemLink.c and itemLink.i) then
		local link = "|c"..itemLink.c.."|H"..ND_LootLink_GetHyperlink(name, index).."|h["..name.."]|h|r";
		return link;
	end
	return nil;
end

function ND_LootLink_TypeLinks_LinkifyName(head, text, tail)
	if (head ~= "|h" and tail ~= "|h") then
		local link = ND_LootLink_GetLink(text);
		if (link) then return link; end
	end
	return head.."["..text.."]"..tail;
end

function ND_LootLink_TypeLinks_ParseChatMessage(text)
	return string.gsub(text, "([|]?[h]?)%[(.-)%]([|]?[h]?)", ND_LootLink_TypeLinks_LinkifyName);
end
