﻿
----------------------------------------------------------------------------------------
--	Text Format Vars
--		(HP/MP text and status bars)
--		$miss = Missing hp/mp
--		$cur = current hp/mp
--		$max = Max hp/mp
--		$perc = Percent hp/mp
--
--		(Name/Level text)
--		$name = Name
--		$level = Level
--		$class = Class
--		$guild = Guild
--		$race = Race
--		$rname = PvP Rank Name
--		$rnum = PvP Rank Number
--		$key = Key Binding
--
--	Element Names
--		hp, mp, xp, combo, target
--		name, level, class, race
--		pvp, leader, master, feedback
--		group, status, buff, debuff
--		raidtarget, highlight, pet, portrait
--
--	StatusBar Animations
--		glide
----------------------------------------------------------------------------------------

function Nurfed_HealthPercColor(perc, unit)
 local color = { r = 1, g = 1, b = 1 };
 if (unit) then
  if (unit == "target") or (unit == "targettarget") or (unit == "targettargettarget") or (unit == "focus") or (unit == "focustarget") or (unit == "focustargettarget") then
   if UnitPlayerControlled(unit) then
    if (UnitPlayerOrPetInParty(unit) or UnitPlayerOrPetInRaid(unit)) and not UnitIsVisible(unit) then
     color = friendlycolor;
    elseif UnitCanAttack(unit, "player") then
     if UnitCanAttack("player", unit) then
      color = { r = 220/255, g = 15/255, b = 15/255 };
     elseif not UnitCanAttack("player", unit) then
      color = { r = 220/255, g = 220/255, b = 35/255};
     end
    elseif UnitCanAttack("player", unit) then
     if not UnitCanAttack(unit, "player") then
      color = { r = 220/255, g = 220/255, b = 35/255};
     end
    else     --if UnitIsFriend("player", unit) then
     color = friendlycolor;
    end
   else
    color = UnitReactionColor[UnitReaction(unit, "player")];
    if (UnitIsTapped(unit) and not UnitIsTappedByPlayer(unit)) then
     color = { r = 153/255, g = 153/255, b = 153/255};
    end
   end
  else -- Normal {friendly} healthbar color
   color = friendlycolor;
  end
 end
 return color;
end

--Below are all the reaction based colors your target (and ToT and ToTT)'s health bars can be
friendlycolor = { r = (152/255), g = (185/255), b = (244/255)};  -- Generalized Friendly Unit Color
UnitReactionColor[1] = { r = 249/255, g = 15/255, b = 15/255};  -- Exceptionally hostile
UnitReactionColor[2] = { r = 220/255, g = 15/255, b = 15/255};  -- Very Hostile
UnitReactionColor[3] = { r = 219/255, g = 126/255, b = 0/255};  -- Hostile
UnitReactionColor[4] = { r = 220/255, g = 220/255, b = 35/255};  -- Neutral
UnitReactionColor[5] = friendlycolor;     -- Friendly
UnitReactionColor[6] = friendlycolor;     -- Very Friendly
UnitReactionColor[7] = friendlycolor;     -- Exceptionally Friendly

ManaBarColor[0] = { r = 87/255, g = 176/255, b = 203/255, prefix = TEXT(MANA) };  -- mana
ManaBarColor[1] = { r = 226/255, g = 45/255, b = 75/255, prefix = TEXT(MANA) };  -- rage
ManaBarColor[2] = { r = 255/255, g = 178/255, b = 0/255, prefix = TEXT(MANA) };  -- focus
ManaBarColor[3] = { r = 255/255, g = 255/255, b = 34/255, prefix = TEXT(MANA) }; -- energy
ManaBarColor[4] = { r = 0/255, g = 255/255, b = 255/255, prefix = TEXT(MANA) };  -- happiness

--[[ Globals ]]--

NRF_LOCKED = 1
NURFED_SAVED = NURFED_SAVED or {}
NURFED_BINDINGS = NURFED_BINDINGS or {}
NURFED_PROFILES = NURFED_PROFILES or {}
NRF_IMG = "Interface\\AddOns\\Nurfed\\Images\\"
NRF_FONT = "Interface\\AddOns\\Nurfed\\Fonts\\"

NURFED_FRAMES = NURFED_FRAMES or {
	templates = {
		Nurfed_Unit_backdrop = {
			bgFile = NRF_IMG.."PlainBackdrop.tga",
			tile = false,
			tileSize = 0,
			insets = { left = 2, right = 2, top = 2, bottom = 2 },
		},
		Nurfed_UnitFont = {
			type = "Font",
			Font = { NRF_FONT.."devilfont.ttf", 10, "OUTLINE" },
			TextColor = { 1, 1, 1 },
		},
		Nurfed_UnitFontOutline = {
			type = "Font",
			Font = { NRF_FONT.."Charcoal.ttf", 11, "OUTLINE" },
			TextColor = { 1, 1, 1 },
		},
		Nurfed_UnitFontSmall = {
			type = "Font",
			Font = { NRF_FONT.."devilfont.ttf", 11, "OUTLINE" },
			TextColor = { 1, 1, 1 },
		},
		Nurfed_UnitFontSmallOutline = {
			type = "Font",
			Font = { NRF_FONT.."devilfont.ttf", 9, "OUTLINE" },
			TextColor = { 1, 1, 1 },
		},
		Nurfed_CountFontOutline = {
			type = "Font",
			Font = { NRF_FONT.."devilfont.ttf", 13, "OUTLINE" },
			TextColor = { 1, 1, 1 },
		},
		Nurfed_Feedback = {
			type = "Font",
			Font = { NRF_FONT.."devilfont.ttf", 12, "OUTLINE" },
			TextColor = { 1, 1, 1 },
		},
		Nurfed_Unit_bg_Frame = {
			type = "Texture",
			layer = "BACKGROUND",
--			size = { 256, 64 },
			Texture = NRF_IMG.."framebg.tga",
		},

		Nurfed_Unit_hp = {
			type = "StatusBar",
			FrameStrata = "LOW",
			StatusBarTexture = NRF_IMG.."statusbar3",
			children = {
				bg = {
					type = "Texture",
					layer = "BACKGROUND",
					Texture = NRF_IMG.."statusbar3",
					VertexColor = { 1, 0, 0, 0.3 },
					Anchor = "all",
				},
				text = {
					type = "FontString",
					layer = "OVERLAY",
					FontObject = "Nurfed_UnitFont",
					JustifyH = "RIGHT",
--					ShadowColor = { 0, 0, 0, 0.75 },
--					ShadowOffset = { 1, -1 },
					Anchor = { "RIGHT", "$parent", "RIGHT", -2, 0 },
					vars = { format = "$cur/$max" },
				},
			},
			vars = { ani = "glide" },
		},

		Nurfed_Unit_mp = {
			type = "StatusBar",
			FrameStrata = "LOW",
			FrameLevel = 1,
			StatusBarTexture = NRF_IMG.."statusbar3",
			children = {
				bg = {
					type = "Texture",
					layer = "OVERLAY",
					Texture = NRF_IMG.."statusbar3",
					VertexColor = { 1, 0, 0, 0.25 },
					Anchor = "all"
				},
				text = {
					type = "FontString",
					layer = "OVERLAY",
					FontObject = "Nurfed_UnitFontSmallOutline",
					JustifyH = "RIGHT",
--					ShadowColor = { 0, 0, 0, 0.75 },
--					ShadowOffset = { 1, -1 },
					Anchor = { "RIGHT", "$parent", "RIGHT", -1,0 },
					vars = { format = "$cur/$max" },
				},
			},
			vars = { ani = "glide" },
		},

		Nurfed_Unit_xp = {
			type = "StatusBar",
			StatusBarTexture = NRF_IMG.."statusbar3",
			children = {
				bg = {
					type = "Texture",
					layer = "BACKGROUND",
					Texture = NRF_IMG.."statusbar3",
					VertexColor = { 0, 0, 1, 0.25 },
					Anchor = "all",
				},
				text = {
					type = "FontString",
					layer = "OVERLAY",
					FontObject = "Nurfed_UnitFontSmall",
					JustifyH = "CENTER",
					ShadowColor = { 0, 0, 0, 0.75 },
					ShadowOffset = { -1, -1 },
					Anchor = "all",
					vars = { format = "$cur/$max$rest" },
				},
				text2 = {
					type = "FontString",
					layer = "OVERLAY",
					FontObject = "Nurfed_UnitFontSmall",
					JustifyH = "RIGHT",
					ShadowColor = { 0, 0, 0, 0.75 },
					ShadowOffset = { -1, -1 },
					Anchor = "all",
					vars = { format = "$perc" },
				},
			},
		},
		Nurfed_Unit_casting = {
			type = "Frame",
			size = { 180, 40 },
			FrameStrata = "LOW",
			Backdrop = "Nurfed_Unit_backdrop",
			BackdropColor = { 0, 0, 0, 0 },
			children = {
			mini_Frame = {
					type = "Texture",
					layer = "BACKGROUND",
					size = { 180, 32 },
					Texture = NRF_IMG.."casting.tga",
					Anchor = { "CENTER", "$parent", "CENTER", 0, 0 },
				},
				casting = {
					type = "StatusBar",
					size = { 172, 12 },
					FrameStrata = "LOW",
					Orientation = "HORIZONTAL",
					Anchor = { "CENTER", "$parent", "CENTER", 0, -1 },
					StatusBarTexture = NRF_IMG.."statusbar3",
					children = {
						text = {
							type = "FontString",
							layer = "ARTWORK",
							size = { 150, 19 },
							JustifyH = "LEFT",
							FontObject = "Nurfed_UnitFont",
--							ShadowColor = { 0, 0, 0, 0.75 },
--							ShadowOffset = { -1, -1 },
							Anchor = { "LEFT", "$parent", "LEFT", 5, 0 },
							vars = { format = "$spell $rank" },
--							vars = { format = "$spell" },
						},
						time = {
							type = "FontString",
							layer = "ARTWORK",
							JustifyH = "LEFT",
							FontObject = "Nurfed_UnitFont",
--							ShadowColor = { 0, 0, 0, 0.75 },
--							ShadowOffset = { -1, -1 },
							Anchor = { "RIGHT", "$parent", "RIGHT", 0, 0 },
						},
						icon = {
							type = "Texture",
							layer = "ARTWORK",
							size = { 20, 20 },
							Anchor = { "LEFT", "$parent", "RIGHT", 7, 1 },
						},
					},
					Hide = true,
				},
			},
			Hide = true,
		},

		Nurfed_Unit_model = {
			type = "PlayerModel",
			size = { 40, 40 },
			FrameStrata = "LOW",
			ModelScale = 1.9,
			FrameLevel = 1,
		},

		Nurfed_Unit_party_model = {
			type = "PlayerModel",
			size = { 26, 26 },
			FrameStrata = "LOW",
			ModelScale = 1.6,
			Camera = 0,
			FrameLevel = 1,
		},

		Nurfed_Target_combo = {
			type = "Texture",
			layer = "OVERLAY",
			size = { 10, 6 },
			Texture = NRF_IMG.."combo.tga",
		},

		Nurfed_Unit_mini = {
			type = "Button",
			uitemp = "SecureUnitButtonTemplate",
			size = { 100, 52 },
			FrameStrata = "LOW",
			Backdrop = "Nurfed_Unit_backdrop",
			BackdropColor = { 0, 0, 0, 0 },
			children = {
				mini_Frame = {
					type = "Texture",
					layer = "BACKGROUND",
					size = { 100, 52 },
					Texture = NRF_IMG.."mframebg.tga",
					Anchor = { "CENTER", "$parent", "CENTER", 0, 0 },
				},
				highlight = {
					type = "Texture",
					size = { 60, 8 },
					layer = "ARTWORK",
					Texture = "Interface\\QuestFrame\\UI-QuestTitleHighlight",
					BlendMode = "ADD",
					Anchor = { "TOPRIGHT", "$parent", "TOPRIGHT", -6, -14 },
					Hide = true,
				},
				hp = {
					type = "StatusBar",
					size = { 88, 16 },
					FrameStrata = "LOW",
					Orientation = "HORIZONTAL",
					StatusBarTexture = NRF_IMG.."statusbar3",
					Anchor = { "BOTTOM", "$parent", "BOTTOM", -1, 12 },
					children = {
						bg = {
							type = "Texture",
							layer = "BACKGROUND",
							Texture = NRF_IMG.."statusbar1",
							VertexColor = { 1, 0, 0, 0.25 },
							Anchor = "all",
						},
						text = {
							type = "FontString",
							layer = "OVERLAY",
							FontObject = "Nurfed_UnitFont",
							JustifyH = "CENTER",
							Anchor = { "CENTER", "$parent", "CENTER", 0, 0 },
							vars = { format = "$perc" },
						},
					},
				},
				name = {
					type = "FontString",
					size = { 88, 10 },
					layer = "ARTWORK",
					FontObject = "Nurfed_UnitFont",
					JustifyH = "LEFT",
					ShadowColor = { 0, 0, 0, 0.75 },
					ShadowOffset = { -1, -1 },
					Anchor = { "TOPLEFT", "$parent", "TOPLEFT", 5, -12 },
					vars = { format = "$level $name" },
				},
				debuff1 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "TOPLEFT", "$parent", "TOPRIGHT", -2, -8 } },
				debuff2 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "TOPLEFT", "$parentdebuff1", "BOTTOMLEFT", 0, 0 } },
				vars = { unit = "target", aurawidth = 100, aurasize = 20 },
			},
      			Hide = true,
		},

		Nurfed_Party = {
			type = "Button",
			uitemp = "SecureUnitButtonTemplate",
			size = { 160, 46 },
			Scale=1.0,
			FrameStrata = "LOW",
			ClampedToScreen = true,
			Backdrop = "Nurfed_Unit_backdrop",
			BackdropColor = { 1, 0, 0, 0 },
			Movable = true,
			Mouse = true,
			children = {
				bg_Frame = {
					type = "Texture",
					layer = "BACKGROUND",
					size = { 200, 52 },
					Texture = NRF_IMG.."framebg.tga",
					Anchor = { "CENTER", "$parent", "CENTER", 2, 0 },
				},
				class = {
					type = "FontString",
					layer = "OVERLAY",
					FontObject = "Nurfed_UnitFont",
					JustifyH = "LEFT",
					ShadowColor = { 0, 0, 0, 0.75 },
					ShadowOffset = { 1, -1 },
					Anchor = { "LEFT", "$parentmp", "LEFT", 1, 0 },
					InsertMode = "TOP",
					vars = { format = "$class" },
				},
				hp = {
					template = "Nurfed_Unit_hp",
					size = { 126, 16 },
					Anchor = { "RIGHT", "$parent", "RIGHT", 0, -1 },
					InsertMode = "BOTTOM",
				},
				mp = {
					template = "Nurfed_Unit_mp",
					size = { 126, 10 },
					Anchor = { "RIGHT", "$parent", "RIGHT", 0, -15 },
				},
				model = {
					template = "Nurfed_Unit_model",
					size = { 28, 28 },
					Anchor = { "LEFT", "$parent", "LEFT", 5, -7 },
				},
				highlight = {
					type = "Texture",
					size = { 120, 10 },
					layer = "ARTWORK",
					Texture = "Interface\\QuestFrame\\UI-QuestTitleHighlight",
					BlendMode = "ADD",
					Anchor = { "TOPRIGHT", "$parent", "TOPRIGHT", 0, -4 },
					Hide = true,
				},
				hpperc = {
					type = "FontString",
					size = { 55, 10 },
					layer = "OVERLAY",
					Font = {NRF_FONT.."devilfont.ttf", 10, "OUTLINE" },
					TextColor = { 1, 1, 1 },
					JustifyH = "RIGHT",
					Anchor = { "BOTTOMRIGHT", "$parenthp", "TOPRIGHT", 1, 2 },
					vars = { format = "$perc" },
				},
				leader = {
					type = "Texture",
					size = { 12, 12 },
					layer = "OVERLAY",
					Texture = "Interface\\GroupFrame\\UI-Group-LeaderIcon",
					Anchor = { "TOPLEFT", "$parent", "TOPLEFT", -10, -18 },
				},
				master = {
					type = "Texture",
					size = { 9, 9 },
					layer = "OVERLAY",
					Texture = "Interface\\GroupFrame\\UI-Group-MasterLooter",
					Anchor = { "TOPLEFT", "$parent", "TOPLEFT", 7, 4 },
				},
				name = {
					type = "FontString",
					size = { 140, 11 },
					layer = "OVERLAY",
					FontObject = "Nurfed_Feedback",
					JustifyH = "LEFT",
					Anchor = { "TOPLEFT", "$parent", "TOPLEFT", -2, -4 },
					vars = { format = "$level $name" },
				},
--				pet = {
--					template = "Nurfed_Unit_mini",
--					Anchor = { "LEFT", "$parent", "RIGHT", 60, 0 },
--				},
				feedbackheal = {
					type = "MessageFrame",
					layer = "OVERLAY",
					size = { 110, 20 },
					FontObject = "Nurfed_Feedback",
					JustifyH = "LEFT",
					InsertMode = "TOP",
					Anchor = { "LEFT", "$parenthp", "LEFT", 2, 0 },
					FadeDuration = 0.25,
					TimeVisible = 0.5,
					vars = { heal = true },
				},
				feedbackdamage = {
					type = "MessageFrame",
					layer = "OVERLAY",
					size = { 110, 20 },
					FontObject = "Nurfed_Feedback",
					JustifyH = "LEFT",
					InsertMode = "TOP",
					Anchor = { "LEFT", "$parenthp", "LEFT", 2, 0 },
					FadeDuration = 0.25,
					TimeVisible = 0.5,
					vars = { damage = true },
				},
				buff1 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "TOPLEFT", "$parent", "BOTTOMLEFT", 4, -3 } },
				buff2 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff1", "RIGHT", 0, 0 } },
				buff3 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff2", "RIGHT", 0, 0 } },
				buff4 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff3", "RIGHT", 0, 0 } },
				buff5 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff4", "RIGHT", 0, 0 } },
				buff6 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff5", "RIGHT", 0, 0 } },
				buff7 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff6", "RIGHT", 0, 0 } },
				buff8 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff7", "RIGHT", 0, 0 } },
				buff9 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff8", "RIGHT", 0, 0 } },
				buff10 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff9", "RIGHT", 0, 0 } },
				buff11 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff10", "RIGHT", 0, 0 } },
				buff12 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff11", "RIGHT", 0, 0 } },
				buff13 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff12", "RIGHT", 0, 0 } },
				buff14 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff13", "RIGHT", 0, 0 } },
				buff15 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff14", "RIGHT", 0, 0 } },
				buff16 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff15", "RIGHT", 0, 0 } },
				debuff1 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "TOPLEFT", "$parent", "TOPRIGHT", 22, 0 } },
				debuff2 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "TOPLEFT", "$parentdebuff1", "BOTTOMLEFT", 0, 0 } },
				debuff3 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "TOPLEFT", "$parentdebuff2", "BOTTOMLEFT", 0, 0 } },
				debuff4 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "TOPLEFT", "$parentdebuff1", "TOPRIGHT", 0, 0 } },
				debuff5 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "TOPLEFT", "$parentdebuff4", "BOTTOMLEFT", 0, 0 } },
				debuff6 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "TOPLEFT", "$parentdebuff5", "BOTTOMLEFT", 0, 0 } },
				},
				vars = { aurawidth = 176, },
			},
		},
	frames = {
		Nurfed_player = {
			type = "Button",
			uitemp = "SecureUnitButtonTemplate",
			size = { 260, 68 },
			Scale=1.0,
			FrameStrata = "LOW",
			FrameLevel = 1,
			ClampedToScreen = true,
			Backdrop = "Nurfed_Unit_backdrop",
			BackdropColor = { 1, 0, 0, 0 },
			Movable = true,
			Mouse = true,
			children = {
				bg_Frame = {
					template = "Nurfed_Unit_bg_Frame",
					size = { 256, 64 },
					Anchor = { "CENTER", "$parent", "CENTER", 1, 0 }
				},
				hp = {
					template = "Nurfed_Unit_hp",
					size = { 164, 18 },
					Anchor = { "CENTER", "$parent", "CENTER", 18, 0 },
					InsertMode = "BOTTOM",
				},
				mp = {
					template = "Nurfed_Unit_mp",
					size = { 164, 14 },
					Anchor = { "TOPRIGHT", "$parenthp", "BOTTOMRIGHT", 0, -1 },
				},
				hpperc = {
					type = "FontString",
					size = { 55, 10 },
					layer = "OVERLAY",
					Font = {NRF_FONT.."devilfont.ttf", 10, "OUTLINE" },
					JustifyH = "RIGHT",
					Anchor = { "BOTTOMRIGHT", "$parenthp", "TOPRIGHT", 10, 3 },
					vars = { format = "$perc" },
				},
				model = {
					template = "Nurfed_Unit_model",
					size = { 32, 32 },
					Anchor = { "BOTTOMLEFT", "$parent", "BOTTOMLEFT", 32, 10 },
				},
				highlight = {
					type = "Texture",
					size = { 140, 14 },
					layer = "ARTWORK",
					Texture = "Interface\\QuestFrame\\UI-QuestTitleHighlight",
					BlendMode = "ADD",
					Anchor = { "TOPRIGHT", "$parent", "TOPRIGHT", -20, -10 },
					Hide = true,
				},
				pvp = {
					type = "Texture",
					size = { 32, 32 },
					layer = "OVERLAY",
					Anchor = { "RIGHT", "$parentmodel", "LEFT", 10, 0 },
				},
				status = {
					type = "Texture",
					size = { 24, 24 },
					layer = "OVERLAY",
					Texture = "Interface\\CharacterFrame\\UI-StateIcon",
					Anchor = { "RIGHT", "$parent", "RIGHT", -6, 0 },
					Hide = true,
				},
--				xp = {
--					template = "Nurfed_Unit_xp",
--					size = { 170, 8 },
--					Anchor = { "BOTTOMRIGHT", "$parent", "BOTTOMRIGHT", -5, 5 },
--				},
--				castingframe = {
--					template = "Nurfed_Unit_casting",
--					Anchor = { "RIGHT", "$parent", "LEFT" },
--				},				
--				bg = {
--					type = "Texture",
--					Texture = NRF_IMG.."framebg.tga",
--					size = { 256, 64 },
--					layer = "ARTWORK",
--					Anchor = { "CENTER", "$parent", "CENTER", 0, 0 },
--					Hide = true,
--				},
				name = {
					type = "FontString",
					size = { 190, 10 },
					layer = "OVERLAY",
					FontObject = "Nurfed_CountFontOutline",
					JustifyH = "LEFT",
					Anchor = { "BOTTOMLEFT", "$parentmodel", "TOPLEFT", -10, 4 },
					vars = { format = "$level $name" },
				},
--				rank = {
--					type = "Texture",
--					size = { 15, 15 },
--					layer = "OVERLAY",
--					FrameLevel = 2,
--					Anchor = { "RIGHT", "$parentname", "LEFT", -2, 0 },
--					Hide = true,
--				},
				leader = {
					type = "Texture",
					size = { 16, 16 },
					layer = "OVERLAY",
					Texture = "Interface\\GroupFrame\\UI-Group-LeaderIcon",
					Anchor = { "RIGHT", "$parent", "LEFT", 23, 17 },
					Hide = true,
				},
				master = {
					type = "Texture",
					size = { 12, 12 },
					layer = "OVERLAY",
					Texture = "Interface\\GroupFrame\\UI-Group-MasterLooter",
					Anchor = { "LEFT", "$parentleader", "RIGHT", 0, 0 },
					Hide = true,
				},
--				raidtarget = {
--					type = "Texture",
--					Texture = "Interface\\TargetingFrame\\UI-RaidTargetingIcons",
--					size = { 20, 20 },
--					layer = "OVERLAY",
--					Anchor = { "LEFT", "$parent", "RIGHT", 2, 18 },
--					Hide = true,
--				},
				group = {
					type = "FontString",
--					size = { 80, 8 },
					layer = "OVERLAY",
					FontObject = "Nurfed_UnitFont",
					JustifyH = "LEFT",
					InsertMode = "TOP",
					Anchor = { "BOTTOMLEFT", "$parent", "BOTTOMLEFT", 28, 9 },
				},
				feedbackheal = {
					type = "MessageFrame",
					layer = "OVERLAY",
					size = { 80, 20 },
					FontObject = "Nurfed_Feedback",
					JustifyH = "LEFT",
					InsertMode = "TOP",
					Anchor = { "LEFT", "$parenthp", "LEFT", 2, -5 },
					FadeDuration = 0.25,
					TimeVisible = 0.5,
					vars = { heal = true },
				},
				feedbackdamage = {
					type = "MessageFrame",
					layer = "OVERLAY",
					size = { 80, 20 },
					FontObject = "Nurfed_Feedback",
					JustifyH = "LEFT",
					InsertMode = "TOP",
					Anchor = { "LEFT", "$parenthp", "LEFT", 2, -5 },
					FadeDuration = 0.25,
					TimeVisible = 0.5,
					vars = { damage = true },
				},
			},
			vars = { unit = "player" },
		},

		Nurfed_target = {
			type = "Button",
			uitemp = "SecureUnitButtonTemplate",
			size = { 260, 68 },
			Scale=1.0,
			FrameStrata = "LOW",
--			FrameLevel = 1,
			ClampedToScreen = true,
			Backdrop = "Nurfed_Unit_backdrop",
			BackdropColor = { 0, 0, 0, 0 },
			Movable = true,
			Mouse = true,
			children = {
				bg_Frame = {
					template = "Nurfed_Unit_bg_Frame",
					size = { 256, 64 },
					Anchor = { "CENTER", "$parent", "CENTER", 0, 2 }
				},
				hp = {
					template = "Nurfed_Unit_hp",
					size = { 164, 18 },
					Anchor = { "CENTER", "$parent", "CENTER", -18, 2 },
					InsertMode = "BOTTOM",
				},
				mp = {
					template = "Nurfed_Unit_mp",
					size = { 164, 14 },
					Anchor = { "TOPRIGHT", "$parenthp", "BOTTOMRIGHT", 0, -1 },
				},
				name = {
					type = "FontString",
					size = { 190, 10 },
					layer = "OVERLAY",
					FontObject = "Nurfed_CountFontOutline",
					JustifyH = "LEFT",
					Anchor = { "BOTTOMLEFT", "$parenthp", "TOPLEFT", -10, 3 },
					vars = { format = "$level $name" },
				},
				model = {
					template = "Nurfed_Unit_model",
					size = { 32, 32 },
					Anchor = { "BOTTOMRIGHT", "$parent", "BOTTOMRIGHT", -32, 10 },
				},
				class = {
					type = "FontString",
					layer = "OVERLAY",
					size = { 100, 10 },
					FontObject = "Nurfed_UnitFont",
					JustifyH = "LEFT",
--					ShadowColor = { 0, 0, 0, 0.75 },
--					ShadowOffset = { 1, -1 },
					Anchor = { "LEFT", "$parentmp", "LEFT", 2, 0 },
					InsertMode = "TOP",
					vars = { format = "$class" },
				},
--				pvp = {
--					type = "Texture",
--					size = { 26, 26 },
--					layer = "OVERLAY",
--					Anchor = { "RIGHT", "$parent", "LEFT", 170, -3 },
--				},
--				status = {
--					type = "Texture",
--					size = { 19, 19 },
--					layer = "OVERLAY",
--					Texture = "Interface\\CharacterFrame\\UI-StateIcon",
--					Anchor = { "LEFT", "$parenthp", "RIGHT", -25, 18 },
--					Hide = true,
--				},
				hpperc = {
					type = "FontString",
					size = { 80, 10 },
					layer = "OVERLAY",
					Font = {NRF_FONT.."devilfont.ttf", 10, "OUTLINE" },
					JustifyH = "RIGHT",
					Anchor = { "BOTTOMRIGHT", "$parentmodel", "TOPRIGHT", 10, 6 },
					vars = { format = "$perc" },
				},
				combo1 = {
					template = "Nurfed_Target_combo",
					VertexColor = { 255/255, 255/255, 0/255, 1 },	--combo point colors, in RGBA values, edit to taste
					Anchor = { "LEFT", "$parent", "LEFT", 16, 8 },
  					vars = { id = 1, },
				},
				combo2 = {
					template = "Nurfed_Target_combo",
					VertexColor = { 255/255, 200/255, 15/255, 1 },
					Anchor = { "TOP", "$parentcombo1", "BOTTOM", 0, -1 },
					vars = { id = 2, },
				},
				combo3 = {
					template = "Nurfed_Target_combo",
					VertexColor = { 255/255, 160/255, 15/255, 1 },
					Anchor = { "TOP", "$parentcombo2", "BOTTOM", 0, -1 },
					vars = { id = 3, },
				},
				combo4 = {
					template = "Nurfed_Target_combo",
					VertexColor = { 255/255, 80/255, 15/255, 1 },
					Anchor = { "TOP", "$parentcombo3", "BOTTOM", 0, -1 },
					vars = { id = 4, },
				},
				combo5 = {
					template = "Nurfed_Target_combo",
					VertexColor = { 255/255, 0/255, 15/255, 1 },
					Anchor = { "TOP", "$parentcombo4", "BOTTOM", 0, -1 },
					vars = { id = 5, },
				},
				castingframe = {
					template = "Nurfed_Unit_casting",
					Anchor = { "BOTTOM", "$parent", "TOP",-10,-10 },
				},
				raidtarget = {
					type = "Texture",
					Texture = "Interface\\TargetingFrame\\UI-RaidTargetingIcons",
					size = { 20, 20 },
					layer = "OVERLAY",
					Anchor = { "RIGHT", "$parent", "RIGHT", -9, 0 },
					Hide = true,
				},
				feedbackheal = {
					type = "MessageFrame",
					layer = "OVERLAY",
					size = { 80, 20 },
					FontObject = "Nurfed_Feedback",
					JustifyH = "LEFT",
					InsertMode = "TOP",
					Anchor = { "LEFT", "$parenthp", "LEFT", 2, -5 },
					FadeDuration = 0.25,
					TimeVisible = 0.5,
					vars = { heal = true },
				},
				feedbackdamage = {
					type = "MessageFrame",
					layer = "OVERLAY",
					size = { 80, 20 },
					FontObject = "Nurfed_Feedback",
					JustifyH = "LEFT",
					InsertMode = "TOP",
					Anchor = { "LEFT", "$parenthp", "LEFT", 2, -5 },
					FadeDuration = 0.25,
					TimeVisible = 0.5,
					vars = { damage = true },
				},								
				buff1 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "TOPLEFT", "$parent", "BOTTOMLEFT", 30, 5 } },
				buff2 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff1", "RIGHT", 0, 0 } },
				buff3 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff2", "RIGHT", 0, 0 } },
				buff4 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff3", "RIGHT", 0, 0 } },
				buff5 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff4", "RIGHT", 0, 0 } },
				buff6 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff5", "RIGHT", 0, 0 } },
				buff7 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff6", "RIGHT", 0, 0 } },
				buff8 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff7", "RIGHT", 0, 0 } },
				buff9 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff8", "RIGHT", 0, 0 } },
				buff10 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff9", "RIGHT", 0, 0 } },
				buff11 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "TOP", "$parentbuff1", "BOTTOM", 0, 0 } },
				buff12 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff11", "RIGHT", 0, 0 } },
				buff13 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff12", "RIGHT", 0, 0 } },
				buff14 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff13", "RIGHT", 0, 0 } },
				buff15 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff14", "RIGHT", 0, 0 } },
				buff16 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff15", "RIGHT", 0, 0 } },
				debuff1 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "TOPLEFT", "$parentbuff1", "BOTTOMLEFT", 0, -1 } },
				debuff2 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentdebuff1", "RIGHT", 0, 0 } },
				debuff3 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentdebuff2", "RIGHT", 0, 0 } },
				debuff4 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentdebuff3", "RIGHT", 0, 0 } },
				debuff5 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentdebuff4", "RIGHT", 0, 0 } },
				debuff6 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentdebuff5", "RIGHT", 0, 0 } },
				debuff7 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentdebuff6", "RIGHT", 0, 0 } },
				debuff8 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentdebuff7", "RIGHT", 0, 0 } },
				debuff9 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentdebuff8", "RIGHT", 0, 0 } },
				debuff10 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentdebuff9", "RIGHT", 0, 0 } },
				debuff11 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentdebuff10", "RIGHT", 0, 0 } },
				debuff12 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "TOP", "$parentdebuff1", "BOTTOM", 0, 0 } },
				debuff13 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentdebuff12", "RIGHT", 0, 0 } },
				debuff14 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentdebuff13", "RIGHT", 0, 0 } },
				debuff15 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentdebuff14", "RIGHT", 0, 0 } },
				debuff16 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentdebuff15", "RIGHT", 0, 0 } },
			},
				vars = { unit = "target", aurawidth = 260, aurasize = 20 },
		},

		--TOT, TOTT 프레임으로 만듬
		Nurfed_targettarget = { 
			Scale=1.0,
			template = "Nurfed_Unit_mini",
			Anchor = {  "LEFT", "Nurfed_target", "RIGHT", 0, 12 },
			vars = { unit = "targettarget" }
			},

		Nurfed_targettargettarget = { 
			Scale=1.0,
			template = "Nurfed_Unit_mini",
			Anchor = {  "LEFT", "Nurfed_target", "RIGHT", 0, -28 },
			vars = { unit = "targettargettarget" }
			},

		Nurfed_focustarget = { 
			Scale=1.0,
			template = "Nurfed_Unit_mini",
			Anchor = {  "LEFT", "Nurfed_focus", "RIGHT", 0, 0 },
			vars = { unit = "focustarget" }
			},
		Nurfed_pet = {
			type = "Button",
			uitemp = "SecureUnitButtonTemplate",
			size = { 100, 52 },
			Scale=1.0,
			FrameStrata = "LOW",
			ClampedToScreen = true,
			Backdrop = "Nurfed_Unit_backdrop",
			BackdropColor = { 0, 0, 0, 0 },
			Movable = true,
			Mouse = true,
		   	children = {
				mini_Frame = {
					type = "Texture",
					layer = "BACKGROUND",
					size = { 100, 52 },
					Texture = NRF_IMG.."mframebg.tga",
					Anchor = { "CENTER", "$parent", "CENTER", 0, 0 },
				},
				highlight = {
					type = "Texture",
					size = { 60, 8 },
					layer = "ARTWORK",
					Texture = "Interface\\QuestFrame\\UI-QuestTitleHighlight",
					BlendMode = "ADD",
					Anchor = { "TOPRIGHT", "$parent", "TOPRIGHT", -6, -14 },
					Hide = true,
				},
				hp = {
					type = "StatusBar",
					size = { 88, 10 },
					FrameStrata = "LOW",
					Orientation = "HORIZONTAL",
					StatusBarTexture = NRF_IMG.."statusbar3",
					Anchor = { "BOTTOM", "$parent", "BOTTOM", -1, 19 },
					children = {
						bg = {
							type = "Texture",
							layer = "BACKGROUND",
							Texture = NRF_IMG.."statusbar3",
							VertexColor = { 1, 0, 0, 0.25 },
							Anchor = "all",
						},
						text = {
							type = "FontString",
							layer = "OVERLAY",
							FontObject = "Nurfed_UnitFont",
							JustifyH = "CENTER",
							Anchor = { "CENTER", "$parent", "CENTER", 0, 0 },
							vars = { format = "$perc" },
						},
					},
				},
				mp = {
					type = "StatusBar",
			     		size = { 88, 6 },
			     		FrameStrata = "LOW",
			     		Orientation = "HORIZONTAL",
			     		StatusBarTexture = NRF_IMG.."statusbar3",
			     		Anchor = { "BOTTOM", "$parent", "BOTTOM", -1, 12},
			     		children = {
			      			bg = {
			       				type = "Texture",
			       				layer = "BACKGROUND",
			       				Texture = NRF_IMG.."statusbar3",
			       				VertexColor = { 1, 0, 0, 0.25 },
			       				Anchor = "all",
			      				},
			     			},
			    		},
				name = {
					type = "FontString",
					size = { 88, 10 },
					layer = "ARTWORK",
					FontObject = "Nurfed_UnitFont",
					JustifyH = "LEFT",
					ShadowColor = { 0, 0, 0, 0.75 },
					ShadowOffset = { -1, -1 },
					Anchor = { "TOPLEFT", "$parent", "TOPLEFT", 5, -12 },
					vars = { format = "$level $name" },
				},
			    	happiness = {
			     		type = "Texture",
			     		Texture = "Interface\\PetPaperDollFrame\\UI-PetHappiness",
			     		size = { 24, 24 },
			     		layer = "OVERLAY",
			     		Anchor = { "RIGHT", "$parent", "LEFT", 0, 2 },
			     		Hide = true,
			    		},
				buff1 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "TOPLEFT", "$parent", "BOTTOMLEFT", 3, 8 } },
				buff2 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff1", "RIGHT", 0, 0 } },
				buff3 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff2", "RIGHT", 0, 0 } },
				buff4 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff3", "RIGHT", 0, 0 } },
				buff5 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff4", "RIGHT", 0, 0 } },
				buff6 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff5", "RIGHT", 0, 0 } },
				buff7 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff6", "RIGHT", 0, 0 } },
				buff8 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff7", "RIGHT", 0, 0 } },
				buff9 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff8", "RIGHT", 0, 0 } },
    				debuff1 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "TOP", "$parentbuff1", "BOTTOM", 0, -1 } },
    				debuff2 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentdebuff1", "RIGHT", 0, 0 } },
    				debuff3 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentdebuff2", "RIGHT", 0, 0 } },
    				debuff4 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentdebuff3", "RIGHT", 0, 0 } },
    				debuff5 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentdebuff4", "RIGHT", 0, 0 } },
    				debuff6 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentdebuff5", "RIGHT", 0, 0 } },
    				debuff7 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentdebuff6", "RIGHT", 0, 0 } },
    				debuff8 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentdebuff7", "RIGHT", 0, 0 } },
    				debuff9 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor =  { "LEFT", "$parentdebuff8", "RIGHT", 0, 0 } },
   				},
				vars = { unit = "pet", aurawidth = 160 },
			},

		Nurfed_focus = {
			type = "Button",
			uitemp = "SecureUnitButtonTemplate",
			size = { 210, 52 },
			FrameStrata = "LOW",
--			FrameLevel = 1,
			ClampedToScreen = true,
			Backdrop = "Nurfed_Unit_backdrop",
			BackdropColor = { 0, 0, 0, 0 },
			Movable = true,
			Mouse = true,
			children = {
				bg_Frame = {
					template = "Nurfed_Unit_bg_Frame",
					size = { 210, 52 },
					Anchor = { "CENTER", "$parent", "CENTER", 0, 2 }
				},
				hp = {
					template = "Nurfed_Unit_hp",
					size = { 160, 16 },
					Anchor = { "CENTER", "$parent", "CENTER",0, 1 },
				},
				mp = {
					template = "Nurfed_Unit_mp",
					size = { 160, 11 },
					Anchor = { "BOTTOM", "$parent", "BOTTOM", 0, 7 },
				},
				name = {
					type = "FontString",
					size = { 188, 10 },
					layer = "OVERLAY",
					FontObject = "Nurfed_Feedback",
					JustifyH = "LEFT",
					Anchor = { "TOPLEFT", "$parent", "TOPLEFT", 16, -6 },
					vars = { format = "$level $name" },
				},
				highlight = {
					type = "Texture",
					size = { 100, 10 },
					layer = "ARTWORK",
					Texture = "Interface\\QuestFrame\\UI-QuestTitleHighlight",
					BlendMode = "ADD",
					Anchor = { "TOPRIGHT", "$parent", "TOPRIGHT", -18, -5 },
					Hide = true,
				},
				hpperc = {
					type = "FontString",
					size = { 100, 10 },
					layer = "OVERLAY",
					Font = {NRF_FONT.."devilfont.ttf", 10, "OUTLINE" },
					JustifyH = "RIGHT",
					Anchor = { "BOTTOMRIGHT", "$parenthp", "TOPRIGHT", 6, 3 },
					vars = { format = "$perc" },
				},
				castingframe = {
					template = "Nurfed_Unit_casting",
					Anchor = { "BOTTOM", "$parent", "TOP",-5,-8 },
				},
				buff1 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "TOPLEFT", "$parent", "BOTTOMLEFT", 25, 2 } },
				buff2 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff1", "RIGHT", 0, 0 } },
				buff3 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff2", "RIGHT", 0, 0 } },
				buff4 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff3", "RIGHT", 0, 0 } },
				buff5 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff4", "RIGHT", 0, 0 } },
				buff6 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff5", "RIGHT", 0, 0 } },
				buff7 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff6", "RIGHT", 0, 0 } },
				buff8 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff7", "RIGHT", 0, 0 } },
				buff9 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentbuff8", "RIGHT", 0, 0 } },
				debuff1 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "TOPLEFT", "$parentbuff1", "BOTTOMLEFT", 0, -1 } },
				debuff2 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentdebuff1", "RIGHT", 0, 0 } },
				debuff3 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentdebuff2", "RIGHT", 0, 0 } },
				debuff4 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentdebuff3", "RIGHT", 0, 0 } },
				debuff5 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentdebuff4", "RIGHT", 0, 0 } },
				debuff6 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentdebuff5", "RIGHT", 0, 0 } },
				debuff7 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentdebuff6", "RIGHT", 0, 0 } },
				debuff8 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentdebuff7", "RIGHT", 0, 0 } },
				debuff9 = { type = "Button", uitemp = "TargetDebuffButtonTemplate", Anchor = { "LEFT", "$parentdebuff8", "RIGHT", 0, 0 } },
			},
			vars = { unit = "focus", aurawidth = 210 },
		},
	
		Nurfed_party1 = { template = "Nurfed_Party", vars = { unit = "party1" } },
		Nurfed_party2 = { template = "Nurfed_Party", vars = { unit = "party2" } },
		Nurfed_party3 = { template = "Nurfed_Party", vars = { unit = "party3" } },
		Nurfed_party4 = { template = "Nurfed_Party", vars = { unit = "party4" } },
		},
	}

NURFED_DEFAULT = {
	chatfade = false,
	chatprefix = false,
	chatbuttons = false,
	chatfadetime = 120,
	autoinvite = false,
	invitetext = false,
	keyword = "invite",
	readycheck = false,
	ping = false,
	raidgroup = false,
	raidclass = false,
	repair = false,
	repairlimit = 20,
	timestamps = false,
	timestampsformat = "[%#I:%M:%S]",
	traineravailable = false,
	raidclicks = false,
}

--[[ Locals ]]--

local nrf = nurfed_util:new()
local invite
local pingflood = {}
local afkstring = nrf:formatgs(RAID_MEMBERS_AFK, true)
local ingroup = nrf:formatgs(ERR_ALREADY_IN_GROUP_S, true)

local wowmenu = {
	{ CHARACTER, function() ToggleCharacter("PaperDollFrame") end },
	{ SPELLBOOK, function() ToggleSpellBook(BOOKTYPE_SPELL) end },
	{ TALENTS, function() ToggleTalentFrame() end },
	{ QUESTLOG_BUTTON, function() ToggleQuestLog() end },
	{ FRIENDS, function() ToggleFriendsFrame() end },
	{ LFG_TITLE, function() ToggleLFGParentFrame() end },
	{ BINDING_NAME_TOGGLEGAMEMENU, function() MainMenuMicroButton:Click() end },
	{ KNOWLEDGE_BASE, function() ToggleKnowledgeBaseFrame() end },
	{ KEYRING, function() ToggleKeyRing() end },
}

local onenter = function()
	GameTooltip:SetOwner(this, "ANCHOR_LEFT")
	GameTooltip:AddLine("Nurfed UI", 0, 0.75, 1)
	GameTooltip:AddLine("|cff66ffff마우스 우클릭|r - 너프드 옵션 메뉴", 1, 1, 1)
	if NRF_LOCKED then
		GameTooltip:AddLine("|cffffff00마우스 좌클릭|r - |cffff0000잠금 해제|r(현재상태:잠금)", 1, 1, 1)
	else
		GameTooltip:AddLine("|cffffff00마우스 좌클릭|r - |cff00ff00잠금|r(현재상태:잠금해제)", 1, 1, 1)
	end
	GameTooltip:AddLine("|cffffff00마우스 가운데버튼 클릭|r - 와우 메뉴", 1, 1, 15)
--	GameTooltip:AddLine("Ctrl + Drag moves your Action Bars.", 0, 1, 0)
	GameTooltip:Show()
end

local onclick = function(button)
	if button == "LeftButton" then
		NRF_LOCKED = this:GetChecked()
		local icon = getglobal(this:GetName().."icon")
		if NRF_LOCKED then
			icon:SetTexture(NRF_IMG.."locked")
		else
			icon:SetTexture(NRF_IMG.."unlocked")
		end
		PlaySound("igMainMenuOption")
		onenter()
	else
		this:SetChecked(NRF_LOCKED)
		if button == "RightButton" then
			local loaded, reason = LoadAddOn("Nurfed_Options")
			if loaded then
				if Nurfed_OptionsFrame:IsShown() then
					PlaySound("igAbilityClose")
					Nurfed_OptionsFrame:Hide()
				else
					PlaySound("igAbilityOpen")
					Nurfed_OptionsFrame:Show()
					UIFrameFadeIn(Nurfed_OptionsFrame, 0.25)
				end
			end
		elseif button == "MiddleButton" then
			local drop = Nurfed_LockButtondropdown
			local info = {}
			if not drop.initialize then
				drop.displayMode = "MENU"
				drop.initialize = function()
					info.text = "WoW Menu"
					info.isTitle = 1
					info.notCheckable = 1
					UIDropDownMenu_AddButton(info)

					for _, v in ipairs(wowmenu) do
						info = {}
						info.text = v[1]
						info.func = v[2]
						info.isTitle = nil
						info.notCheckable = 1
						UIDropDownMenu_AddButton(info)
					end
				end
			end
			ToggleDropDownMenu(1, nil, drop, "cursor")
		end
	end
end

local onupdate = function(e)
	if this.isMoving then
		-- Credit to Alex Brazie for this calculation
		local cursorX, cursorY = GetCursorPosition()
		local centerX, centerY = Minimap:GetCenter()
		local scale = Minimap:GetEffectiveScale()
		cursorX = cursorX / scale
		cursorY = cursorY / scale
		local radius = (Minimap:GetWidth()/2) + (this:GetWidth()/1.6)
		local x = math.abs(cursorX - centerX)
		local y = math.abs(cursorY - centerY)
		local xSign = 1
		local ySign = 1
		if not (cursorX >= centerX) then xSign = -1 end
		if not (cursorY >= centerY) then ySign = -1 end

		local angle = math.atan(x/y)
		x = math.sin(angle)*radius
		y = math.cos(angle)*radius
		this:ClearAllPoints()
		this:SetPoint("CENTER", "Minimap", "CENTER", xSign * x, ySign * y)
		this:SetUserPlaced(true)
	end

	this.update = this.update + e
	if this.update > 0.5 then
		local now = GetTime()
		if invite and now - invite > 1 then invite = nil end
		for n, t in pairs(pingflood) do
			if now - t > 1 then pingflood[n] = nil end
		end
		this.update = 0
	end
end

local groupav = function()
	local pguild = GetGuildInfo("player")
	local server = GetRealmName()
	if server == "Blackrock" then
		if pguild == "Nurfed" or pguild == "The Feared" or UnitName("player") == "Fi" then
			if ((GetNumPartyMembers() > 0) or (GetNumRaidMembers() > 0)) and IsPartyLeader() then
				BattlefieldFrameGroupJoinButton:Show()
				BattlefieldFrameGroupJoinButton:Enable()
			end
		end
	end
end

local onevent = function()
	if event == "CHAT_MSG_WHISPER" then
		local invite = nrf:getopt("autoinvite")
		if invite and (IsPartyLeader() or IsRaidLeader() or IsRaidOfficer() or (GetNumPartyMembers() == 0 and GetNumRaidMembers() == 0)) then
			local text = string.lower(arg1)
			local keyword = string.lower(nrf:getopt("keyword"))
			if (string.find(text, "^"..keyword)) then
				InviteUnit(arg2)
				lastinvite = GetTime()
			end
		end
	elseif event == "MINIMAP_PING" then
		local show = nrf:getopt("ping")
		if show then
			local name = UnitName(arg1)
			if name ~= UnitName("player") and not pingflood[name] then
				nrf:print(name.." Ping.", nil, 1, 1, 0)
				pingflood[name] = GetTime()
			end
		end
	elseif event == "CHAT_MSG_SYSTEM" then
		if arg1 == READY_CHECK_NO_AFK or string.find(arg1, afkstring) then
			local readycheck = nrf:getopt("readycheck")
			if readycheck then
				SendChatMessage(arg1, "RAID")
			end
		else
			local invitetext = nrf:getopt("invitetext")
			if invitetext and (IsPartyLeader() or IsRaidLeader() or IsRaidOfficer()) then
				if string.find(arg1, ERR_GROUP_FULL, 1, true) and lastinvite then
					local lastTell = ChatEdit_GetLastTellTarget(DEFAULT_CHAT_FRAME.editBox)
					if lastTell ~= "" then
						SendChatMessage("Party Full", "WHISPER", this.language, lastTell)
					end
				else
					local result = { string.find(arg1, ingroup) }
					if (result[1]) then
						SendChatMessage("Drop group and resend '"..nrf:getopt("keyword").."'", "WHISPER", this.language, result[3])
					end
				end
			end
		end
	elseif event == "MERCHANT_SHOW" then
		local repair = nrf:getopt("repair")
		if repair then
			local limit = nrf:getopt("repairlimit")
			local money = math.floor(GetMoney() / COPPER_PER_GOLD)
			if money >= limit then
				local repairAllCost, canRepair = GetRepairAllCost()
				if canRepair then
					RepairAllItems()
					local gold = math.floor(repairAllCost / (COPPER_PER_SILVER * SILVER_PER_GOLD))
					local silver = math.floor((repairAllCost - (gold * COPPER_PER_SILVER * SILVER_PER_GOLD)) / COPPER_PER_SILVER)
					local copper = math.fmod(repairAllCost, COPPER_PER_SILVER)
					nrf:print("|cffffffffSpent|r |c00ffff66"..gold.."g|r |c00c0c0c0"..silver.."s|r |c00cc9900"..copper.."c|r |cffffffffOn Repairs.|r")
				end
			end
		end
	elseif event == "TRAINER_SHOW" then
		local avail = nrf:getopt("traineravailable")
		if avail then SetTrainerServiceTypeFilter("unavailable",0) end
	elseif event == "ADDON_LOADED" and arg1 == "Blizzard_InspectUI" then
		InspectPaperDollFrame:SetScript("OnShow", Nurfed_InspectOnShow)
	elseif event == "PLAYER_LOGIN" then
		for k, v in pairs(NURFED_BINDINGS) do
			local func = getglobal("SetBinding"..v[1])
			func(k, v[2])
		end
		SaveBindings(GetCurrentBindingSet())
		nrf_togglechat()
		hooksecurefunc("BattlefieldFrame_Update", groupav)
	elseif event == "VARIABLES_LOADED" then
		if not this:IsUserPlaced() then
			this:SetPoint("CENTER", "Minimap", "CENTER", -12, -76)
		end

		for k, v in pairs(NURFED_FRAMES.templates) do nrf:createtemp(k, v) end
		for k, v in pairs(NURFED_FRAMES.frames) do
			local f = nrf:create(k, v)
			if f.unit then nrf:unitimbue(f) end
			if not v.Point then f:SetPoint("CENTER", UIParent, "CENTER") end
		end
		for k, v in pairs(UIOptionsFrameSliders) do
			if v.text == "MAX_FOLLOW_DIST" then
				v.maxValue = 3.5
			end
		end
	end
end

local tbl = {
	type = "CheckButton",
	size = { 33, 33 },
	FrameStrata = "LOW",
	Checked = NRF_LOCKED,
	Movable = true,
	events = {
		"ADDON_LOADED",
		"MERCHANT_SHOW",
		"TRAINER_SHOW",
		"MINIMAP_PING",
		"CHAT_MSG_WHISPER",
		"CHAT_MSG_SYSTEM",
		"PLAYER_LOGIN",
		"VARIABLES_LOADED",
	},
	children = {
		dropdown = { type = "Frame" },
		Border = {
			type = "Texture",
			size = { 52, 52 },
			layer = "ARTWORK",
			Texture = "Interface\\Minimap\\MiniMap-TrackingBorder",
			Anchor = { "TOPLEFT", "$parent", "TOPLEFT", 0, 0 },
		},
		HighlightTexture = {
			type = "Texture",
			size = { 33, 33 },
			alphaMode = "ADD",
			Texture = "Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight",
			Anchor = { "TOPLEFT", "$parent", "TOPLEFT", 0, 0 },
		},
		icon = {
			type = "Texture",
			size = { 23, 23 },
			layer = "BACKGROUND",
			Texture = NRF_IMG.."locked",
			Anchor = { "CENTER", "$parent", "CENTER", -1, 1 },
		},
	},
	OnEvent = onevent,
	OnEnter = onenter,
	OnUpdate = function() onupdate(arg1) end,
	OnClick = function() onclick(arg1) end,
	OnLeave = function() GameTooltip:Hide() end,
	OnDragStart = function() this.isMoving = true end,
	OnDragStop = function() this.isMoving = nil end,
	vars = { update = 0 },
}

--[[ Init ]]--
local lock = nrf:create("Nurfed_LockButton", tbl, Minimap)
lock:RegisterForClicks("AnyUp")
lock:RegisterForDrag("LeftButton")
tbl = nil

-- Modify chat frames
ChatTypeInfo["CHANNEL"].sticky = 1
ChatTypeInfo["OFFICER"].sticky = 1

local OnMouseWheel = function()
	if IsShiftKeyDown() then
		if arg1 > 0 then this:PageUp()
		elseif arg1 < 0 then this:PageDown()
		end
	elseif IsControlKeyDown() then
		if arg1 > 0 then this:ScrollToTop()
		elseif arg1 < 0 then this:ScrollToBottom()
		end
	else
		if arg1 > 0 then this:ScrollUp()
		elseif arg1 < 0 then this:ScrollDown()
		end
	end
end

local message = function(this, msg, r, g, b, id)
	if (msg and type(msg) == "string") then
		if id and id == 8 and string.find(msg, "!ndkp") then return end
		local text = {}
		local pre = nrf:getopt("chatprefix")
		local ts = nrf:getopt("timestamps")
		if ts then
			local tsform = nrf:getopt("timestampsformat")
			local stamp = date(tsform)
			table.insert(text, stamp)
		end
		if not pre then
--			msg = string.gsub(msg, "%["..CHAT_MSG_WHISPER.."%] ", "▶")
--			msg = string.gsub(msg, "%["..CHAT_MSG_WHISPER_INFORM.."%] ", "◀")
--			msg = string.gsub(msg, "%["..CHAT_MSG_MONSTER_YELL.."%] ", "[외]%:\32")
--			msg = string.gsub(msg, "%["..CHAT_MSG_OFFICER.."%] ", "[관]%:\32")
--			msg = string.gsub(msg, "%["..CHAT_MSG_GUILD.."%] ", "[길]")
--			msg = string.gsub(msg, "%["..CHAT_MSG_PARTY.."%] ", "[파]%:\32")
--			msg = string.gsub(msg, "%["..CHAT_MSG_RAID.."%] ", "[공]%:\32")
--			msg = string.gsub(msg, "%["..CHAT_MSG_RAID_LEADER.."%] ", "[공장]%:\32")
--			msg = string.gsub(msg, "%["..CHAT_MSG_RAID_WARNING.."%] ", "[경보]%s:\32")
--			msg = string.gsub(msg, "%["..CHAT_MSG_BATTLEGROUND.."%] ", "[전]")
--			msg = string.gsub(msg, "%["..CHAT_MSG_BATTLEGROUND_LEADER.."%] ", "[전지]")
		CHAT_FLAG_AFK = "<자리비움> ";
		CHAT_FLAG_DND = "<다른용무중> ";
		CHAT_WHISPER_GET = "%s▶:\32"; -- Whisper from player %s
		CHAT_WHISPER_INFORM_GET = "%s◀:\32"; -- A whisper already sent to player %s
		CHAT_MONSTER_YELL_GET = "[외치기]%s:\32";
		CHAT_GUILD_GET = "[길드]%s:\32"; -- Guild message from player %s
		CHAT_RAID_GET = "[공격대]%s:\32";   -- Raid message from player %s
		CHAT_PARTY_GET = "[파티]%s:\32"; -- Party message from player %s
		CHAT_OFFICER_GET = "[관리자]%s:\32"; -- Officer message from player %s
		CHAT_YELL_GET = "[외치기]%s:\32"
		CHAT_RAID_LEADER_GET = "[♠♠]%s:\32";
		CHAT_RAID_WARNING_GET = "[경보]%s:\32"
		CHAT_BATTLEGROUND_GET = "[전장]%s:\32";
		CHAT_BATTLEGROUND_LEADER_GET = "[전장지휘관]%s:\32";
			ChatFrameEditBox:ClearAllPoints();
			ChatFrameEditBox:SetPoint("BOTTOMLEFT", "ChatFrame1", "TOPLEFT", 0, 2);
			ChatFrameEditBox:SetPoint("BOTTOMRIGHT", "ChatFrame1", "TOPRIGHT", 0, 2);

		end
		table.insert(text, msg)
		this:O_AddMessage(table.concat(text, " "), r, g, b, id)
	end
end

function nrf_togglechat()
	local buttons = nrf:getopt("chatbuttons")
	local fade = nrf:getopt("chatfade")
	local fadetime = nrf:getopt("chatfadetime")
	for i = 1, 7 do
		local chatframe = getglobal("ChatFrame"..i)
		local up = getglobal("ChatFrame"..i.."UpButton")
		local down = getglobal("ChatFrame"..i.."DownButton")
		local bottom = getglobal("ChatFrame"..i.."BottomButton")
		if buttons then
			up:Hide()
			down:Hide()
			bottom:Hide()
			if i == 1 then ChatFrameMenuButton:Hide() end
			chatframe:SetScript("OnShow", function() SetChatWindowShown(this:GetID(), 1) end)
		else
			up:Show()
			down:Show()
			bottom:Show()
			if i == 1 then ChatFrameMenuButton:Show() end
			chatframe:SetScript("OnShow", chatframe.O_OnShow)
		end
		chatframe:SetFading(fade)
		chatframe:SetTimeVisible(fadetime)
	end
end

local nrf_PlaySound = PlaySound
function PlaySound(snd)
	local raid = nrf:getopt("raidclicks")
	if snd == "igCharacterInfoTab" and raid then
		return
	end
	nrf_PlaySound(snd)
end

for i = 1, 7 do
	local chatframe = getglobal("ChatFrame"..i)
	local buttons = nrf:getopt("chatbuttons")
	chatframe:EnableMouseWheel(1)
	chatframe:SetScript("OnMouseWheel", OnMouseWheel)
	if not chatframe.O_AddMessage then
		chatframe.O_AddMessage = chatframe.AddMessage
		chatframe.AddMessage = message
	end
	if not chatframe.O_OnShow then
		chatframe.O_OnShow = chatframe:GetScript("OnShow")
	end
end

-- Overwrite Blizzard seconds conversion
--function SecondsToTimeAbbrev(seconds)
--	local time
--	if seconds > 86400 then
--		time = format(DAY_ONELETTER_ABBR, ceil(seconds / 86400))
--	elseif seconds > 3600 then
--		time = format(HOUR_ONELETTER_ABBR, ceil(seconds / 3600))
--	elseif seconds > 60 then
--		local min = floor(seconds / 60)
--		local sec = floor(seconds-(min)*60)
--		time = format("%02d:%02d", min, sec)
--	else
--		time = format("00:%02d", seconds)
--	end
--	return time
--end

-- Add guild line to inspect
function Nurfed_InspectOnShow()
	InspectPaperDollFrame_OnShow()
	local guildname, guildtitle = GetGuildInfo("target")
	if guildname and guildtitle then
		InspectTitleText:SetText(format(TEXT(GUILD_TITLE_TEMPLATE), guildtitle, guildname))
		InspectTitleText:Show()
	else
		InspectTitleText:Hide()
	end
end