﻿
local Nurfed_HudClass = {
	["마법사"] =	"00FFFF",
	["흑마법사"] =	"8D54FB",
	["사제"] =	"FFFFFF",
	["드루이드"] =	"FF8A00",
	["주술사"] =	"FF71A8",
	["성기사"] =	"FF71A8",
	["도적"] =	"FFFF00",
	["사냥꾼"] =	"00FF00",
	["전사"] =	"B39442",
};

local combatmode = false;
local petmode = false;

function Nurfed_HudTargetUpdate()
	if (combatmode == true) then
		Nurfed_Hud:SetAlpha(1.0);
	elseif (combatmode == false and UnitExists("target")) then
		Nurfed_Hud:SetAlpha(0.5);
	else
		Nurfed_Hud:SetAlpha(0.0);		
	end
	if (UnitExists("target")) then
		this:Show();

		Nurfed_TargetHudLayer:SetVertexColor(1, 0.4, 0.4);
		Nurfed_TargetHudBG:SetVertexColor(0, 0, 0);
		
		Nurfed_TargetHudLayer:SetAlpha(1.0);			-- Target HP의 선명도를 설정
		Nurfed_TargetHudBG:SetAlpha(0.8);          
		Nurfed_TargetHudBG:SetTexCoord(0, 1, 0, 1);

		local p=UnitHealth("target")/UnitHealthMax("target");
		local h = 236 * p;
		Nurfed_TargetHudLayer:SetHeight(h);
		Nurfed_TargetHudLayer:SetTexCoord(0, 1, 1-p, 1);
		
		if (petmode == false) then
			Nurfed_TargetHudMP:SetAlpha(1.0);
			Nurfed_TargetHudMPBG:SetAlpha(0.8);
			Nurfed_TargetHudMPBG:SetTexCoord(0, 1, 0, 1);

			local p=UnitMana("target")/UnitManaMax("target");
			local h = 236 * p;
			Nurfed_TargetHudMP:SetHeight(h);
			Nurfed_TargetHudMP:SetTexCoord(0, 1, 1-p, 1);
		end

		if (UnitPowerType("target") == 0) then
			info = { r = 0.00, g = 1.00, b = 1.00 };
		else
			info = ManaBarColor[UnitPowerType("target")];
		end
		Nurfed_TargetHudMP:SetVertexColor(info.r+0.7, info.g-0.3, info.b-0.1);
		Nurfed_TargetHudMPBG:SetVertexColor(0, 0, 0);

		--Nurfed_PlayerModelFrame:SetUnit("target");
		
		Nurfed_TargetHudHPPerc:SetText(ceil((UnitHealth("target") / UnitHealthMax("target")) * 100).."%");
		Nurfed_HudMobHealth();
		if (UnitManaMax("target") > 0 and petmode == false) then
			Nurfed_TargetHudMP:Show();
			Nurfed_TargetHudMPText:SetText(UnitMana("target").."/"..UnitManaMax("target"));
		else
			Nurfed_TargetHudMP:Hide();
			Nurfed_TargetHudMPText:SetText(" ");
		end

		if ( UnitClassification("target") == "worldboss" ) then
			Nurfed_TargetHudLevel:SetText("Boss.");
		elseif ( UnitClassification("target") == "elite" or UnitClassification("target") == "rareelite" ) then
			Nurfed_TargetHudLevel:SetText("Lv. "..UnitLevel("target").."+ ");
		elseif (UnitLevel("target") < 0) then
			Nurfed_TargetHudLevel:SetText("??");
		else
			Nurfed_TargetHudLevel:SetText("Lv. "..UnitLevel("target"));
		end

		local info = {};
		if (UnitPowerType("target") == 0) then
			info = { r = 0.00, g = 1.00, b = 1.00 };
		else
			info = ManaBarColor[UnitPowerType("target")];
		end

		local class = UnitClass("target");
		local color = Nurfed_HudClass[class];
		if (color) then
			Nurfed_TargetHudName:SetText("|cff"..color..UnitName("target").."|r");
		else
			Nurfed_TargetHudName:SetText("|cffffffff"..UnitName("target").."|r");
		end

		Nurfed_TargetHudMPText:SetTextColor(info.r+0.7, info.g-0.3, info.b-0.1);
		Nurfed_TargetHudHPText:SetTextColor(0.95, 0, 0);

		if (UnitIsPlayer("target")) then
			if (Nurfed_UnitsClassIcon and Nurfed_UnitsClassIcon[UnitClass("target")]) then
				local info = {};
				info = Nurfed_UnitsClassIcon[UnitClass("target")];
				if (info) then
					Nurfed_TargetHudIcon:Show();
					Nurfed_TargetHudIcon:SetTexCoord(info.right, info.left, info.top, info.bottom);
				end
			else
				Nurfed_TargetHudIcon:Hide();
			end
		else
			Nurfed_TargetHudIcon:Hide();
			
			
		end
		Nurfed_HudTargetAuras();
		return;
	else
		this:Hide();
	end
end

function Nurfed_HudTargetAuras()
	local i, icon, buff, debuff, debuffborder, debuffcount;
	for i = 1, 16 do
		buff, _, buffTexture = UnitBuff("target", i);
		button = getglobal("Nurfed_TargetHudBuff"..i);
		if (buff) then
			icon = getglobal(button:GetName().."Icon");
			icon:SetTexture(buffTexture);
			button:Show();
			button.unit = "target";
		else
			button:Hide();
		end
	end
	
	for i = 1, 16 do
		debuff, _, debuffTexture, debuffApplications = UnitDebuff("target", i);
		button = getglobal("Nurfed_TargetHudDeBuff"..i);
		if (debuff) then
			icon = getglobal(button:GetName().."Icon");
			debuffborder = getglobal(button:GetName().."Border");
			debuffcount = getglobal(button:GetName().."Count");
			icon:SetTexture(debuffTexture);
			button:Show();
			debuffborder:Show();
			button.isdebuff = 1;
			button.unit = "target";
			if (debuffApplications > 1) then
				debuffcount:SetText(debuffApplications);
				debuffcount:Show();
			else
				debuffcount:Hide();
			end
		else
			button:Hide();
		end
	end
end

function Nurfed_HudSetAuraTooltip()
	if (not this:IsVisible()) then return; end
	GameTooltip:SetOwner(this, "ANCHOR_BOTTOMRIGHT");
	local unit = this.unit;
	if (this.isdebuff == 1) then
		GameTooltip:SetUnitDebuff(unit, this:GetID());
	else
		GameTooltip:SetUnitBuff(unit, this:GetID());
	end
end

function Nurfed_HudOnEvent(event)
	if (event == "PLAYER_ENTERING_WORLD") then
		combatmode = false;
		if (UnitExists("pet")) then 
			petmode = true;
			Nurfed_PetHud:Show();
			Nurfed_PetHudBG:Show();
			Nurfed_TargetHudMP:Hide();
			Nurfed_TargetHudMPBG:Hide();
		end
		this:SetAlpha(0.0);
		Nurfed_HealthHud:SetVertexColor(1, 1, 1);
		Nurfed_HealthHudBG:SetVertexColor(0, 0, 0);

		Nurfed_HealthHud:SetAlpha(1.0);			-- Player HUD 선명도를 설정
		Nurfed_HealthHudBG:SetAlpha(0.8);          
		Nurfed_HealthHudBG:SetTexCoord(0, 1, 0, 1);

		Nurfed_ManaHud:SetAlpha(1.0);
		Nurfed_ManaHudBG:SetAlpha(0.8);
		Nurfed_ManaHudBG:SetTexCoord(0, 1, 0, 1);

		if (UnitPowerType("player") == 0) then
			info = { r = 0.00, g = 1.00, b = 1.00 };
		else
			info = ManaBarColor[UnitPowerType("player")];
		end
		Nurfed_ManaHud:SetVertexColor(info.r, info.g, info.b);
		Nurfed_ManaHudBG:SetVertexColor(0, 0, 0);
		
		local p=UnitMana("player")/UnitManaMax("player");
		local h = 256 * p;
		Nurfed_ManaHud:SetHeight(h);
		Nurfed_ManaHud:SetTexCoord(0, 1, 1-p, 1);
		Nurfed_HudManaText:SetText(UnitMana("player").."/"..UnitManaMax("player"));
		Nurfed_HudManaText:SetVertexColor(info.r-0.35, info.g-0.35, info.b-0.35);

		p=UnitHealth("player")/UnitHealthMax("player");
		h = 256 * p;
		Nurfed_HealthHud:SetHeight(h);
		Nurfed_HealthHud:SetTexCoord(0, 1, 1-p, 1);
		Nurfed_HudHealthText:SetText(UnitHealth("player").."/"..UnitHealthMax("player"));
		Nurfed_HudHealthText:SetVertexColor(0, 1-0.35, 0);
	elseif (event == "PLAYER_REGEN_ENABLED") then
		combatmode = false;
		this:SetAlpha(0.0);
	elseif (event == "PLAYER_REGEN_DISABLED") then
		combatmode = true;
		this:SetAlpha(1.0);
		Nurfed_HealthHud:SetVertexColor(1, 1, 1);
		Nurfed_HealthHudBG:SetVertexColor(0, 0, 0);

		Nurfed_HealthHud:SetAlpha(1.0);			-- Player HUD 선명도를 설정
		Nurfed_HealthHudBG:SetAlpha(0.8);          
		Nurfed_HealthHudBG:SetTexCoord(0, 1, 0, 1);

		Nurfed_ManaHud:SetAlpha(1.0);
		Nurfed_ManaHudBG:SetAlpha(0.8);
		Nurfed_ManaHudBG:SetTexCoord(0, 1, 0, 1);

		if (UnitPowerType("player") == 0) then
			info = { r = 0.00, g = 1.00, b = 1.00 };
		else
			info = ManaBarColor[UnitPowerType("player")];
		end
		Nurfed_ManaHud:SetVertexColor(info.r, info.g, info.b);
		Nurfed_ManaHudBG:SetVertexColor(0, 0, 0);
		
		local p=UnitMana("player")/UnitManaMax("player");
		local h = 256 * p;
		Nurfed_ManaHud:SetHeight(h);
		Nurfed_ManaHud:SetTexCoord(0, 1, 1-p, 1);
		Nurfed_HudManaText:SetText(UnitMana("player").."/"..UnitManaMax("player"));
		Nurfed_HudManaText:SetVertexColor(info.r-0.35, info.g-0.35, info.b-0.35);

		p=UnitHealth("player")/UnitHealthMax("player");
		h = 256 * p;
		Nurfed_HealthHud:SetHeight(h);
		Nurfed_HealthHud:SetTexCoord(0, 1, 1-p, 1);
		Nurfed_HudHealthText:SetText(UnitHealth("player").."/"..UnitHealthMax("player"));
		Nurfed_HudHealthText:SetVertexColor(0, 1-0.35, 0);
	elseif (event == "UNIT_DISPLAYPOWER") then
		local info = {};
		if (arg1 == "player" or arg1 == "target") then
			if (UnitPowerType(arg1) == 0) then
				info = { r = 0.00, g = 1.00, b = 1.00 };
			else
				info = ManaBarColor[UnitPowerType(arg1)];
			end
			if (arg1 == "player") then
				Nurfed_ManaHud:SetVertexColor(info.r, info.g, info.b);
				Nurfed_ManaHudBG:SetVertexColor(info.r, info.g, info.b);
			else
				Nurfed_TargetHudMPText:SetTextColor(info.r+0.7, info.g-0.3, info.b-0.1);
			end
		end
	elseif (event == "PLAYER_COMBO_POINTS") then
		local points = GetComboPoints();
		if (points > 0) then
			Nurfed_HudCombo:SetText(points);
		else
			Nurfed_HudCombo:SetText("");
		end
	elseif (event == "UNIT_AURA" and arg1 == "target") then
		Nurfed_HudTargetAuras();
	elseif (event == "UNIT_HEALTH" or event == "UNIT_MAXHEALTH") then
		if (arg1=="player") then
			if UnitHealthMax("player")==0 then return; end
			local p=UnitHealth("player")/UnitHealthMax("player");
			local h = 256 * p;
			Nurfed_HealthHud:SetHeight(h);
			Nurfed_HealthHud:SetTexCoord(0, 1, 1-p, 1);
			Nurfed_HudHealthText:SetText(UnitHealth("player").."/"..UnitHealthMax("player"));

		elseif (arg1 == "target") then
			local p=UnitHealth("target")/UnitHealthMax("target");
			local h = 236 * p;
			Nurfed_TargetHudLayer:SetHeight(h);
			Nurfed_TargetHudLayer:SetTexCoord(0, 1, 1-p, 1);
			Nurfed_HudMobHealth();
			Nurfed_TargetHudHPPerc:SetText(ceil((UnitHealth("target") / UnitHealthMax("target")) * 100).."%");

		elseif (arg1 == "pet") then
			--if UnitHealthMax("pet")==0 then return; end
			local p=UnitHealth("pet")/UnitHealthMax("pet");
			local h = 236 * p;
			Nurfed_PetHud:SetHeight(h);
			Nurfed_PetHud:SetTexCoord(0, 1, 1-p, 1);
		end
	elseif (event == "UNIT_PET") then

		if (UnitExists("pet")) then
			petmode = true;
			Nurfed_PetHud:Show();
			Nurfed_PetHudBG:Show();
			Nurfed_TargetHudMP:Hide();
			Nurfed_TargetHudMPBG:Hide();

			Nurfed_PetHud:SetVertexColor(1, 0.8, 0.8);
			Nurfed_PetHudBG:SetVertexColor(0, 0, 0);

			Nurfed_PetHud:SetAlpha(1.0);			-- Pet HUD의 선명도 설정
			Nurfed_PetHudBG:SetAlpha(0.8);
			Nurfed_PetHudBG:SetTexCoord(0, 1, 0, 1);
		else
			petmode = false;
			Nurfed_PetHud:Hide();
			Nurfed_PetHudBG:Hide();	
			Nurfed_TargetHudMP:Show();
			Nurfed_TargetHudMPBG:Show();
		end

	else
		if (arg1=="player") then
			if UnitManaMax("player")==0 then return; end
			local p=UnitMana("player")/UnitManaMax("player");
			local h = 256 * p;
			Nurfed_ManaHud:SetHeight(h);
			Nurfed_ManaHud:SetTexCoord(0, 1, 1-p, 1);
			Nurfed_HudManaText:SetText(UnitMana("player").."/"..UnitManaMax("player"));
		elseif (arg1 == "target") then
			if UnitManaMax("target")==0 then return; end	
			if (petmode == false) then
				local p=UnitMana("target")/UnitManaMax("target");
				local h = 236 * p;
				Nurfed_TargetHudMP:SetHeight(h);
				Nurfed_TargetHudMP:SetTexCoord(0, 1, 1-p, 1);
			end
			Nurfed_TargetHudMPText:SetText(UnitMana("target").."/"..UnitManaMax("target"));
		end
	end
end

function Nurfed_HudMobHealth()
	local targethealth = UnitHealth("target");
	local targethealthmax = UnitHealthMax("target");
	if (MobHealthFrame) then
		MobHealthFrame:Hide();
		local index;

		if UnitIsPlayer("target") then
			index = UnitName("target");
		else
			index = UnitName("target")..":"..UnitLevel("target");
		end

		if ((MobHealthDB and MobHealthDB[index]) or (MobHealthPlayerDB and MobHealthPlayerDB[index])) then
			local s, e;
			local pts;
			local pct;

			if MobHealthDB[index] then
				if (type(MobHealthDB[index]) ~= "string") then
					Nurfed_TargetHudHPText:SetText(targethealth.."/"..targethealthmax);
				end
				s, e, pts, pct = string.find(MobHealthDB[index], "^(%d+)/(%d+)$");
			else
				if (type(MobHealthPlayerDB[index]) ~= "string") then
					Nurfed_TargetHudHPText:SetText(targethealth.."/"..targethealthmax);
				end
				s, e, pts, pct = string.find(MobHealthPlayerDB[index], "^(%d+)/(%d+)$");
			end

			if (pts and pct) then
				pts = pts + 0;
				pct = pct + 0;
				if (pct ~= 0) then
					pointsPerPct = pts / pct;
				else
					pointsPerPct = 0;
				end
			end

			local currentPct = UnitHealth("target");
			
			if (pointsPerPct > 0) then
				Nurfed_TargetHudHPText:SetText(string.format("%d", (currentPct * pointsPerPct) + 0.5).."/"..string.format("%d", (100 * pointsPerPct) + 0.5));
			end
		else
			Nurfed_TargetHudHPText:SetText(targethealth.."/"..targethealthmax);
		end
	else
		Nurfed_TargetHudHPText:SetText(targethealth.."/"..targethealthmax);
	end
end
