BINDING_NAME_TBTOGGLE		=	"버튼정리 미니맵 토글"

ToolsBar = {
	Version = "2.21",
	Button = {
		Micro = {	CharacterMicroButton, SpellbookMicroButton, TalentMicroButton, QuestLogMicroButton,
				SocialsMicroButton, LFGMicroButton, MainMenuMicroButton, HelpMicroButton	},
		Bag = {	MainMenuBarBackpackButton, CharacterBag0Slot, CharacterBag1Slot, CharacterBag2Slot, CharacterBag3Slot	},
		Blz = {	"BonusActionButton", "ActionButton", "MultiBarBottomLeftButton", "MultiBarBottomRightButton",
				"MultiBarLeftButton", "MultiBarRightButton"}
	},
	Sort = {
		Micro = {	[1] = {Point = {2, 8, 4, 6}, Gap = {-15, 0, -22, 0}},
				[2] = {Point = {8, 2, 4, 6}, Gap = {-15, 22, 22, 0}},
				[3] = {Point = {6, 4, 8, 2}, Gap = {0, 28, 0, 22}},
				[4] = {Point = {4, 6, 8, 2}, Gap = {0, 28, 0, 22}}
		},
		Bag = {	[1] = {Point = {2, 8, 6, 4}, Gap = {0, 0, 0, 3}},
				[2] = {Point = {8, 2, 6, 4}, Gap = {0, 0, 0, -3}},
				[3] = {Point = {6, 4, 4, 6}, Gap = {-25, 0, -3, 0}},
				[4] = {Point = {4, 6, 6, 4}, Gap = {25, 0, 3, 0}}
		}
	}
}
CreateMinimapButton({
	name = "ToolsBarMinimap",
	texture = "Interface\\Icons\\INV_Misc_Bag_08.blp",
	tooltip = "",
	script = {
		OnClick = function ()
			if (arg1 == "LeftButton") then
				if IsAltKeyDown() then
					ToolsDropdownOnClick("ToolsBarMinimap", ToolsBarMinimap)
				else
					ToolsBarMicroFrame:Hide()
					if (ToolsBarBagFrame:IsShown()) then
						ToolsBarBagFrame:Hide()
					else
						ToolsBarBagFrame:Show()
					end
				end
			elseif (arg1 == "RightButton") then
				ToolsBarBagFrame:Hide()
				if (ToolsBarMicroFrame:IsShown()) then
					ToolsBarMicroFrame:Hide()
				else
					ToolsBarMicroFrame:Show()
				end
			end
		end}
})
ToolsEventReg("ToolsBarEvent",
	{"PLAYER_ENTERING_WORLD", "VARIABLES_LOADED", "SPELLS_CHANGED"},
	
	function ()
	    if event == "VARIABLES_LOADED" then
		if not (ToolsBarDB) then
			local failed = nil
			ChatFrame1:AddMessage("Tool's Bar : "..ToolsBar.Version.." 최초실행")
			if IsAddOnLoadOnDemand("ToolsBar_Option") then
				LoadAddOn("ToolsBar_Option")
				if IsAddOnLoaded("ToolsBar_Option") then
					ToolsBarDefault()
				else
					failed = 0
				end
			else
				failed = 1
			end
			if (failed) then
				this:UnregisterEvent("VARIABLES_LOADED")
				this:UnregisterEvent("PLAYER_ENTERING_WORLD")
				this:UnregisterEvent("SPELLS_CHANGED")
				this:UnregisterEvent("UPDATE_BONUS_ACTIONBAR")
				if failed == 0 then
					ChatFrame1:AddMessage("Tool's Bar : 외부 인터페이스에서 옵션을 선택후에 재접속 하시기 바랍니다", 1, .4 ,.4)
				else
					ChatFrame1:AddMessage("Tool's Bar : 옵션이 설치되어 있지 않아 작동하지 않습니다", 1, 0.4, 0.4)
					ChatFrame1:AddMessage("Tool's Bar : 옵션을 설치후에 이용하세요", 1, 0.4, 0.4)
				end
				ToolsBarMinimap:Hide()
				return
			end
		end
		Tools_SetPoint(MainMenuBar, 2, 0, 2, 0, -1000)
		ToolsBar:HideButton()
		ToolsBar:OnLoad()
	    elseif event == "PLAYER_ENTERING_WORLD" then
		ToolsBar:SetTextColor()
		ToolsBar:InitButton()
		for i = 1, 14 do
			ToolsBar:SetScale(i)
			ToolsBar:UpdateFramePoint(i)
		end
		ToolsBar:SetShapeshiftBar()
		this:UnregisterEvent(event)

		--{{ 테스트용 }}
		--LoadAddOn("ToolsBar_Option")
		--ToolsBar_OptionFrame:Show()

	    elseif event == "SPELLS_CHANGED" then
		if ToolsBarDB[13].Col == GetNumShapeshiftForms() then return end
		ToolsBarDB[13].Col = GetNumShapeshiftForms()
		ToolsBar:SetBorderSize(13)
	    end
	end)
-- ** 버튼 위치 / 배경 / 색상 / 크기 불러오기 **
function ToolsBar:OnLoad()
	for i = 1, 14 do
		self:CreateFrame(i)
		self:SetGroupButton(i)
		self:SetBorder(i)
		self:SetBorderSize(i)
		self:SetBorderColor(i)
		self:SetBorderShow(i)
	end
	self:SetBagButton()
	self:SetMicroButton()
end
-- ** 배경 프레임 제작 **
function ToolsBar:CreateFrame(id)
	local f = CreateFrame("Frame", "ToolsBarGroup"..id, (id == 13) and ShapeshiftBarFrame or (id == 14) and PetActionBarFrame or UIParent, "SecureFrameTemplate")
	f:SetClampedToScreen(1)
	f:SetID(id)
	f:SetMovable(1)
	ToolsEventReg(f, "CVAR_UPDATE",	function()
		if arg1 == "USE_UISCALE" then
			ToolsTimer("TBARSCALE"..id, { time = 1, func = function() ToolsBar:SetScale(id) end })
		end
	end)
end
-- ** 버튼 테두리 변경 / 버튼 폰트 변경 **
function ToolsBar:InitButton()
	for i = 1, getn(self.Button.Blz) do
		for j = 1, 12 do
			local b = self.Button.Blz[i]..j
			if (getglobal(b)) then
				getglobal(b):SetFrameStrata("LOW")
				getglobal(b.."HotKey"):SetFontObject("ToolsBarHotkeyFont")
				getglobal(b.."Name"):SetFontObject("ToolsBarHotkeyFont")
				getglobal(b.."Count"):SetFontObject("ToolsBarHotkeyFont")
			end
		end
	end
	for i = 1, 14 do
		ToolsBar:SetButtonOverlayTexture(i)
	end
end
-- ** 버튼 텍스트 색상 변경 **
function ToolsBar:SetTextColor()
	HOTKEY_TEXT_COLOR = ToolsBarDB.Color.Hotkey
	for i = 1, getn(self.Button.Blz) do
		for j = 1, 12 do
			getglobal(self.Button.Blz[i]..j.."Name"):SetTextColor(unpack(ToolsBarDB.Color.Name))
			getglobal(self.Button.Blz[i]..j.."Count"):SetTextColor(unpack(ToolsBarDB.Color.Count))
		end
	end
end
-- ** 버튼의 배열방식 설정 (아래 / 위) **
function ToolsBar:FlipCheck(i)
	if (ToolsBarDB[i].Flip) then
		return {1, 2, 8, ToolsBarDB[i].GapButton, ToolsBarDB[i].GapBorder}
	else
		return {7, 8, 2, -ToolsBarDB[i].GapButton, -ToolsBarDB[i].GapBorder}
	end
end
-- ** 버튼의 이름 가져오기 **
function ToolsBar:ButtonCheck(i, j)
	j = j or 0
	if (i <= 12) then return getglobal("ActionButton"..i-j)
	elseif (i <= 24) then return getglobal("MultiBarBottomLeftButton"..i-12-j)
	elseif (i <= 36) then return getglobal("MultiBarBottomRightButton"..i-24-j)
	elseif (i <= 48) then return getglobal("MultiBarRightButton"..i-36-j)
	else return getglobal("MultiBarLeftButton"..i-48-j)
	end
end
-- ** 버튼의 기분 버튼 가져오기 **
function ToolsBar:ParentCheck(i, j)
	if (i == 13) then return ActionButton12
	elseif (i == 25) then return MultiBarBottomLeftButton12
	elseif (i == 37) then return MultiBarBottomRightButton12
	elseif (i == 49) then return MultiBarRightButton12
	else return self:ButtonCheck(i, 1)
	end
end
-- ** 사용하지 않는 버튼 숨기기 **
function ToolsBar:HideButton()
	for i = ToolsBarDB.Total+1, 60 do
		Tools_SetPoint(self:ButtonCheck(i), 8, 0,  2, 0, -1000)
	end
end
-- ** 태세전환 숨김 설정 **
function ToolsBar:SetShapeshiftBar()
	if ToolsBarDB.HideShapeshiftBar then
		ToolsBarGroup13:SetClampedToScreen(0)
		ToolsBarEvent:UnregisterEvent("SPELLS_CHANGED")
		Tools_SetPoint(ToolsBarGroup13, 8,0,2,0,-1000)
	else
		ToolsBarGroup13:SetClampedToScreen(1)
		ToolsBarEvent:RegisterEvent("SPELLS_CHANGED")
		ToolsBarDB[13].Col = GetNumShapeshiftForms()
		self:SetGroupButton(13)
		self:SetBorder(13)
		self:SetBorderSize(13)
		self:SetBorderColor(13)
		self:SetBorderShow(13)
	end
end
-- ** 버튼 정렬 부분 **
function ToolsBar:SetGroupButton(id)

	if id <= 12 and (ToolsBarDB[id].Col == 0) then return end

	if id <= 12 then		-- [액션바]
		if not (ToolsBarDB[id].ID) then return end
		local flip = self:FlipCheck(id)
		for i = ToolsBarDB[id].ID.Start, ToolsBarDB[id].ID.Last do
			if i == ToolsBarDB[id].ID.Start then
				Tools_SetPoint(self:ButtonCheck(i), flip[1], getglobal("ToolsBarGroup"..id), flip[1], ToolsBarDB[id].GapBorder, flip[5])
			else
				Tools_SetPoint(self:ButtonCheck(i), 4, self:ParentCheck(i), 6, ToolsBarDB[id].GapButton, 0)
			end
			if i <= 12 then
				getglobal("BonusActionButton"..i):SetAllPoints(getglobal("ActionButton"..i))
			end
		end
		for i = ToolsBarDB[id].ID.Start, ToolsBarDB[id].ID.Last do
			i = i + ToolsBarDB[id].Col
			j = i - ToolsBarDB[id].Col
			if i > ToolsBarDB[id].ID.Last then break end
			Tools_SetPoint(self:ButtonCheck(i), flip[2], self:ButtonCheck(j), flip[3], 0, flip[4])
			i = i - 1
		end
	elseif id == 13 then	-- [태세전환]
		for i = 1, 10 do
			if i == 1 then
				Tools_SetPoint(getglobal("ShapeshiftButton"..i), 7, getglobal("ToolsBarGroup"..id), 7, ToolsBarDB[id].GapBorder, -ToolsBarDB[id].GapBorder)
			else
				Tools_SetPoint(getglobal("ShapeshiftButton"..i), 4, getglobal("ShapeshiftButton"..i-1), 6, ToolsBarDB[id].GapButton, 0)
			end
		end
	elseif id == 14 then	-- [소환수]
		local mode = ToolsBarDB.PetCompactMode and 4 or 1
		for i = 1, 10 do
			if i < mode then
				Tools_SetPoint(getglobal("PetActionButton"..i), 2, 0, 8, 0, 1000)
			elseif i == mode then
				Tools_SetPoint(getglobal("PetActionButton"..i), 7, getglobal("ToolsBarGroup"..id), 7, ToolsBarDB[id].GapBorder, -ToolsBarDB[id].GapBorder)
			else
				Tools_SetPoint(getglobal("PetActionButton"..i), 4, getglobal("PetActionButton"..i-1), 6, ToolsBarDB[id].GapButton, 0)
			end
		end
	end
	
end
-- ** 보더 그리기 **
function ToolsBar:SetBorder(id)
	Tools_SetBackdrop("ToolsBarGroup"..id, ToolsBarDB[id].Thickness, 4, "BACKGROUND", ToolsBarDB[id].Border)
end
-- ** 보더 크기 계산 **
function ToolsBar:SetBorderSize(id)
	local size = (id <= 12) and 36 or 30
	Tools_SetSize("ToolsBarGroup"..id, 
		(size*ToolsBarDB[id].Col)+(ToolsBarDB[id].GapButton*(ToolsBarDB[id].Col-1))+(ToolsBarDB[id].GapBorder*2),
		(size*ToolsBarDB[id].Row)+(ToolsBarDB[id].GapButton*(ToolsBarDB[id].Row-1))+(ToolsBarDB[id].GapBorder*2))
end
-- ** 보더 색상 설정 **
function ToolsBar:SetBorderColor(id)
	getglobal("ToolsBarGroup"..id):SetBackdropBorderColor(unpack(ToolsBarDB[id].ColorBorder))
	getglobal("ToolsBarGroup"..id):SetBackdropColor(unpack(ToolsBarDB[id].ColorBackdrop))
end
-- ** 보더 보이기 설정 **
function ToolsBar:SetBorderShow(id)
	if (ToolsBarDB[id].Show) and ToolsBarDB[id].Col ~= 0 then
		getglobal("ToolsBarGroup"..id):Show()
	else
		getglobal("ToolsBarGroup"..id):Hide()
	end
end
-- ** 스케일 설정 **
function ToolsBar:SetScale(id)
	local scale = ToolsBarDB[id].Scale/UIParent:GetScale()
	
	if id <= 12 then
		getglobal("ToolsBarGroup"..id):SetScale(scale)
		if (ToolsBarDB[id].ID) then
			for i = ToolsBarDB[id].ID.Start, ToolsBarDB[id].ID.Last do
				self:ButtonCheck(i):SetScale(scale)
				if i <=12 then
					getglobal("BonusActionButton"..i):SetScale(scale)
				end
			end
		end
	elseif id == 13 then
		ShapeshiftBarFrame:SetScale(scale)
	elseif id == 14 then
		PetActionBarFrame:SetScale(scale)
	end
end
-- ** 버튼 테두리 변경 **
function ToolsBar:SetButtonOverlayTexture(id)
	if not (ToolsCommonButton) then return end

	if id <= 12 then
		if not ToolsBarDB[id].ID then return end
		for i = ToolsBarDB[id].ID.Start, ToolsBarDB[id].ID.Last do
			ToolsCommonButton:SetButtonTexture(self:ButtonCheck(i):GetName(), ToolsBarDB[id].Overlay)
			if i <= 12 then
				ToolsCommonButton:SetButtonTexture("BonusActionButton"..i, ToolsBarDB[id].Overlay)
			end
		end
		return
	else
		for i = 1, 10 do
			ToolsCommonButton:SetButtonTexture((id == 13) and "ShapeshiftButton"..i or "PetActionButton"..i, ToolsBarDB[id].Overlay)
		end
	end
end
-- ** 가방 / 메뉴 부모 프레임 설정 **
function ToolsBar:CreateHideButtonParent(frame)
	if (getglobal(frame)) then return end
	CreateFrame("Frame", frame, UIParent):Hide()
	tinsert(UISpecialFrames, frame)
end
-- ** 가방 설정 **
function ToolsBar:SetBagButton()
	self:CreateHideButtonParent("ToolsBarBagFrame")
	KeyRingButton:SetParent(ToolsBarBagFrame)
	KeyRingButton:Show()
	Tools_SetPoint(	KeyRingButton,
				self.Sort.Bag[ToolsBarDB.Sort.Bag].Point[3],
				self.Button.Bag[1],
				self.Sort.Bag[ToolsBarDB.Sort.Bag].Point[4], 0, 0)
	ToolsBarBagFrame:SetScale(0.75)
	for i = 1, getn(self.Button.Bag) do
		self.Button.Bag[i]:SetParent(ToolsBarBagFrame)
		if i == 1 then
			Tools_SetPoint(	self.Button.Bag[1], 
						self.Sort.Bag[ToolsBarDB.Sort.Bag].Point[1], ToolsBarMinimap, 
						self.Sort.Bag[ToolsBarDB.Sort.Bag].Point[2],
						self.Sort.Bag[ToolsBarDB.Sort.Bag].Gap[1],
						self.Sort.Bag[ToolsBarDB.Sort.Bag].Gap[2])
		else
			Tools_SetPoint(	self.Button.Bag[i], 
						self.Sort.Bag[ToolsBarDB.Sort.Bag].Point[1],
						self.Button.Bag[i-1],
						self.Sort.Bag[ToolsBarDB.Sort.Bag].Point[2],
						self.Sort.Bag[ToolsBarDB.Sort.Bag].Gap[3],
						self.Sort.Bag[ToolsBarDB.Sort.Bag].Gap[4])
		end
	end

end
-- ** 메뉴 설정 **
function ToolsBar:SetMicroButton()
	self:CreateHideButtonParent("ToolsBarMicroFrame")
	ToolsBarMicroFrame:SetScale(0.75)
	for i = 1, 8 do
		self.Button.Micro[i]:SetParent(ToolsBarMicroFrame)
		if i == 1 then
			Tools_SetPoint(	self.Button.Micro[i],
						self.Sort.Micro[ToolsBarDB.Sort.Micro].Point[1], ToolsBarMinimap, 
						self.Sort.Micro[ToolsBarDB.Sort.Micro].Point[2],
						self.Sort.Micro[ToolsBarDB.Sort.Micro].Gap[1],
						self.Sort.Micro[ToolsBarDB.Sort.Micro].Gap[2])
		elseif i == 5 then
			Tools_SetPoint(	self.Button.Micro[i],
						self.Sort.Micro[ToolsBarDB.Sort.Micro].Point[3], self.Button.Micro[1], 
						self.Sort.Micro[ToolsBarDB.Sort.Micro].Point[4], 0,
						self.Sort.Micro[ToolsBarDB.Sort.Micro].Gap[4])
		else
			Tools_SetPoint(	self.Button.Micro[i],
						self.Sort.Micro[ToolsBarDB.Sort.Micro].Point[1], self.Button.Micro[i-1], 
						self.Sort.Micro[ToolsBarDB.Sort.Micro].Point[2], 0,
						self.Sort.Micro[ToolsBarDB.Sort.Micro].Gap[3])
		end
	end
end
-- ** 보더 위치 설정 **
function ToolsBar:UpdateFramePoint(id)
	local s = getglobal("ToolsBarGroup"..id):GetEffectiveScale()
	
	if not (ToolsBarDB[id].Anchor) then
		ToolsBarDB[id].Anchor = 1
		ToolsBarDB[id].Ypoint = (ToolsBarDB[id].Ypoint - getglobal("ToolsBarGroup"..id):GetHeight())
	end
	Tools_SetPoint(getglobal("ToolsBarGroup"..id), ToolsBarDB[id].Anchor, 0, ToolsBarDB[id].Anchor, ToolsBarDB[id].Xpoint / s, ToolsBarDB[id].Ypoint / s)
	
	--Tools_SetPoint(getglobal("ToolsBarGroup"..id), 7, 0, 1, ToolsBarDB[id].Xpoint / s, ToolsBarDB[id].Ypoint / s)
end