HOTKEY_TEXT_COLOR = HOTKEY_TEXT_COLOR or {1, 1, 1}

-- 특성버튼 위치 변경 고정 삭제
function UpdateTalentButton() end
TalentMicroButton:SetScript("OnUpdate", function()
	if ( UnitLevel("player") < 10 ) then
		this:Disable()
	else
		this:Enable()
		this:SetScript("OnUpdate", nil)
	end
end)

-- 거리에 따른 아이콘 색상 변경에 따른 기능 추가
function TB_ActionButton_OnUpdate(elapsed)
	local hotkey = getglobal(this:GetName().."HotKey")
	local button = ActionButton_GetPagedID(this)

	if ( hotkey:GetText() == RANGE_INDICATOR ) then
		if ( ToolsBarDB ) then
			if (ToolsBarDB.RangeColor) then
				hotkey:Hide()
			else
				if ( IsActionInRange(button) == 1 ) then
					hotkey:Hide();
				else
					hotkey:Show();
				end
			end
		else
			if ( IsActionInRange(button) == 1 ) then
				hotkey:Hide();
			else
				hotkey:Show();
			end
		end
	end

	if ( ActionButton_IsFlashing() ) then
		this.flashtime = this.flashtime - elapsed;
		if ( this.flashtime <= 0 ) then
			local overtime = -this.flashtime;
			if ( overtime >= ATTACK_BUTTON_FLASH_TIME ) then
				overtime = 0;
			end
			this.flashtime = ATTACK_BUTTON_FLASH_TIME - overtime;

			local flashTexture = getglobal(this:GetName().."Flash");
			if ( flashTexture:IsVisible() ) then
				flashTexture:Hide();
			else
				flashTexture:Show();
			end
		end
	end

	-- Handle range indicator
	if ( this.rangeTimer ) then
		this.rangeTimer = this.rangeTimer - elapsed;
		if ( this.rangeTimer <= 0 ) then
			if ( IsActionInRange(button) == 0 ) then
				hotkey:SetVertexColor(1, .1, .1)
			else
				-- 기본 색상값 회색에서 사용자정의로 변경
				hotkey:SetVertexColor(unpack(HOTKEY_TEXT_COLOR))
			end
			this.rangeTimer = TOOLTIP_UPDATE_TIME;
		end
	end

	ActionButton_UpdateUsable()

	if ( not this.updateTooltip ) then
		return;
	end

	this.updateTooltip = this.updateTooltip - elapsed;
	if ( this.updateTooltip > 0 ) then
		return;
	end

	if ( GameTooltip:IsOwned(this) ) then
		ActionButton_SetTooltip();
	else
		this.updateTooltip = nil;
	end
end

function TB_ActionButton_UpdateUsable()
	local icon = getglobal(this:GetName().."Icon")
	local normalTexture = getglobal(this:GetName().."NormalTexture")
	local isUsable, notEnoughMana = IsUsableAction(ActionButton_GetPagedID(this))
-- 거리에 따른 색상 추가
	if (ToolsBarDB) then
		if (ToolsBarDB.RangeColor) then
			if (IsActionInRange(ActionButton_GetPagedID(this)) == 0) then
				if ( isUsable ) then
					icon:SetVertexColor(1.0, 0.5, 0.5)   --<---- 거리가 멀고, 사용 가능한 경우 색을 엷게
				elseif ( notEnoughMana ) then
					icon:SetVertexColor(0.5, 0.3, 0.3)   --<---- 거리가 멀고, 마나가 부족할때 색을 어둡게
				else
					icon:SetVertexColor(0.5, 0.3, 0.3)   --<---- 거리가 멀고, 마나는 있지만 사용조건이 안맞을경우 색을 어둡게(ex, 제압/복수/반격)
				end
				return
			end
		end
	end
	if ( isUsable ) then
		icon:SetVertexColor(1.0, 1.0, 1.0)
	elseif ( notEnoughMana ) then
		icon:SetVertexColor(0.5, 0.5, 1.0)
	else
		icon:SetVertexColor(0.4, 0.4, 0.4)
	end
end

-- 거리 판별 단축키 위치 고정 제거
function TB_ActionButton_UpdateHotkeys(actionButtonType)
     if ( not actionButtonType ) then
        actionButtonType = "ACTIONBUTTON";
    end
    local hotkey = getglobal(this:GetName().."HotKey");
    local button = ActionButton_GetPagedID(this);
    local key = GetBindingKey(actionButtonType..this:GetID()) or
                GetBindingKey("CLICK "..this:GetName()..":LeftButton");

    if ( GetBindingText(key, "KEY_", 1) == "" ) then
        if ( not HasAction(button) ) then
            hotkey:SetText("");
        elseif ( ActionHasRange(button) ) then
            if ( IsActionInRange(button) ) then
                hotkey:SetText(RANGE_INDICATOR);
                --hotkey:SetTextHeight(8);
                --hotkey:SetPoint("TOPRIGHT", this:GetName(), "TOPRIGHT", -3, 5);
            else
                hotkey:SetText("");
            end
        end
    else
       -- hotkey:SetText(GetBindingText(key, "KEY_", 1))
	local text = GetBindingText(key, "KEY_", 1)
	text = string.gsub(text, "마우스 가운데 버튼", "M3")
	text = string.gsub(text, "4번 마우스 버튼", "M4")
	text = string.gsub(text, "5번 마우스 버튼", "M5")
	text = string.gsub(text, "마우스 휠 아래로", (ToolsBarDB) and (ToolsBarDB.Arrow and "▼") or "Wd")
	text = string.gsub(text, "마우스 휠 위로", (ToolsBarDB) and (ToolsBarDB.Arrow and "▲") or "Wu")
	text = string.gsub(text, "숫자패드% ", "n-")
	text = string.gsub(text, "스페이스 바", "Sp")
	text = string.gsub(text, "Backspace", "Bs")
	text = string.gsub(text, "Page Up", "pU")
	text = string.gsub(text, "Page Down", "pD")
	text = string.gsub(text, "Home", "Hm")
	text = string.gsub(text, "Insert", "In")
	text = string.gsub(text, "Delete", "Dl")
	text = string.gsub(text, "End", "Ed")
	hotkey:SetText(text) 
    end
end

backup_ActionButton_UpdateHotkeys = ActionButton_UpdateHotkeys
backup_ActionButton_UpdateUsable = ActionButton_UpdateUsable
backup_ActionButton_OnUpdate = ActionButton_OnUpdate

ActionButton_UpdateHotkeys = TB_ActionButton_UpdateHotkeys
ActionButton_UpdateUsable = TB_ActionButton_UpdateUsable
ActionButton_OnUpdate = TB_ActionButton_OnUpdate

--[[
hooksecurefunc("ActionButton_UpdateHotkeys", TB_ActionButton_UpdateHotkeys)
hooksecurefunc("ActionButton_UpdateUsable", TB_ActionButton_UpdateUsable)
hooksecurefunc("ActionButton_OnUpdate", TB_ActionButton_OnUpdate)
]]
